#ifndef BUTTONGROUP
#define BUTTONGROUP

#include "Button.h"
#include "GroupBox.h"
#include <qbttngrp.h>

class ButtonGroup : public GroupBox
{
  Q_OBJECT;
public:

  ButtonGroup (Widget* parent=0, const char* name=0); 
  ButtonGroup (const char* title, Widget* parent=0, const char* name=0);
  ~ButtonGroup ();
  bool isExclusive () const; 
  void setExclusive (bool);
  int insert (Button*, int id=-1); 
  void remove (Button*);
  Button* find (int id) const; 

  int  count();  
  void setButtonState(int id, int state);
  
protected:
  void setWidget(QButtonGroup *bg);

private slots:
  //Signals
  void pressed (int id);
  void released (int id); 
  void clicked (int id);

private:
  QButtonGroup *buttongroup;
};
#endif
