#include "Widget.h"
#include "Frame.h"

Frame::Frame(char *abstractframevariable)
  : Widget("")
{
}


Frame::Frame(Widget *parent, const char *name)
  : Widget("")
{
  if(parent)
    {
      frame = new QFrame(parent->widget,name);
    }
  else
    {
      frame = new QFrame(NULL,name);
    }

  setWidget(frame);
}

Frame::~Frame()
{
}

void Frame::setWidget(QFrame *widget)
{
  frame = widget;
  Widget::setWidget((QWidget*)frame);
}

int Frame::frameStyle()
{
  return frame->frameStyle();
}

int Frame::frameShape()
{
  return frame->frameShape();
}

int Frame::frameShadow()
{
  return frame->frameShadow();
}

void Frame::setFrameStyle(int s)
{
  frame->setFrameStyle(s);
}

bool Frame::lineShapesOk()
{
  return frame->lineShapesOk();
}

int Frame::lineWidth()
{
  return frame->lineWidth();
}

void Frame::setLineWidth(int w)
{
  frame->setLineWidth(w);
}

int Frame::midLineWidth()
{
  return frame->midLineWidth();
}

void Frame::setMidLineWidth(int w)
{
  frame->setMidLineWidth(w);
}

int Frame::frameWidth()
{
  return frame->frameWidth();
}

QRect Frame::frameRect() const
{
  return frame->frameRect();
}

QRect Frame::contentsRect() const
{
  return frame->contentsRect();
}
