#ifndef TABDIALOG_H
#define TABDIALOG_H

#include <qtabdlg.h>
#include "Dialog.h"

class TabDialog : public Dialog
{
Q_OBJECT;
public:
  TabDialog(Widget *parent=0, const char *name=0, int modal=0);
  ~TabDialog();

  virtual void show();
  virtual void setFont(const QFont& font);
  void addTab(Widget *w, const char *name);
  bool isTabEnabled(const char* name);
  void setDefaultButton(const char* text = "Defaults");
  bool hasDefaultButton() const;
  void setCancelButton(const char* text = "Cancel");
  bool hasCancelButton() const;
  void setApplyButton(const char *text = "Apply");
  bool hasApplyButton() const;
  void setOKButton(const char* text = "OK");

  //SIGNALS
public slots:
  void aboutToShow();
  void applyButtonPressed();
  void cancelButtonPressed();
  void defaultButtonPressed();

public:
  virtual void setWidget(QTabDialog *td);
  QTabDialog *tabdialog;
};

#endif
