#ifndef TOOLBAR_H
#define TOOLBAR_H


#include <qtoolbar.h>
#include "Object.h"
#include <qtoolbutton.h>
#include <qwhatsthis.h> 




class ToolBar : public Widget
{
private:
	QToolBar *self;	

public:
      ToolBar ( const char * label, MainWindow *p, char *edge,
                   bool newLine = FALSE, const char * name = 0 );
                   
                   
	
	void addToolButton(char *imagePath, char *caption, char *groupText, 
		PyObject *slot, char *toolTip, char *buttonName = 0);

		   
      ToolBar ( const char * label, 
      		   MainWindow *p, 
		   Widget *q, 
		   bool newLine = FALSE, 
		   const char *name = 0,
                   WFlags f = 0 ) 
	{
		self = new QToolBar(label,
			(QMainWindow *)p->widget,
			q->widget,newLine,name,f);		
		setWidget(self);
	};		   
		   
      ToolBar ( MainWindow * parent = 0, const char * name = 0 ) 
      {
      		if (parent)
      			self = new QToolBar(
				(QMainWindow *) parent->widget, 
				name);
		else
			self = new QToolBar();

		setWidget(self);
      };
      
      ~ToolBar () 
      {
      	delete self;
      };
      
      void addSeparator () 
      {
      	self->addSeparator();	
      }
//      virtual void setOrientation ( Orientation ) 
//      Orientation orientation () const
//      virtual void show () 
//      QMainWindow* mainWindow () 
      void setStretchableWidget ( Widget *w ) 
      {
      	self->setStretchableWidget( w->widget );
      };



};


#endif
