from pythonqt import *
from random import *


########### Set up the application
a = Application()

#x = ModalFileDialog()
#print x




class Main(Widget):

	def hello(self, *args):
		print "hello ",args

	def __init__(self):
		Widget.__init__(self)
		
	def setup(self):
		self.menubar = MenuBar(self)
		self.pmenu = PopupMenu(self, "File")
		self.pmenu.insertItemText("hello there",self,"hello")
		 
		self.menubar.show()




	def showme(self, id):
		pass

	






## Set up the main widget
w = Main()
w.timerConnection("showme",1000,w.showme)


w.setGeometry(50,50,300,480)
w.setCaption("Welcome to Python/Qt")

## A different font!
f = QFontV("uptopia", 18, QFont.Bold,0)

## Some colors
black = QColorRGB(0,0,0)
white = QColorRGB(255,255,255)
blue = QColorRGB(0,0,255)
col = QColorRGB(240,10,10)

## Create some push buttons
b = PushButton("Done",w)
b.setFont(f)
cgn = QColorGroupV(black,col,col.light(), col.dark(), col.dark(120), 
		  blue, white)
cgd = QColorGroupV(black,col,col.light(), col.dark(), col.dark(120),
		   col.light(), black)
 
b.setPalette(QPaletteCG(cgn,cgd,cgn))
b.setAutoResize(1)
b.move(10,10)

bb = PushButton("enable",w)
bb.resizeSize(b.size())
bb.move(10 + b.width() + 10,10)

pmb = PushButton("hello",w)
pmb.setPixmap(PixmapFile("python.bmp"))
pmb.setAutoResize(1)
pmb.move(bb.x() + bb.width() + 10, 10)
pmb.setToggleButton(1)

qmb = PushButton("hello",w)
qmb.setPixmap(PixmapFile("qt.bmp"))
qmb.setAutoResize(1)
qmb.move(pmb.x() + pmb.width() + 5 ,10)
qmb.setToggleButton(1)

label = LabelT("Enter your name:",w)
label.setFrameStyle(Frame.Panel | Frame.Raised)
label.setAutoResize(1)
label.move(10,100)


le = LineEdit(w)
le.move(150,100)
le.resize(100,label.height())

groupbox = GroupBoxTitle("GroupBox",w)
groupbox.move(100,150)
groupbox.resize(100,150)
groupbox.setFrameStyle(Frame.Box | Frame.Raised)

pl = Label(groupbox)
pl.setAutoResize(1)
pl.move(20,20)

ql = Label(groupbox)
ql.setAutoResize(1)
ql.move(20,70)

chkbx = CheckBox("CheckBox",w)
chkbx.setAutoResize(1)
chkbx.move(200,200)

radio = RadioButton("RadioButton",w)
radio.setAutoResize(1)
radio.move(200,220)


buttongroup = ButtonGroupTitle("Radio Buttons",w)
buttongroup.resize(200,100)
buttongroup.move(100,310)
buttongroup.setExclusive(1)

buttonnames = ["AM","FM","MW"]
rbuttons = {}
y = 15
for x in buttonnames:
    rbuttons[x] = RadioButton(x,buttongroup)
    rbuttons[x].setAutoResize(1)
    rbuttons[x].move(5,y)
    buttongroup.insert(rbuttons[x])
    y = y + rbuttons[x].height() + 5

## Create something to do when they are clicked
def OkHit():
    print '-------------------------------------------------'
    t = le.text()
    print 'Hello, ' + t + ' and welcome to the wonderful world of Python/Qt'
    print '-------------------------------------------------'
    a.quit()

def EnableHit():
    if (b.isEnabled()):
	b.setEnabled(0)
    else:
	b.setEnabled(1)

def PythonToggled(t):
    if t:
	pl.setPixmap(PixmapFile("python.bmp"))
    else:
	pl.setText("")

def QtToggled(t):
    if t:
	ql.setPixmap(PixmapFile("qt.bmp"))
    else:
	ql.setText("")

#def mytimer(*args):
#	print "hello timer world",args

## Connect them to the slots
b.connect("clicked", OkHit)
bb.connect("clicked", EnableHit)

#b.mytimer = mytimer

# try a timer
#b.timerConnection("mytimer",1000,b.mytimer)

pmb.connect("toggled", PythonToggled)
qmb.connect("toggled", QtToggled)


a.setMainWidget(w)
w.setup()			# set the main widget
w.show()				# show the main widget
a.execLoop()				# start the application


## del a -- this doesn't seem to delete it -- python memory management problem
## which I haven't managed to resolve yet!
