/*
 * FILE : pythonqt_wrap.c
 * 
 * This file was automatically generated by :
 * Simplified Wrapper and Interface Generator (SWIG)
 * Version 1.1 (Patch 5)
 * 
 * Portions Copyright (c) 1995-1998
 * The University of Utah and The Regents of the University of California.
 * Permission is granted to distribute this file in any manner provided
 * this notice remains intact.
 * 
 * Do not make changes to this file--changes will be lost!
 *
 */


#define SWIGCODE
/* Implementation : PYTHON */

#define SWIGPYTHON
#include <string.h>
#include <stdlib.h>
/***********************************************************************
 * $Header:$
 * swig_lib/python/python.cfg
 *
 * This file contains coded needed to add variable linking to the
 * Python interpreter.   C variables are added as a new kind of Python
 * datatype.
 *
 * Also contains supporting code for building python under Windows
 * and things like that.
 *
 * $Log:$
 ************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif
#include "Python.h"
#ifdef __cplusplus
}
#endif

/* Definitions for Windows/Unix exporting */
#if defined(__WIN32__)
#   if defined(_MSC_VER)
#	define SWIGEXPORT(a,b) __declspec(dllexport) a b
#   else
#	if defined(__BORLANDC__)
#	    define SWIGEXPORT(a,b) a _export b
#	else
#	    define SWIGEXPORT(a,b) a b
#	endif
#   endif
#else
#   define SWIGEXPORT(a,b) a b
#endif

#ifdef SWIG_GLOBAL
#ifdef __cplusplus
#define SWIGSTATIC extern "C"
#else
#define SWIGSTATIC
#endif
#endif

#ifndef SWIGSTATIC
#define SWIGSTATIC static
#endif

typedef struct {
  char  *name;
  PyObject *(*get_attr)(void);
  int (*set_attr)(PyObject *);
} swig_globalvar;

typedef struct swig_varlinkobject {
  PyObject_HEAD
  swig_globalvar **vars;
  int      nvars;
  int      maxvars;
} swig_varlinkobject;

/* ----------------------------------------------------------------------
   swig_varlink_repr()

   Function for python repr method
   ---------------------------------------------------------------------- */

static PyObject *
swig_varlink_repr(swig_varlinkobject *v)
{
  v = v;
  return PyString_FromString("<Global variables>");
}

/* ---------------------------------------------------------------------
   swig_varlink_print()

   Print out all of the global variable names
   --------------------------------------------------------------------- */

static int
swig_varlink_print(swig_varlinkobject *v, FILE *fp, int flags)
{

  int i = 0;
  flags = flags;
  fprintf(fp,"Global variables { ");
  while (v->vars[i]) {
    fprintf(fp,"%s", v->vars[i]->name);
    i++;
    if (v->vars[i]) fprintf(fp,", ");
  }
  fprintf(fp," }\n");
  return 0;
}

/* --------------------------------------------------------------------
   swig_varlink_getattr
 
   This function gets the value of a variable and returns it as a
   PyObject.   In our case, we'll be looking at the datatype and
   converting into a number or string
   -------------------------------------------------------------------- */

static PyObject *
swig_varlink_getattr(swig_varlinkobject *v, char *n)
{
  int i = 0;
  char temp[128];

  while (v->vars[i]) {
    if (strcmp(v->vars[i]->name,n) == 0) {
      return (*v->vars[i]->get_attr)();
    }
    i++;
  }
  sprintf(temp,"C global variable %s not found.", n);
  PyErr_SetString(PyExc_NameError,temp);
  return NULL;
}

/* -------------------------------------------------------------------
   swig_varlink_setattr()

   This function sets the value of a variable.
   ------------------------------------------------------------------- */

static int
swig_varlink_setattr(swig_varlinkobject *v, char *n, PyObject *p)
{
  char temp[128];
  int i = 0;
  while (v->vars[i]) {
    if (strcmp(v->vars[i]->name,n) == 0) {
      return (*v->vars[i]->set_attr)(p);
    }
    i++;
  }
  sprintf(temp,"C global variable %s not found.", n);
  PyErr_SetString(PyExc_NameError,temp);
  return 1;
}

statichere PyTypeObject varlinktype = {
/*  PyObject_HEAD_INIT(&PyType_Type)  Note : This doesn't work on some machines */
  PyObject_HEAD_INIT(0)              
  0,
  "varlink",                          /* Type name    */
  sizeof(swig_varlinkobject),         /* Basic size   */
  0,                                  /* Itemsize     */
  0,                                  /* Deallocator  */ 
  (printfunc) swig_varlink_print,     /* Print        */
  (getattrfunc) swig_varlink_getattr, /* get attr     */
  (setattrfunc) swig_varlink_setattr, /* Set attr     */
  0,                                  /* tp_compare   */
  (reprfunc) swig_varlink_repr,       /* tp_repr      */    
  0,                                  /* tp_as_number */
  0,                                  /* tp_as_mapping*/
  0,                                  /* tp_hash      */
};

/* Create a variable linking object for use later */

SWIGSTATIC PyObject *
SWIG_newvarlink(void)
{
  swig_varlinkobject *result = 0;
  result = PyMem_NEW(swig_varlinkobject,1);
  varlinktype.ob_type = &PyType_Type;    /* Patch varlinktype into a PyType */
  result->ob_type = &varlinktype;
  /*  _Py_NewReference(result);  Does not seem to be necessary */
  result->nvars = 0;
  result->maxvars = 64;
  result->vars = (swig_globalvar **) malloc(64*sizeof(swig_globalvar *));
  result->vars[0] = 0;
  result->ob_refcnt = 0;
  Py_XINCREF((PyObject *) result);
  return ((PyObject*) result);
}

SWIGSTATIC void
SWIG_addvarlink(PyObject *p, char *name,
	   PyObject *(*get_attr)(void), int (*set_attr)(PyObject *p))
{
  swig_varlinkobject *v;
  v= (swig_varlinkobject *) p;
	
  if (v->nvars >= v->maxvars -1) {
    v->maxvars = 2*v->maxvars;
    v->vars = (swig_globalvar **) realloc(v->vars,v->maxvars*sizeof(swig_globalvar *));
    if (v->vars == NULL) {
      fprintf(stderr,"SWIG : Fatal error in initializing Python module.\n");
      exit(1);
    }
  }
  v->vars[v->nvars] = (swig_globalvar *) malloc(sizeof(swig_globalvar));
  v->vars[v->nvars]->name = (char *) malloc(strlen(name)+1);
  strcpy(v->vars[v->nvars]->name,name);
  v->vars[v->nvars]->get_attr = get_attr;
  v->vars[v->nvars]->set_attr = set_attr;
  v->nvars++;
  v->vars[v->nvars] = 0;
}



/*****************************************************************************
 * $Header:$
 *
 * swigptr.swg
 *
 * This file contains supporting code for the SWIG run-time type checking
 * mechanism.  The following functions are available :
 *
 * SWIG_RegisterMapping(char *origtype, char *newtype, void *(*cast)(void *));
 *
 *      Registers a new type-mapping with the type-checker.  origtype is the
 *      original datatype and newtype is an equivalent type.  cast is optional
 *      pointer to a function to cast pointer values between types (this
 *      is typically used to cast pointers from derived classes to base classes in C++)
 *      
 * SWIG_MakePtr(char *buffer, void *ptr, char *typestring);
 *     
 *      Makes a pointer string from a pointer and typestring.  The result is returned
 *      in buffer which is assumed to hold enough space for the result.
 *
 * char * SWIG_GetPtr(char *buffer, void **ptr, char *type)
 *
 *      Gets a pointer value from a string.  If there is a type-mismatch, returns
 *      a character string to the received type.  On success, returns NULL.
 *
 *
 * You can remap these functions by making a file called "swigptr.swg" in
 * your the same directory as the interface file you are wrapping.
 *
 * These functions are normally declared static, but this file can be
 * can be used in a multi-module environment by redefining the symbol
 * SWIGSTATIC.
 *****************************************************************************/

#include <stdlib.h>

#ifdef SWIG_GLOBAL
#ifdef __cplusplus
#define SWIGSTATIC extern "C"
#else
#define SWIGSTATIC
#endif
#endif

#ifndef SWIGSTATIC
#define SWIGSTATIC static
#endif


/* SWIG pointer structure */

typedef struct SwigPtrType {
  char               *name;               /* Datatype name                  */
  int                 len;                /* Length (used for optimization) */
  void               *(*cast)(void *);    /* Pointer casting function       */
  struct SwigPtrType *next;               /* Linked list pointer            */
} SwigPtrType;

/* Pointer cache structure */

typedef struct {
  int                 stat;               /* Status (valid) bit             */
  SwigPtrType        *tp;                 /* Pointer to type structure      */
  char                name[256];          /* Given datatype name            */
  char                mapped[256];        /* Equivalent name                */
} SwigCacheType;

/* Some variables  */

static int SwigPtrMax  = 64;           /* Max entries that can be currently held */
                                       /* This value may be adjusted dynamically */
static int SwigPtrN    = 0;            /* Current number of entries              */
static int SwigPtrSort = 0;            /* Status flag indicating sort            */
static int SwigStart[256];             /* Starting positions of types            */

/* Pointer table */
static SwigPtrType *SwigPtrTable = 0;  /* Table containing pointer equivalences  */

/* Cached values */

#define SWIG_CACHESIZE  8
#define SWIG_CACHEMASK  0x7
static SwigCacheType SwigCache[SWIG_CACHESIZE];  
static int SwigCacheIndex = 0;
static int SwigLastCache = 0;

/* Sort comparison function */
static int swigsort(const void *data1, const void *data2) {
	SwigPtrType *d1 = (SwigPtrType *) data1;
	SwigPtrType *d2 = (SwigPtrType *) data2;
	return strcmp(d1->name,d2->name);
}

/* Binary Search function */
static int swigcmp(const void *key, const void *data) {
  char *k = (char *) key;
  SwigPtrType *d = (SwigPtrType *) data;
  return strncmp(k,d->name,d->len);
}

/* Register a new datatype with the type-checker */

SWIGSTATIC 
void SWIG_RegisterMapping(char *origtype, char *newtype, void *(*cast)(void *)) {

  int i;
  SwigPtrType *t = 0,*t1;

  /* Allocate the pointer table if necessary */

  if (!SwigPtrTable) {     
    SwigPtrTable = (SwigPtrType *) malloc(SwigPtrMax*sizeof(SwigPtrType));
    SwigPtrN = 0;
  }
  /* Grow the table */
  if (SwigPtrN >= SwigPtrMax) {
    SwigPtrMax = 2*SwigPtrMax;
    SwigPtrTable = (SwigPtrType *) realloc((char *) SwigPtrTable,SwigPtrMax*sizeof(SwigPtrType));
  }
  for (i = 0; i < SwigPtrN; i++)
    if (strcmp(SwigPtrTable[i].name,origtype) == 0) {
      t = &SwigPtrTable[i];
      break;
    }
  if (!t) {
    t = &SwigPtrTable[SwigPtrN];
    t->name = origtype;
    t->len = strlen(t->name);
    t->cast = 0;
    t->next = 0;
    SwigPtrN++;
  }

  /* Check for existing entry */

  while (t->next) {
    if ((strcmp(t->name,newtype) == 0)) {
      if (cast) t->cast = cast;
      return;
    }
    t = t->next;
  }
  
  /* Now place entry (in sorted order) */

  t1 = (SwigPtrType *) malloc(sizeof(SwigPtrType));
  t1->name = newtype;
  t1->len = strlen(t1->name);
  t1->cast = cast;
  t1->next = 0;            
  t->next = t1;           
  SwigPtrSort = 0;
}

/* Make a pointer value string */

SWIGSTATIC 
void SWIG_MakePtr(char *_c, const void *_ptr, char *type) {
  static char _hex[16] =
  {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
   'a', 'b', 'c', 'd', 'e', 'f'};
  unsigned long _p, _s;
  char _result[20], *_r;    /* Note : a 64-bit hex number = 16 digits */
  _r = _result;
  _p = (unsigned long) _ptr;
  if (_p > 0) {
    while (_p > 0) {
      _s = _p & 0xf;
      *(_r++) = _hex[_s];
      _p = _p >> 4;
    }
    *_r = '_';
    while (_r >= _result)
      *(_c++) = *(_r--);
  } else {
    strcpy (_c, "NULL");
  }
  if (_ptr)
    strcpy (_c, type);
}

/* Define for backwards compatibility */

#define _swig_make_hex   SWIG_MakePtr 

/* Function for getting a pointer value */

SWIGSTATIC 
char *SWIG_GetPtr(char *_c, void **ptr, char *_t)
{
  unsigned long _p;
  char temp_type[256];
  char *name;
  int  i, len;
  SwigPtrType *sp,*tp;
  SwigCacheType *cache;
  char find[3];
  int  start, end;
  _p = 0;

  /* Pointer values must start with leading underscore */
  if (*_c == '_') {
      _c++;
      /* Extract hex value from pointer */
      while (*_c) {
	  if ((*_c >= '0') && (*_c <= '9'))
	    _p = (_p << 4) + (*_c - '0');
	  else if ((*_c >= 'a') && (*_c <= 'f'))
	    _p = (_p << 4) + ((*_c - 'a') + 10);
	  else
	    break;
	  _c++;
      }

      if (_t) {
	if (strcmp(_t,_c)) { 
	  if (!SwigPtrSort) {
	    qsort((void *) SwigPtrTable, SwigPtrN, sizeof(SwigPtrType), swigsort); 
	    for (i = 0; i < 256; i++) {
	      SwigStart[i] = SwigPtrN;
	    }
	    for (i = SwigPtrN-1; i >= 0; i--) {
	      SwigStart[SwigPtrTable[i].name[1]] = i;
	    }
	    for (i = 255; i >= 1; i--) {
	      if (SwigStart[i-1] > SwigStart[i])
		SwigStart[i-1] = SwigStart[i];
	    }
	    SwigPtrSort = 1;
	    for (i = 0; i < SWIG_CACHESIZE; i++)  
	      SwigCache[i].stat = 0;
	  }
	  
	  /* First check cache for matches.  Uses last cache value as starting point */
	  cache = &SwigCache[SwigLastCache];
	  for (i = 0; i < SWIG_CACHESIZE; i++) {
	    if (cache->stat) {
	      if (strcmp(_t,cache->name) == 0) {
		if (strcmp(_c,cache->mapped) == 0) {
		  cache->stat++;
		  *ptr = (void *) _p;
		  if (cache->tp->cast) *ptr = (*(cache->tp->cast))(*ptr);
		  return (char *) 0;
		}
	      }
	    }
	    SwigLastCache = (SwigLastCache+1) & SWIG_CACHEMASK;
	    if (!SwigLastCache) cache = SwigCache;
	    else cache++;
	  }
	  /* We have a type mismatch.  Will have to look through our type
	     mapping table to figure out whether or not we can accept this datatype */

	  start = SwigStart[_t[1]];
	  end = SwigStart[_t[1]+1];
	  sp = &SwigPtrTable[start];
	  while (start < end) {
	    if (swigcmp(_t,sp) == 0) break;
	    sp++;
	    start++;
	  }
	  if (start >= end) sp = 0;
	  /* Try to find a match for this */
	  if (sp) {
	    name = sp->name;
	    len = sp->len;
	    while (swigcmp(_t,sp) == 0) {
	      tp = sp->next;
	      /* Try to find entry for our given datatype */
	      while(tp) {
		if (tp->len >= 255) {
		  return _c;
		}
		strncpy(temp_type,tp->name,255);
		strncat(temp_type,_t+len,255-tp->len);
		if (strcmp(_c,temp_type) == 0) {
		  
		  strcpy(SwigCache[SwigCacheIndex].mapped,_c);
		  strcpy(SwigCache[SwigCacheIndex].name,_t);
		  SwigCache[SwigCacheIndex].stat = 1;
		  SwigCache[SwigCacheIndex].tp = tp;
		  SwigCacheIndex = SwigCacheIndex & SWIG_CACHEMASK;
		  
		  /* Get pointer value */
		  *ptr = (void *) _p;
		  if (tp->cast) *ptr = (*(tp->cast))(*ptr);
		  return (char *) 0;
		}
		tp = tp->next;
	      }
	      sp++;
	      /* Hmmm. Didn't find it this time */
	    }
	  }
	  /* Didn't find any sort of match for this data.  
	     Get the pointer value and return the received type */
	  *ptr = (void *) _p;
	  return _c;
	} else {
	  /* Found a match on the first try.  Return pointer value */
	  *ptr = (void *) _p;
	  return (char *) 0;
	}
      } else {
	/* No type specified.  Good luck */
	*ptr = (void *) _p;
	return (char *) 0;
      }
  } else {
    if (strcmp (_c, "NULL") == 0) {
	*ptr = (void *) 0;
	return (char *) 0;
    }
    *ptr = (void *) 0;	
    return _c;
  }
}

/* Compatibility mode */

#define _swig_get_hex  SWIG_GetPtr


#define SWIG_init    initpythonqtc

#define SWIG_name    "pythonqtc"

#include <qpixmap.h>
#include <qbitmap.h>
#include "Object.h"
 #include "Application.h"
 #include "Layout.h"
  #include "BoxLayout.h"
  #include "GridLayout.h"
 #include "Widget.h"
  #include "Button.h"
   #include "CheckBox.h"
   #include "PushButton.h"
   #include "RadioButton.h"
  #include "ComboBox.h"
  #include "Dialog.h"
   #include "TabDialog.h"
  #include "LineEdit.h"
  #include "Frame.h"
   #include "GroupBox.h"
    #include "ButtonGroup.h"
   #include "Label.h"
   #include "TableView.h"
    #include "ListBox.h"
    #include "MultiLineEdit.h"
  #include "ScrollBar.h"
#include "FileDialog.h"
#include "PopupMenu.h"
#include "MenuData.h"
#include "qdbt_tabular.h"
#include "treeview.h"
#include "splitter.h"
#include "mainwindow.h"
#include "toolbar.h"
#include "toolbutton.h"
#include "whatsthis.h"

#include <qlistview.h>

#include "Object.h"
extern const char *ModalFileDialog(const char *,const char *,QWidget *,const char *);
extern const char *getOpenFileName(const char *,const char *,Widget *,const char *);
extern const char *getSaveFileName(const char *,const char *,Widget *,const char *);
extern const char *getExistingDirectory(const char *,Widget *,const char *);

#include "PopupMenu.h"

#include "PopupMenu.h"

#include "MenuData.h"

#include <qmessagebox.h>
#include <qdialog.h>
#include "Widget.h"

#include "qdbt_tabular.h"

#include "treeview.h"

#include "splitter.h"
extern int ToolBarOrientation(char *);

#include "whatsthis.h"
static PyObject *_wrap_bitBlt(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPaintDevice * _arg0;
    int  _arg1;
    int  _arg2;
    QPaintDevice * _arg3;
    int  _arg4;
    int  _arg5;
    int  _arg6;
    int  _arg7;
    RasterOp  _arg8;
    int  _arg9;
    char * _argc0 = 0;
    char * _argc3 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siisiiiiii:bitBlt",&_argc0,&_arg1,&_arg2,&_argc3,&_arg4,&_arg5,&_arg6,&_arg7,&_arg8,&_arg9)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of bitBlt. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of bitBlt. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    bitBlt(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7,_arg8,_arg9);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_ModalFileDialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    char * _arg0 = 0;
    char * _arg1 = 0;
    QWidget * _arg2 = 0;
    char * _arg3 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"|ssss:ModalFileDialog",&_arg0,&_arg1,&_argc2,&_arg3)) 
        return NULL;
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QWidget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of ModalFileDialog. Expected _QWidget_p.");
        return NULL;
        }
    }
    _result = (char *)ModalFileDialog(_arg0,_arg1,_arg2,_arg3);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static PyObject *_wrap_getOpenFileName(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    char * _arg0 = 0;
    char * _arg1 = 0;
    Widget * _arg2 = 0;
    char * _arg3 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"|ssss:getOpenFileName",&_arg0,&_arg1,&_argc2,&_arg3)) 
        return NULL;
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of getOpenFileName. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (char *)getOpenFileName(_arg0,_arg1,_arg2,_arg3);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static PyObject *_wrap_getSaveFileName(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    char * _arg0 = 0;
    char * _arg1 = 0;
    Widget * _arg2 = 0;
    char * _arg3 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"|ssss:getSaveFileName",&_arg0,&_arg1,&_argc2,&_arg3)) 
        return NULL;
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of getSaveFileName. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (char *)getSaveFileName(_arg0,_arg1,_arg2,_arg3);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static PyObject *_wrap_getExistingDirectory(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    char * _arg0 = 0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"|sss:getExistingDirectory",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of getExistingDirectory. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (char *)getExistingDirectory(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static PyObject *_wrap_ToolBarOrientation(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    char * _arg0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ToolBarOrientation",&_arg0)) 
        return NULL;
    _result = (int )ToolBarOrientation(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define new_QListViewItem(_swigarg0) (new QListViewItem(_swigarg0))
static PyObject *_wrap_new_QListViewItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QListViewItem * _result;
    QListView * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QListViewItem",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListView_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QListViewItem. Expected _QListView_p.");
        return NULL;
        }
    }
    _result = (QListViewItem *)new_QListViewItem(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QListViewItem_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QListViewItemChild(_swigarg0) (new QListViewItem(_swigarg0))
static PyObject *_wrap_new_QListViewItemChild(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QListViewItem * _result;
    QListViewItem * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QListViewItemChild",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QListViewItemChild. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    _result = (QListViewItem *)new_QListViewItemChild(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QListViewItem_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QListViewItemAndLabels(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7,_swigarg8) (new QListViewItem(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7,_swigarg8))
static PyObject *_wrap_new_QListViewItemAndLabels(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QListViewItem * _result;
    QListView * _arg0;
    char * _arg1;
    char * _arg2 = 0;
    char * _arg3 = 0;
    char * _arg4 = 0;
    char * _arg5 = 0;
    char * _arg6 = 0;
    char * _arg7 = 0;
    char * _arg8 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss|sssssss:new_QListViewItemAndLabels",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4,&_arg5,&_arg6,&_arg7,&_arg8)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListView_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QListViewItemAndLabels. Expected _QListView_p.");
        return NULL;
        }
    }
    _result = (QListViewItem *)new_QListViewItemAndLabels(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7,_arg8);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QListViewItem_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QListViewItemChildAndLabels(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7,_swigarg8) (new QListViewItem(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7,_swigarg8))
static PyObject *_wrap_new_QListViewItemChildAndLabels(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QListViewItem * _result;
    QListViewItem * _arg0;
    char * _arg1;
    char * _arg2 = 0;
    char * _arg3 = 0;
    char * _arg4 = 0;
    char * _arg5 = 0;
    char * _arg6 = 0;
    char * _arg7 = 0;
    char * _arg8 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss|sssssss:new_QListViewItemChildAndLabels",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4,&_arg5,&_arg6,&_arg7,&_arg8)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QListViewItemChildAndLabels. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    _result = (QListViewItem *)new_QListViewItemChildAndLabels(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7,_arg8);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QListViewItem_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QListViewItem_insertItem(_swigobj,_swigarg0)  (_swigobj->insertItem(_swigarg0))
static PyObject *_wrap_QListViewItem_insertItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QListViewItem * _arg0;
    QListViewItem * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QListViewItem_insertItem",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_insertItem. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QListViewItem_insertItem. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    QListViewItem_insertItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QListViewItem_removeItem(_swigobj,_swigarg0)  (_swigobj->removeItem(_swigarg0))
static PyObject *_wrap_QListViewItem_removeItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QListViewItem * _arg0;
    QListViewItem * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QListViewItem_removeItem",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_removeItem. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QListViewItem_removeItem. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    QListViewItem_removeItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QListViewItem_height(_swigobj)  (_swigobj->height())
static PyObject *_wrap_QListViewItem_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QListViewItem * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QListViewItem_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_height. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    _result = (int )QListViewItem_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QListViewItem_invalidateHeight(_swigobj)  (_swigobj->invalidateHeight())
static PyObject *_wrap_QListViewItem_invalidateHeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QListViewItem * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QListViewItem_invalidateHeight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_invalidateHeight. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    QListViewItem_invalidateHeight(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QListViewItem_totalHeight(_swigobj)  (_swigobj->totalHeight())
static PyObject *_wrap_QListViewItem_totalHeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QListViewItem * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QListViewItem_totalHeight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_totalHeight. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    _result = (int )QListViewItem_totalHeight(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QListViewItem_width(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->width(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_QListViewItem_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QListViewItem * _arg0;
    QFontMetrics * _arg1;
    QListView * _arg2;
    int  _arg3;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sssi:QListViewItem_width",&_argc0,&_argc1,&_argc2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_width. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QListViewItem_width. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QListView_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QListViewItem_width. Expected _QListView_p.");
        return NULL;
        }
    }
    _result = (int )QListViewItem_width(_arg0,*_arg1,_arg2,_arg3);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QListViewItem_widthChanged(_swigobj,_swigarg0)  (_swigobj->widthChanged(_swigarg0))
static PyObject *_wrap_QListViewItem_widthChanged(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QListViewItem * _arg0;
    int  _arg1 = -1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|i:QListViewItem_widthChanged",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_widthChanged. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    QListViewItem_widthChanged(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QListViewItem_depth(_swigobj)  (_swigobj->depth())
static PyObject *_wrap_QListViewItem_depth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QListViewItem * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QListViewItem_depth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_depth. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    _result = (int )QListViewItem_depth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QListViewItem_setText(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setText(_swigarg0,_swigarg1))
static PyObject *_wrap_QListViewItem_setText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QListViewItem * _arg0;
    int  _arg1;
    char * _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sis:QListViewItem_setText",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_setText. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    QListViewItem_setText(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QListViewItem_text(_swigobj,_swigarg0)  (_swigobj->text(_swigarg0))
static PyObject *_wrap_QListViewItem_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    QListViewItem * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QListViewItem_text",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_text. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    _result = (char *)QListViewItem_text(_arg0,_arg1);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define QListViewItem_setPixmap(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setPixmap(_swigarg0,_swigarg1))
static PyObject *_wrap_QListViewItem_setPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QListViewItem * _arg0;
    int  _arg1;
    QPixmap * _arg2;
    char * _argc0 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sis:QListViewItem_setPixmap",&_argc0,&_arg1,&_argc2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_setPixmap. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QListViewItem_setPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    QListViewItem_setPixmap(_arg0,_arg1,*_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QListViewItem_pixmap(_swigobj,_swigarg0)  (_swigobj->pixmap(_swigarg0))
static PyObject *_wrap_QListViewItem_pixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    QListViewItem * _arg0;
    int  _arg1;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"si:QListViewItem_pixmap",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_pixmap. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)QListViewItem_pixmap(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QListViewItem_key(_swigobj,_swigarg0,_swigarg1)  (_swigobj->key(_swigarg0,_swigarg1))
static PyObject *_wrap_QListViewItem_key(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    QListViewItem * _arg0;
    int  _arg1;
    bool  _arg2;
    char * _argc0 = 0;
    int tempbool2;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:QListViewItem_key",&_argc0,&_arg1,&tempbool2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_key. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    _arg2 = (bool ) tempbool2;
    _result = (char *)QListViewItem_key(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define QListViewItem_sortChildItems(_swigobj,_swigarg0,_swigarg1)  (_swigobj->sortChildItems(_swigarg0,_swigarg1))
static PyObject *_wrap_QListViewItem_sortChildItems(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QListViewItem * _arg0;
    int  _arg1;
    bool  _arg2;
    char * _argc0 = 0;
    int tempbool2;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:QListViewItem_sortChildItems",&_argc0,&_arg1,&tempbool2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QListViewItem_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QListViewItem_sortChildItems. Expected _QListViewItem_p.");
        return NULL;
        }
    }
    _arg2 = (bool ) tempbool2;
    QListViewItem_sortChildItems(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define new_QColor() (new QColor())
static PyObject *_wrap_new_QColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_QColor")) 
        return NULL;
    _result = (QColor *)new_QColor();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QColorRGB(_swigarg0,_swigarg1,_swigarg2) (new QColor(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_QColorRGB(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    int  _arg0;
    int  _arg1;
    int  _arg2;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"iii:new_QColorRGB",&_arg0,&_arg1,&_arg2)) 
        return NULL;
    _result = (QColor *)new_QColorRGB(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QColorName(_swigarg0) (new QColor(_swigarg0))
static PyObject *_wrap_new_QColorName(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    char * _arg0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QColorName",&_arg0)) 
        return NULL;
    _result = (QColor *)new_QColorName(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QColorCopy(_swigarg0) (new QColor(_swigarg0))
static PyObject *_wrap_new_QColorCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColor * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QColorCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QColorCopy. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (QColor *)new_QColorCopy(*_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QColor_isValid(_swigobj)  (_swigobj->isValid())
static PyObject *_wrap_QColor_isValid(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QColor * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColor_isValid",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_isValid. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (bool )QColor_isValid(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QColor_isDirty(_swigobj)  (_swigobj->isDirty())
static PyObject *_wrap_QColor_isDirty(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QColor * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColor_isDirty",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_isDirty. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (bool )QColor_isDirty(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QColor_setNamedColor(_swigobj,_swigarg0)  (_swigobj->setNamedColor(_swigarg0))
static PyObject *_wrap_QColor_setNamedColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QColor_setNamedColor",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_setNamedColor. Expected _QColor_p.");
        return NULL;
        }
    }
    QColor_setNamedColor(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QColor_rgb(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->rgb(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_QColor_rgb(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _arg0;
    int * _arg1;
    int * _arg2;
    int * _arg3;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char * _argc3 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssss:QColor_rgb",&_argc0,&_argc1,&_argc2,&_argc3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_rgb. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QColor_rgb. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QColor_rgb. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of QColor_rgb. Expected _int_p.");
        return NULL;
        }
    }
    QColor_rgb(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QColor_setRgb(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->setRgb(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_QColor_setRgb(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siii:QColor_setRgb",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_setRgb. Expected _QColor_p.");
        return NULL;
        }
    }
    QColor_setRgb(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QColor_red(_swigobj)  (_swigobj->red())
static PyObject *_wrap_QColor_red(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QColor * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColor_red",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_red. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (int )QColor_red(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QColor_green(_swigobj)  (_swigobj->green())
static PyObject *_wrap_QColor_green(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QColor * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColor_green",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_green. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (int )QColor_green(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QColor_blue(_swigobj)  (_swigobj->blue())
static PyObject *_wrap_QColor_blue(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QColor * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColor_blue",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_blue. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (int )QColor_blue(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QColor_hsv(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->hsv(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_QColor_hsv(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _arg0;
    int * _arg1;
    int * _arg2;
    int * _arg3;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char * _argc3 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssss:QColor_hsv",&_argc0,&_argc1,&_argc2,&_argc3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_hsv. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QColor_hsv. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QColor_hsv. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of QColor_hsv. Expected _int_p.");
        return NULL;
        }
    }
    QColor_hsv(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QColor_setHsv(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->setHsv(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_QColor_setHsv(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siii:QColor_setHsv",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_setHsv. Expected _QColor_p.");
        return NULL;
        }
    }
    QColor_setHsv(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QColor_light(_swigobj,_swigarg0)  (_swigobj->light(_swigarg0))
static PyObject *_wrap_QColor_light(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColor * _arg0;
    int  _arg1 = 112;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s|i:QColor_light",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_light. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = new QColor (QColor_light(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QColor_dark(_swigobj,_swigarg0)  (_swigobj->dark(_swigarg0))
static PyObject *_wrap_QColor_dark(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColor * _arg0;
    int  _arg1 = 220;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s|i:QColor_dark",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_dark. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = new QColor (QColor_dark(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QColor_alloc(_swigobj)  (_swigobj->alloc())
static PyObject *_wrap_QColor_alloc(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    uint * _result;
    QColor * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColor_alloc",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_alloc. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = new uint (QColor_alloc(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_uint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QColor_pixel(_swigobj)  (_swigobj->pixel())
static PyObject *_wrap_QColor_pixel(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    uint * _result;
    QColor * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColor_pixel",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColor_pixel. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = new uint (QColor_pixel(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_uint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static PyObject *_wrap_QColor_lazyAlloc(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;

    self = self;
    if(!PyArg_ParseTuple(args,":QColor_lazyAlloc")) 
        return NULL;
    _result = (bool )QColor::lazyAlloc();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QColor_setLazyAlloc(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _arg0;

    self = self;
    if(!PyArg_ParseTuple(args,"i:QColor_setLazyAlloc",&_arg0)) 
        return NULL;
    QColor::setLazyAlloc(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_QColor_maxColors(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;

    self = self;
    if(!PyArg_ParseTuple(args,":QColor_maxColors")) 
        return NULL;
    _result = (int )QColor::maxColors();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QColor_numBitPlanes(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;

    self = self;
    if(!PyArg_ParseTuple(args,":QColor_numBitPlanes")) 
        return NULL;
    _result = (int )QColor::numBitPlanes();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QColor_enterAllocContext(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;

    self = self;
    if(!PyArg_ParseTuple(args,":QColor_enterAllocContext")) 
        return NULL;
    _result = (int )QColor::enterAllocContext();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QColor_leaveAllocContext(PyObject *self, PyObject *args) {
    PyObject * _resultobj;

    self = self;
    if(!PyArg_ParseTuple(args,":QColor_leaveAllocContext")) 
        return NULL;
    QColor::leaveAllocContext();
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_QColor_currentAllocContext(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;

    self = self;
    if(!PyArg_ParseTuple(args,":QColor_currentAllocContext")) 
        return NULL;
    _result = (int )QColor::currentAllocContext();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QColor_destroyAllocContext(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _arg0;

    self = self;
    if(!PyArg_ParseTuple(args,"i:QColor_destroyAllocContext",&_arg0)) 
        return NULL;
    QColor::destroyAllocContext(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define new_QColorGroup() (new QColorGroup())
static PyObject *_wrap_new_QColorGroup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_QColorGroup")) 
        return NULL;
    _result = (QColorGroup *)new_QColorGroup();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QColorGroupV(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6) (new QColorGroup(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6))
static PyObject *_wrap_new_QColorGroupV(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    QColor * _arg0;
    QColor * _arg1;
    QColor * _arg2;
    QColor * _arg3;
    QColor * _arg4;
    QColor * _arg5;
    QColor * _arg6;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char * _argc3 = 0;
    char * _argc4 = 0;
    char * _argc5 = 0;
    char * _argc6 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"sssssss:new_QColorGroupV",&_argc0,&_argc1,&_argc2,&_argc3,&_argc4,&_argc5,&_argc6)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc4) {
        if (SWIG_GetPtr(_argc4,(void **) &_arg4,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 5 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc5) {
        if (SWIG_GetPtr(_argc5,(void **) &_arg5,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 6 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    if (_argc6) {
        if (SWIG_GetPtr(_argc6,(void **) &_arg6,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 7 of new_QColorGroupV. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (QColorGroup *)new_QColorGroupV(*_arg0,*_arg1,*_arg2,*_arg3,*_arg4,*_arg5,*_arg6);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QColorGroup_foreground(_swigobj)  (_swigobj->foreground())
static PyObject *_wrap_QColorGroup_foreground(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColorGroup_foreground",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_foreground. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    const QColor & _result_ref = QColorGroup_foreground(_arg0);
    _result = (QColor *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QColorGroup_background(_swigobj)  (_swigobj->background())
static PyObject *_wrap_QColorGroup_background(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColorGroup_background",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_background. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    const QColor & _result_ref = QColorGroup_background(_arg0);
    _result = (QColor *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QColorGroup_light(_swigobj)  (_swigobj->light())
static PyObject *_wrap_QColorGroup_light(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColorGroup_light",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_light. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    const QColor & _result_ref = QColorGroup_light(_arg0);
    _result = (QColor *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QColorGroup_dark(_swigobj)  (_swigobj->dark())
static PyObject *_wrap_QColorGroup_dark(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColorGroup_dark",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_dark. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    const QColor & _result_ref = QColorGroup_dark(_arg0);
    _result = (QColor *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QColorGroup_mid(_swigobj)  (_swigobj->mid())
static PyObject *_wrap_QColorGroup_mid(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColorGroup_mid",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_mid. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    const QColor & _result_ref = QColorGroup_mid(_arg0);
    _result = (QColor *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QColorGroup_text(_swigobj)  (_swigobj->text())
static PyObject *_wrap_QColorGroup_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColorGroup_text",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_text. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    const QColor & _result_ref = QColorGroup_text(_arg0);
    _result = (QColor *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QColorGroup_base(_swigobj)  (_swigobj->base())
static PyObject *_wrap_QColorGroup_base(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    QColorGroup * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QColorGroup_base",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QColorGroup_base. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    const QColor & _result_ref = QColorGroup_base(_arg0);
    _result = (QColor *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QPalette() (new QPalette())
static PyObject *_wrap_new_QPalette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_QPalette")) 
        return NULL;
    _result = (QPalette *)new_QPalette();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QPaletteColor(_swigarg0) (new QPalette(_swigarg0))
static PyObject *_wrap_new_QPaletteColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    QColor * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QPaletteColor",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QPaletteColor. Expected _QColor_p.");
        return NULL;
        }
    }
    _result = (QPalette *)new_QPaletteColor(*_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QPaletteCG(_swigarg0,_swigarg1,_swigarg2) (new QPalette(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_QPaletteCG(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    QColorGroup * _arg0;
    QColorGroup * _arg1;
    QColorGroup * _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"sss:new_QPaletteCG",&_argc0,&_argc1,&_argc2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QPaletteCG. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_QPaletteCG. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of new_QPaletteCG. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    _result = (QPalette *)new_QPaletteCG(*_arg0,*_arg1,*_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QPaletteCopy(_swigarg0) (new QPalette(_swigarg0))
static PyObject *_wrap_new_QPaletteCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    QPalette * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QPaletteCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QPaletteCopy. Expected _QPalette_p.");
        return NULL;
        }
    }
    _result = (QPalette *)new_QPaletteCopy(*_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_QPalette(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_QPalette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_QPalette",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QPalette. Expected _QPalette_p.");
        return NULL;
        }
    }
    delete_QPalette(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QPalette_copy(_swigobj)  (_swigobj->copy())
static PyObject *_wrap_QPalette_copy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    QPalette * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPalette_copy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_copy. Expected _QPalette_p.");
        return NULL;
        }
    }
    _result = new QPalette (QPalette_copy(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QPalette_normal(_swigobj)  (_swigobj->normal())
static PyObject *_wrap_QPalette_normal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    QPalette * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPalette_normal",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_normal. Expected _QPalette_p.");
        return NULL;
        }
    }
    const QColorGroup & _result_ref = QPalette_normal(_arg0);
    _result = (QColorGroup *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QPalette_disabled(_swigobj)  (_swigobj->disabled())
static PyObject *_wrap_QPalette_disabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    QPalette * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPalette_disabled",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_disabled. Expected _QPalette_p.");
        return NULL;
        }
    }
    const QColorGroup & _result_ref = QPalette_disabled(_arg0);
    _result = (QColorGroup *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QPalette_active(_swigobj)  (_swigobj->active())
static PyObject *_wrap_QPalette_active(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    QPalette * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPalette_active",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_active. Expected _QPalette_p.");
        return NULL;
        }
    }
    const QColorGroup & _result_ref = QPalette_active(_arg0);
    _result = (QColorGroup *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QPalette_setNormal(_swigobj,_swigarg0)  (_swigobj->setNormal(_swigarg0))
static PyObject *_wrap_QPalette_setNormal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _arg0;
    QColorGroup * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QPalette_setNormal",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_setNormal. Expected _QPalette_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QPalette_setNormal. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    QPalette_setNormal(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QPalette_setDisabled(_swigobj,_swigarg0)  (_swigobj->setDisabled(_swigarg0))
static PyObject *_wrap_QPalette_setDisabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _arg0;
    QColorGroup * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QPalette_setDisabled",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_setDisabled. Expected _QPalette_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QPalette_setDisabled. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    QPalette_setDisabled(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QPalette_setActive(_swigobj,_swigarg0)  (_swigobj->setActive(_swigarg0))
static PyObject *_wrap_QPalette_setActive(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _arg0;
    QColorGroup * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QPalette_setActive",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_setActive. Expected _QPalette_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColorGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QPalette_setActive. Expected _QColorGroup_p.");
        return NULL;
        }
    }
    QPalette_setActive(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QPalette_serialNumber(_swigobj)  (_swigobj->serialNumber())
static PyObject *_wrap_QPalette_serialNumber(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPalette * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPalette_serialNumber",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPalette_serialNumber. Expected _QPalette_p.");
        return NULL;
        }
    }
    _result = (int )QPalette_serialNumber(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define new_QCursor() (new QCursor())
static PyObject *_wrap_new_QCursor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QCursor * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_QCursor")) 
        return NULL;
    _result = (QCursor *)new_QCursor();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QCursor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QCursorShape(_swigarg0) (new QCursor(_swigarg0))
static PyObject *_wrap_new_QCursorShape(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QCursor * _result;
    int  _arg0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"i:new_QCursorShape",&_arg0)) 
        return NULL;
    _result = (QCursor *)new_QCursorShape(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QCursor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QCursorCopy(_swigarg0) (new QCursor(_swigarg0))
static PyObject *_wrap_new_QCursorCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QCursor * _result;
    QCursor * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QCursorCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QCursor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QCursorCopy. Expected _QCursor_p.");
        return NULL;
        }
    }
    _result = (QCursor *)new_QCursorCopy(*_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QCursor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QCursor_shape(_swigobj)  (_swigobj->shape())
static PyObject *_wrap_QCursor_shape(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QCursor * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QCursor_shape",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QCursor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QCursor_shape. Expected _QCursor_p.");
        return NULL;
        }
    }
    _result = (int )QCursor_shape(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QCursor_setShape(_swigobj,_swigarg0)  (_swigobj->setShape(_swigarg0))
static PyObject *_wrap_QCursor_setShape(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QCursor * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QCursor_setShape",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QCursor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QCursor_setShape. Expected _QCursor_p.");
        return NULL;
        }
    }
    QCursor_setShape(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_QCursor_setPos(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _arg0;
    int  _arg1;

    self = self;
    if(!PyArg_ParseTuple(args,"ii:QCursor_setPos",&_arg0,&_arg1)) 
        return NULL;
    QCursor::setPos(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define new_QFont() (new QFont())
static PyObject *_wrap_new_QFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_QFont")) 
        return NULL;
    _result = (QFont *)new_QFont();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFont_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QFontV(_swigarg0,_swigarg1,_swigarg2,_swigarg3) (new QFont(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_new_QFontV(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _result;
    char * _arg0;
    int  _arg1 = 12;
    int  _arg2 = QFont::Normal;
    bool  _arg3 = FALSE;
    int tempbool3;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s|iii:new_QFontV",&_arg0,&_arg1,&_arg2,&tempbool3)) 
        return NULL;
    _arg3 = (bool ) tempbool3;
    _result = (QFont *)new_QFontV(_arg0,_arg1,_arg2,_arg3);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFont_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QFontCopy(_swigarg0) (new QFont(_swigarg0))
static PyObject *_wrap_new_QFontCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _result;
    QFont * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QFontCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QFontCopy. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (QFont *)new_QFontCopy(*_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFont_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QFont_family(_swigobj)  (_swigobj->family())
static PyObject *_wrap_QFont_family(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_family",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_family. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (char *)QFont_family(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define QFont_setFamily(_swigobj,_swigarg0)  (_swigobj->setFamily(_swigarg0))
static PyObject *_wrap_QFont_setFamily(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QFont_setFamily",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setFamily. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setFamily(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFont_pointSize(_swigobj)  (_swigobj->pointSize())
static PyObject *_wrap_QFont_pointSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_pointSize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_pointSize. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (int )QFont_pointSize(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFont_setPointSize(_swigobj,_swigarg0)  (_swigobj->setPointSize(_swigarg0))
static PyObject *_wrap_QFont_setPointSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QFont_setPointSize",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setPointSize. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setPointSize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFont_weight(_swigobj)  (_swigobj->weight())
static PyObject *_wrap_QFont_weight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_weight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_weight. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (int )QFont_weight(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFont_setWeight(_swigobj,_swigarg0)  (_swigobj->setWeight(_swigarg0))
static PyObject *_wrap_QFont_setWeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QFont_setWeight",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setWeight. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setWeight(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFont_bold(_swigobj)  (_swigobj->bold())
static PyObject *_wrap_QFont_bold(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_bold",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_bold. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_bold(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFont_setBold(_swigobj,_swigarg0)  (_swigobj->setBold(_swigarg0))
static PyObject *_wrap_QFont_setBold(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;
    int tempbool1;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QFont_setBold",&_argc0,&tempbool1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setBold. Expected _QFont_p.");
        return NULL;
        }
    }
    _arg1 = (bool ) tempbool1;
    QFont_setBold(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFont_italic(_swigobj)  (_swigobj->italic())
static PyObject *_wrap_QFont_italic(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_italic",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_italic. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_italic(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFont_setItalic(_swigobj,_swigarg0)  (_swigobj->setItalic(_swigarg0))
static PyObject *_wrap_QFont_setItalic(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;
    int tempbool1;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QFont_setItalic",&_argc0,&tempbool1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setItalic. Expected _QFont_p.");
        return NULL;
        }
    }
    _arg1 = (bool ) tempbool1;
    QFont_setItalic(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFont_underline(_swigobj)  (_swigobj->underline())
static PyObject *_wrap_QFont_underline(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_underline",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_underline. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_underline(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFont_setUnderline(_swigobj,_swigarg0)  (_swigobj->setUnderline(_swigarg0))
static PyObject *_wrap_QFont_setUnderline(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;
    int tempbool1;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QFont_setUnderline",&_argc0,&tempbool1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setUnderline. Expected _QFont_p.");
        return NULL;
        }
    }
    _arg1 = (bool ) tempbool1;
    QFont_setUnderline(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFont_strikeOut(_swigobj)  (_swigobj->strikeOut())
static PyObject *_wrap_QFont_strikeOut(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_strikeOut",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_strikeOut. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_strikeOut(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFont_setStrikeOut(_swigobj,_swigarg0)  (_swigobj->setStrikeOut(_swigarg0))
static PyObject *_wrap_QFont_setStrikeOut(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;
    int tempbool1;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QFont_setStrikeOut",&_argc0,&tempbool1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setStrikeOut. Expected _QFont_p.");
        return NULL;
        }
    }
    _arg1 = (bool ) tempbool1;
    QFont_setStrikeOut(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFont_fixedPitch(_swigobj)  (_swigobj->fixedPitch())
static PyObject *_wrap_QFont_fixedPitch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_fixedPitch",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_fixedPitch. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_fixedPitch(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFont_setFixedPitch(_swigobj,_swigarg0)  (_swigobj->setFixedPitch(_swigarg0))
static PyObject *_wrap_QFont_setFixedPitch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;
    int tempbool1;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QFont_setFixedPitch",&_argc0,&tempbool1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setFixedPitch. Expected _QFont_p.");
        return NULL;
        }
    }
    _arg1 = (bool ) tempbool1;
    QFont_setFixedPitch(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFont_styleHint(_swigobj)  (_swigobj->styleHint())
static PyObject *_wrap_QFont_styleHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont::StyleHint  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_styleHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_styleHint. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (QFont::StyleHint )QFont_styleHint(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFont_setStyleHint(_swigobj,_swigarg0)  (_swigobj->setStyleHint(_swigarg0))
static PyObject *_wrap_QFont_setStyleHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    QFont::StyleHint  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QFont_setStyleHint",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setStyleHint. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setStyleHint(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFont_charSet(_swigobj)  (_swigobj->charSet())
static PyObject *_wrap_QFont_charSet(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont::CharSet  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_charSet",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_charSet. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (QFont::CharSet )QFont_charSet(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFont_setCharSet(_swigobj,_swigarg0)  (_swigobj->setCharSet(_swigarg0))
static PyObject *_wrap_QFont_setCharSet(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    QFont::CharSet  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QFont_setCharSet",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setCharSet. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont_setCharSet(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFont_rawMode(_swigobj)  (_swigobj->rawMode())
static PyObject *_wrap_QFont_rawMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_rawMode",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_rawMode. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_rawMode(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFont_setRawMode(_swigobj,_swigarg0)  (_swigobj->setRawMode(_swigarg0))
static PyObject *_wrap_QFont_setRawMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    bool  _arg1;
    char * _argc0 = 0;
    int tempbool1;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QFont_setRawMode",&_argc0,&tempbool1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setRawMode. Expected _QFont_p.");
        return NULL;
        }
    }
    _arg1 = (bool ) tempbool1;
    QFont_setRawMode(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFont_exactMatch(_swigobj)  (_swigobj->exactMatch())
static PyObject *_wrap_QFont_exactMatch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_exactMatch",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_exactMatch. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (bool )QFont_exactMatch(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QFont_defaultFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":QFont_defaultFont")) 
        return NULL;
    const QFont & _result_ref = QFont::defaultFont();
    _result = (QFont *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFont_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static PyObject *_wrap_QFont_setDefaultFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_setDefaultFont",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFont_setDefaultFont. Expected _QFont_p.");
        return NULL;
        }
    }
    QFont::setDefaultFont(*_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_QFont_substitute(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    char * _arg0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_substitute",&_arg0)) 
        return NULL;
    _result = (char *)QFont::substitute(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static PyObject *_wrap_QFont_insertSubstitution(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _arg0;
    char * _arg1;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QFont_insertSubstitution",&_arg0,&_arg1)) 
        return NULL;
    QFont::insertSubstitution(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyObject *_wrap_QFont_removeSubstitution(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _arg0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFont_removeSubstitution",&_arg0)) 
        return NULL;
    QFont::removeSubstitution(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define new_QFontInfo(_swigarg0) (new QFontInfo(_swigarg0))
static PyObject *_wrap_new_QFontInfo(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontInfo * _result;
    QFont * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QFontInfo",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QFontInfo. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (QFontInfo *)new_QFontInfo(*_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFontInfo_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QFontInfoCopy(_swigarg0) (new QFontInfo(_swigarg0))
static PyObject *_wrap_new_QFontInfoCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontInfo * _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QFontInfoCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QFontInfoCopy. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (QFontInfo *)new_QFontInfoCopy(*_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFontInfo_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_QFontInfo(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_QFontInfo(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_QFontInfo",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QFontInfo. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    delete_QFontInfo(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFontInfo_family(_swigobj)  (_swigobj->family())
static PyObject *_wrap_QFontInfo_family(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_family",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_family. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (char *)QFontInfo_family(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define QFontInfo_pointSize(_swigobj)  (_swigobj->pointSize())
static PyObject *_wrap_QFontInfo_pointSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_pointSize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_pointSize. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (int )QFontInfo_pointSize(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontInfo_italic(_swigobj)  (_swigobj->italic())
static PyObject *_wrap_QFontInfo_italic(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_italic",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_italic. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_italic(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontInfo_weight(_swigobj)  (_swigobj->weight())
static PyObject *_wrap_QFontInfo_weight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_weight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_weight. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (int )QFontInfo_weight(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontInfo_bold(_swigobj)  (_swigobj->bold())
static PyObject *_wrap_QFontInfo_bold(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_bold",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_bold. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_bold(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontInfo_underline(_swigobj)  (_swigobj->underline())
static PyObject *_wrap_QFontInfo_underline(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_underline",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_underline. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_underline(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontInfo_strikeOut(_swigobj)  (_swigobj->strikeOut())
static PyObject *_wrap_QFontInfo_strikeOut(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_strikeOut",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_strikeOut. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_strikeOut(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontInfo_fixedPitch(_swigobj)  (_swigobj->fixedPitch())
static PyObject *_wrap_QFontInfo_fixedPitch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_fixedPitch",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_fixedPitch. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_fixedPitch(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontInfo_styleHint(_swigobj)  (_swigobj->styleHint())
static PyObject *_wrap_QFontInfo_styleHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont::StyleHint  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_styleHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_styleHint. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (QFont::StyleHint )QFontInfo_styleHint(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontInfo_charSet(_swigobj)  (_swigobj->charSet())
static PyObject *_wrap_QFontInfo_charSet(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont::CharSet  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_charSet",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_charSet. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (QFont::CharSet )QFontInfo_charSet(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontInfo_rawMode(_swigobj)  (_swigobj->rawMode())
static PyObject *_wrap_QFontInfo_rawMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_rawMode",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_rawMode. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_rawMode(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontInfo_exactMatch(_swigobj)  (_swigobj->exactMatch())
static PyObject *_wrap_QFontInfo_exactMatch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QFontInfo * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontInfo_exactMatch",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontInfo_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontInfo_exactMatch. Expected _QFontInfo_p.");
        return NULL;
        }
    }
    _result = (bool )QFontInfo_exactMatch(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define new_QFontMetrics(_swigarg0) (new QFontMetrics(_swigarg0))
static PyObject *_wrap_new_QFontMetrics(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontMetrics * _result;
    QFont * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QFontMetrics",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QFontMetrics. Expected _QFont_p.");
        return NULL;
        }
    }
    _result = (QFontMetrics *)new_QFontMetrics(*_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFontMetrics_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QFontMetricsCopy(_swigarg0) (new QFontMetrics(_swigarg0))
static PyObject *_wrap_new_QFontMetricsCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontMetrics * _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QFontMetricsCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QFontMetricsCopy. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (QFontMetrics *)new_QFontMetricsCopy(*_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFontMetrics_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_QFontMetrics(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_QFontMetrics(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_QFontMetrics",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QFontMetrics. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    delete_QFontMetrics(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QFontMetrics_ascent(_swigobj)  (_swigobj->ascent())
static PyObject *_wrap_QFontMetrics_ascent(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontMetrics_ascent",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_ascent. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_ascent(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontMetrics_descent(_swigobj)  (_swigobj->descent())
static PyObject *_wrap_QFontMetrics_descent(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontMetrics_descent",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_descent. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_descent(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontMetrics_height(_swigobj)  (_swigobj->height())
static PyObject *_wrap_QFontMetrics_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontMetrics_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_height. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontMetrics_leading(_swigobj)  (_swigobj->leading())
static PyObject *_wrap_QFontMetrics_leading(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontMetrics_leading",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_leading. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_leading(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontMetrics_lineSpacing(_swigobj)  (_swigobj->lineSpacing())
static PyObject *_wrap_QFontMetrics_lineSpacing(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontMetrics_lineSpacing",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_lineSpacing. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_lineSpacing(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontMetrics_width(_swigobj,_swigarg0,_swigarg1)  (_swigobj->width(_swigarg0,_swigarg1))
static PyObject *_wrap_QFontMetrics_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|i:QFontMetrics_width",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_width. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_width(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontMetrics_charWidth(_swigobj,_swigarg0)  (_swigobj->width(_swigarg0))
static PyObject *_wrap_QFontMetrics_charWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sc:QFontMetrics_charWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_charWidth. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_charWidth(_arg0,_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontMetrics_maxWidth(_swigobj)  (_swigobj->maxWidth())
static PyObject *_wrap_QFontMetrics_maxWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontMetrics_maxWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_maxWidth. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_maxWidth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontMetrics_underlinePos(_swigobj)  (_swigobj->underlinePos())
static PyObject *_wrap_QFontMetrics_underlinePos(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontMetrics_underlinePos",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_underlinePos. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_underlinePos(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontMetrics_strikeOutPos(_swigobj)  (_swigobj->strikeOutPos())
static PyObject *_wrap_QFontMetrics_strikeOutPos(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontMetrics_strikeOutPos",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_strikeOutPos. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_strikeOutPos(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QFontMetrics_lineWidth(_swigobj)  (_swigobj->lineWidth())
static PyObject *_wrap_QFontMetrics_lineWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QFontMetrics * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QFontMetrics_lineWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QFontMetrics_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QFontMetrics_lineWidth. Expected _QFontMetrics_p.");
        return NULL;
        }
    }
    _result = (int )QFontMetrics_lineWidth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define delete_QPaintDevice(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_QPaintDevice(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPaintDevice * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_QPaintDevice",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QPaintDevice. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    delete_QPaintDevice(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QPaintDevice_devType(_swigobj)  (_swigobj->devType())
static PyObject *_wrap_QPaintDevice_devType(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPaintDevice * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPaintDevice_devType",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPaintDevice_devType. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    _result = (int )QPaintDevice_devType(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPaintDevice_isExtDev(_swigobj)  (_swigobj->isExtDev())
static PyObject *_wrap_QPaintDevice_isExtDev(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPaintDevice * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPaintDevice_isExtDev",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPaintDevice_isExtDev. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    _result = (bool )QPaintDevice_isExtDev(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPaintDevice_paintingActive(_swigobj)  (_swigobj->paintingActive())
static PyObject *_wrap_QPaintDevice_paintingActive(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPaintDevice * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPaintDevice_paintingActive",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPaintDevice_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPaintDevice_paintingActive. Expected _QPaintDevice_p.");
        return NULL;
        }
    }
    _result = (bool )QPaintDevice_paintingActive(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static void *SwigQPixmapToQPaintDevice(void *ptr) {
    QPixmap *src;
    QPaintDevice *dest;
    src = (QPixmap *) ptr;
    dest = (QPaintDevice *) src;
    return (void *) dest;
}

#define new_QPixmap() (new QPixmap())
static PyObject *_wrap_new_QPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_QPixmap")) 
        return NULL;
    _result = (QPixmap *)new_QPixmap();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QPixmapSize(_swigarg0,_swigarg1,_swigarg2) (new QPixmap(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_QPixmapSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    int  _arg0;
    int  _arg1;
    int  _arg2 = -1;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ii|i:new_QPixmapSize",&_arg0,&_arg1,&_arg2)) 
        return NULL;
    _result = (QPixmap *)new_QPixmapSize(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_PixmapFile(_swigarg0,_swigarg1,_swigarg2) (new QPixmap(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_PixmapFile(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    char * _arg0;
    char * _arg1 = 0;
    QPixmap::ColorMode  _arg2 = QPixmap::Auto;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s|si:new_PixmapFile",&_arg0,&_arg1,&_arg2)) 
        return NULL;
    _result = (QPixmap *)new_PixmapFile(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_PixmapCopy(_swigarg0) (new QPixmap(_swigarg0))
static PyObject *_wrap_new_PixmapCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    QPixmap * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_PixmapCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_PixmapCopy. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)new_PixmapCopy(*_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_QPixmap(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_QPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_QPixmap",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    delete_QPixmap(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QPixmap_isNull(_swigobj)  (_swigobj->isNull())
static PyObject *_wrap_QPixmap_isNull(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPixmap_isNull",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_isNull. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_isNull(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_width(_swigobj)  (_swigobj->width())
static PyObject *_wrap_QPixmap_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPixmap_width",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_width. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (int )QPixmap_width(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_height(_swigobj)  (_swigobj->height())
static PyObject *_wrap_QPixmap_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPixmap_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_height. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (int )QPixmap_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_depth(_swigobj)  (_swigobj->depth())
static PyObject *_wrap_QPixmap_depth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPixmap_depth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_depth. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (int )QPixmap_depth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_resize(_swigobj,_swigarg0,_swigarg1)  (_swigobj->resize(_swigarg0,_swigarg1))
static PyObject *_wrap_QPixmap_resize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:QPixmap_resize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_resize. Expected _QPixmap_p.");
        return NULL;
        }
    }
    QPixmap_resize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QPixmap_mask(_swigobj)  (_swigobj->mask())
static PyObject *_wrap_QPixmap_mask(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    QPixmap * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPixmap_mask",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_mask. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (QBitmap *)QPixmap_mask(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QPixmap_setMask(_swigobj,_swigarg0)  (_swigobj->setMask(_swigarg0))
static PyObject *_wrap_QPixmap_setMask(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    QBitmap * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QPixmap_setMask",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_setMask. Expected _QPixmap_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QBitmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QPixmap_setMask. Expected _QBitmap_p.");
        return NULL;
        }
    }
    QPixmap_setMask(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QPixmap_selfMask(_swigobj)  (_swigobj->selfMask())
static PyObject *_wrap_QPixmap_selfMask(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPixmap_selfMask",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_selfMask. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_selfMask(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_createHeuristicMask(_swigobj,_swigarg0)  (_swigobj->createHeuristicMask(_swigarg0))
static PyObject *_wrap_QPixmap_createHeuristicMask(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    QPixmap * _arg0;
    bool  _arg1 = TRUE;
    char * _argc0 = 0;
    int tempbool1;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s|i:QPixmap_createHeuristicMask",&_argc0,&tempbool1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_createHeuristicMask. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _arg1 = (bool ) tempbool1;
    _result = new QBitmap (QPixmap_createHeuristicMask(_arg0,_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QPixmap_load(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->load(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_QPixmap_load(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _arg1;
    char * _arg2 = 0;
    QPixmap::ColorMode  _arg3 = QPixmap::Auto;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|si:QPixmap_load",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_load. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_load(_arg0,_arg1,_arg2,_arg3);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_loadFromData(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->loadFromData(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_QPixmap_loadFromData(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    uchar * _arg1;
    uint * _arg2;
    char * _arg3 = 0;
    QPixmap::ColorMode  _arg4 = QPixmap::Auto;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sss|si:QPixmap_loadFromData",&_argc0,&_argc1,&_argc2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_loadFromData. Expected _QPixmap_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_uchar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QPixmap_loadFromData. Expected _uchar_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_uint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QPixmap_loadFromData. Expected _uint_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_loadFromData(_arg0,_arg1,*_arg2,_arg3,_arg4);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_save(_swigobj,_swigarg0,_swigarg1)  (_swigobj->save(_swigarg0,_swigarg1))
static PyObject *_wrap_QPixmap_save(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _arg1;
    char * _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sss:QPixmap_save",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_save. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_save(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_serialNumber(_swigobj)  (_swigobj->serialNumber())
static PyObject *_wrap_QPixmap_serialNumber(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPixmap_serialNumber",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_serialNumber. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (int )QPixmap_serialNumber(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_isOptimized(_swigobj)  (_swigobj->isOptimized())
static PyObject *_wrap_QPixmap_isOptimized(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPixmap_isOptimized",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_isOptimized. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_isOptimized(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_optimize(_swigobj,_swigarg0)  (_swigobj->optimize(_swigarg0))
static PyObject *_wrap_QPixmap_optimize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    bool  _arg1;
    char * _argc0 = 0;
    int tempbool1;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QPixmap_optimize",&_argc0,&tempbool1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_optimize. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _arg1 = (bool ) tempbool1;
    QPixmap_optimize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QPixmap_detach(_swigobj)  (_swigobj->detach())
static PyObject *_wrap_QPixmap_detach(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPixmap_detach",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_detach. Expected _QPixmap_p.");
        return NULL;
        }
    }
    QPixmap_detach(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QPixmap_isQBitmap(_swigobj)  (_swigobj->isQBitmap())
static PyObject *_wrap_QPixmap_isQBitmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPixmap_isQBitmap",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_isQBitmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_isQBitmap(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static PyObject *_wrap_QPixmap_defaultDepth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;

    self = self;
    if(!PyArg_ParseTuple(args,":QPixmap_defaultDepth")) 
        return NULL;
    _result = (int )QPixmap::defaultDepth();
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_imageFormat(_swigobj,_swigarg0)  (_swigobj->imageFormat(_swigarg0))
static PyObject *_wrap_QPixmap_imageFormat(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    QPixmap * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QPixmap_imageFormat",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_imageFormat. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (char *)QPixmap_imageFormat(_arg0,_arg1);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define QPixmap_isGloballyOptimized(_swigobj)  (_swigobj->isGloballyOptimized())
static PyObject *_wrap_QPixmap_isGloballyOptimized(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPixmap * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPixmap_isGloballyOptimized",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_isGloballyOptimized. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _result = (bool )QPixmap_isGloballyOptimized(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPixmap_optimizeGlobally(_swigobj,_swigarg0)  (_swigobj->optimizeGlobally(_swigarg0))
static PyObject *_wrap_QPixmap_optimizeGlobally(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _arg0;
    bool  _arg1;
    char * _argc0 = 0;
    int tempbool1;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QPixmap_optimizeGlobally",&_argc0,&tempbool1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPixmap_optimizeGlobally. Expected _QPixmap_p.");
        return NULL;
        }
    }
    _arg1 = (bool ) tempbool1;
    QPixmap_optimizeGlobally(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigQBitmapToQPixmap(void *ptr) {
    QBitmap *src;
    QPixmap *dest;
    src = (QBitmap *) ptr;
    dest = (QPixmap *) src;
    return (void *) dest;
}

static void *SwigQBitmapToQPaintDevice(void *ptr) {
    QBitmap *src;
    QPaintDevice *dest;
    src = (QBitmap *) ptr;
    dest = (QPaintDevice *) src;
    return (void *) dest;
}

#define new_QBitmap() (new QBitmap())
static PyObject *_wrap_new_QBitmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_QBitmap")) 
        return NULL;
    _result = (QBitmap *)new_QBitmap();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QBitmapSize(_swigarg0,_swigarg1,_swigarg2) (new QBitmap(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_QBitmapSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    int  _arg0;
    int  _arg1;
    bool  _arg2 = FALSE;
    int tempbool2;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ii|i:new_QBitmapSize",&_arg0,&_arg1,&tempbool2)) 
        return NULL;
    _arg2 = (bool ) tempbool2;
    _result = (QBitmap *)new_QBitmapSize(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QBitmapSizeData(_swigarg0,_swigarg1,_swigarg2,_swigarg3) (new QBitmap(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_new_QBitmapSizeData(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    int  _arg0;
    int  _arg1;
    uchar * _arg2;
    bool  _arg3 = FALSE;
    char * _argc2 = 0;
    int tempbool3;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"iis|i:new_QBitmapSizeData",&_arg0,&_arg1,&_argc2,&tempbool3)) 
        return NULL;
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_uchar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of new_QBitmapSizeData. Expected _uchar_p.");
        return NULL;
        }
    }
    _arg3 = (bool ) tempbool3;
    _result = (QBitmap *)new_QBitmapSizeData(_arg0,_arg1,_arg2,_arg3);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QBitmapCopy(_swigarg0) (new QBitmap(_swigarg0))
static PyObject *_wrap_new_QBitmapCopy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    QBitmap * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:new_QBitmapCopy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QBitmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QBitmapCopy. Expected _QBitmap_p.");
        return NULL;
        }
    }
    _result = (QBitmap *)new_QBitmapCopy(*_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QBitmapLoad(_swigarg0,_swigarg1) (new QBitmap(_swigarg0,_swigarg1))
static PyObject *_wrap_new_QBitmapLoad(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QBitmap * _result;
    char * _arg0;
    char * _arg1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s|s:new_QBitmapLoad",&_arg0,&_arg1)) 
        return NULL;
    _result = (QBitmap *)new_QBitmapLoad(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QBitmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QPoint() (new QPoint())
static PyObject *_wrap_new_QPoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_QPoint")) 
        return NULL;
    _result = (QPoint *)new_QPoint();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QPointV(_swigarg0,_swigarg1) (new QPoint(_swigarg0,_swigarg1))
static PyObject *_wrap_new_QPointV(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    int  _arg0;
    int  _arg1;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ii:new_QPointV",&_arg0,&_arg1)) 
        return NULL;
    _result = (QPoint *)new_QPointV(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QPoint_isNull(_swigobj)  (_swigobj->isNull())
static PyObject *_wrap_QPoint_isNull(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QPoint * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPoint_isNull",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPoint_isNull. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = (bool )QPoint_isNull(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPoint_x(_swigobj)  (_swigobj->x())
static PyObject *_wrap_QPoint_x(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPoint * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPoint_x",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPoint_x. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = (int )QPoint_x(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPoint_y(_swigobj)  (_swigobj->y())
static PyObject *_wrap_QPoint_y(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QPoint * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QPoint_y",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPoint_y. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = (int )QPoint_y(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QPoint_setX(_swigobj,_swigarg0)  (_swigobj->setX(_swigarg0))
static PyObject *_wrap_QPoint_setX(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QPoint_setX",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPoint_setX. Expected _QPoint_p.");
        return NULL;
        }
    }
    QPoint_setX(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QPoint_setY(_swigobj,_swigarg0)  (_swigobj->setY(_swigarg0))
static PyObject *_wrap_QPoint_setY(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QPoint_setY",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QPoint_setY. Expected _QPoint_p.");
        return NULL;
        }
    }
    QPoint_setY(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define new_QRect() (new QRect())
static PyObject *_wrap_new_QRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_QRect")) 
        return NULL;
    _result = (QRect *)new_QRect();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QRectPoints(_swigarg0,_swigarg1) (new QRect(_swigarg0,_swigarg1))
static PyObject *_wrap_new_QRectPoints(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    QPoint * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss:new_QRectPoints",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QRectPoints. Expected _QPoint_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_QRectPoints. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = (QRect *)new_QRectPoints(*_arg0,*_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QRectPointSize(_swigarg0,_swigarg1) (new QRect(_swigarg0,_swigarg1))
static PyObject *_wrap_new_QRectPointSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    QPoint * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss:new_QRectPointSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QRectPointSize. Expected _QPoint_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_QRectPointSize. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (QRect *)new_QRectPointSize(*_arg0,*_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QRectLTWH(_swigarg0,_swigarg1,_swigarg2,_swigarg3) (new QRect(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_new_QRectLTWH(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    int  _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"iiii:new_QRectLTWH",&_arg0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    _result = (QRect *)new_QRectLTWH(_arg0,_arg1,_arg2,_arg3);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QRect_isNull(_swigobj)  (_swigobj->isNull())
static PyObject *_wrap_QRect_isNull(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_isNull",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_isNull. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (bool )QRect_isNull(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_isEmpty(_swigobj)  (_swigobj->isEmpty())
static PyObject *_wrap_QRect_isEmpty(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_isEmpty",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_isEmpty. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (bool )QRect_isEmpty(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_isValid(_swigobj)  (_swigobj->isValid())
static PyObject *_wrap_QRect_isValid(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_isValid",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_isValid. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (bool )QRect_isValid(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_normalize(_swigobj)  (_swigobj->normalize())
static PyObject *_wrap_QRect_normalize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_normalize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_normalize. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QRect (QRect_normalize(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QRect_left(_swigobj)  (_swigobj->left())
static PyObject *_wrap_QRect_left(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_left",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_left. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_left(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_top(_swigobj)  (_swigobj->top())
static PyObject *_wrap_QRect_top(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_top",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_top. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_top(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_right(_swigobj)  (_swigobj->right())
static PyObject *_wrap_QRect_right(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_right",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_right. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_right(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_bottom(_swigobj)  (_swigobj->bottom())
static PyObject *_wrap_QRect_bottom(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_bottom",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_bottom. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_bottom(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_x(_swigobj)  (_swigobj->x())
static PyObject *_wrap_QRect_x(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_x",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_x. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_x(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_y(_swigobj)  (_swigobj->y())
static PyObject *_wrap_QRect_y(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_y",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_y. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_y(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_setLeft(_swigobj,_swigarg0)  (_swigobj->setLeft(_swigarg0))
static PyObject *_wrap_QRect_setLeft(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QRect_setLeft",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setLeft. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setLeft(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_setTop(_swigobj,_swigarg0)  (_swigobj->setTop(_swigarg0))
static PyObject *_wrap_QRect_setTop(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QRect_setTop",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setTop. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setTop(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_setRight(_swigobj,_swigarg0)  (_swigobj->setRight(_swigarg0))
static PyObject *_wrap_QRect_setRight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QRect_setRight",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setRight. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setRight(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_setBottom(_swigobj,_swigarg0)  (_swigobj->setBottom(_swigarg0))
static PyObject *_wrap_QRect_setBottom(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QRect_setBottom",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setBottom. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setBottom(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_setX(_swigobj,_swigarg0)  (_swigobj->setX(_swigarg0))
static PyObject *_wrap_QRect_setX(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QRect_setX",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setX. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setX(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_setY(_swigobj,_swigarg0)  (_swigobj->setY(_swigarg0))
static PyObject *_wrap_QRect_setY(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QRect_setY",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setY. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setY(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_topLeft(_swigobj)  (_swigobj->topLeft())
static PyObject *_wrap_QRect_topLeft(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_topLeft",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_topLeft. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QPoint (QRect_topLeft(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QRect_bottomRight(_swigobj)  (_swigobj->bottomRight())
static PyObject *_wrap_QRect_bottomRight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_bottomRight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_bottomRight. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QPoint (QRect_bottomRight(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QRect_topRight(_swigobj)  (_swigobj->topRight())
static PyObject *_wrap_QRect_topRight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_topRight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_topRight. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QPoint (QRect_topRight(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QRect_bottomLeft(_swigobj)  (_swigobj->bottomLeft())
static PyObject *_wrap_QRect_bottomLeft(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_bottomLeft",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_bottomLeft. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QPoint (QRect_bottomLeft(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QRect_center(_swigobj)  (_swigobj->center())
static PyObject *_wrap_QRect_center(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_center",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_center. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QPoint (QRect_center(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QRect_rect(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->rect(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_QRect_rect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int * _arg1;
    int * _arg2;
    int * _arg3;
    int * _arg4;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char * _argc3 = 0;
    char * _argc4 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sssss:QRect_rect",&_argc0,&_argc1,&_argc2,&_argc3,&_argc4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_rect. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_rect. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QRect_rect. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of QRect_rect. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc4) {
        if (SWIG_GetPtr(_argc4,(void **) &_arg4,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 5 of QRect_rect. Expected _int_p.");
        return NULL;
        }
    }
    QRect_rect(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_coords(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->coords(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_QRect_coords(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int * _arg1;
    int * _arg2;
    int * _arg3;
    int * _arg4;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;
    char * _argc3 = 0;
    char * _argc4 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sssss:QRect_coords",&_argc0,&_argc1,&_argc2,&_argc3,&_argc4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_coords. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_coords. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QRect_coords. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of QRect_coords. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc4) {
        if (SWIG_GetPtr(_argc4,(void **) &_arg4,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 5 of QRect_coords. Expected _int_p.");
        return NULL;
        }
    }
    QRect_coords(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_moveTopLeft(_swigobj,_swigarg0)  (_swigobj->moveTopLeft(_swigarg0))
static PyObject *_wrap_QRect_moveTopLeft(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QRect_moveTopLeft",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveTopLeft. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_moveTopLeft. Expected _QPoint_p.");
        return NULL;
        }
    }
    QRect_moveTopLeft(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_moveBottomRight(_swigobj,_swigarg0)  (_swigobj->moveBottomRight(_swigarg0))
static PyObject *_wrap_QRect_moveBottomRight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QRect_moveBottomRight",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveBottomRight. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_moveBottomRight. Expected _QPoint_p.");
        return NULL;
        }
    }
    QRect_moveBottomRight(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_moveTopRight(_swigobj,_swigarg0)  (_swigobj->moveTopRight(_swigarg0))
static PyObject *_wrap_QRect_moveTopRight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QRect_moveTopRight",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveTopRight. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_moveTopRight. Expected _QPoint_p.");
        return NULL;
        }
    }
    QRect_moveTopRight(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_moveBottomLeft(_swigobj,_swigarg0)  (_swigobj->moveBottomLeft(_swigarg0))
static PyObject *_wrap_QRect_moveBottomLeft(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QRect_moveBottomLeft",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveBottomLeft. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_moveBottomLeft. Expected _QPoint_p.");
        return NULL;
        }
    }
    QRect_moveBottomLeft(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_moveCenter(_swigobj,_swigarg0)  (_swigobj->moveCenter(_swigarg0))
static PyObject *_wrap_QRect_moveCenter(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QRect_moveCenter",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveCenter. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_moveCenter. Expected _QPoint_p.");
        return NULL;
        }
    }
    QRect_moveCenter(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_moveBy(_swigobj,_swigarg0,_swigarg1)  (_swigobj->moveBy(_swigarg0,_swigarg1))
static PyObject *_wrap_QRect_moveBy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:QRect_moveBy",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_moveBy. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_moveBy(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_setRect(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->setRect(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_QRect_setRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siiii:QRect_setRect",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setRect. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setRect(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_setCoords(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->setCoords(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_QRect_setCoords(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siiii:QRect_setCoords",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setCoords. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setCoords(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_size(_swigobj)  (_swigobj->size())
static PyObject *_wrap_QRect_size(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    QRect * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_size",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_size. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QSize (QRect_size(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QRect_width(_swigobj)  (_swigobj->width())
static PyObject *_wrap_QRect_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_width",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_width. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_width(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_height(_swigobj)  (_swigobj->height())
static PyObject *_wrap_QRect_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QRect * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QRect_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_height. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (int )QRect_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_setWidth(_swigobj,_swigarg0)  (_swigobj->setWidth(_swigarg0))
static PyObject *_wrap_QRect_setWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QRect_setWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setWidth. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setWidth(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_setHeight(_swigobj,_swigarg0)  (_swigobj->setHeight(_swigarg0))
static PyObject *_wrap_QRect_setHeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QRect_setHeight",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setHeight. Expected _QRect_p.");
        return NULL;
        }
    }
    QRect_setHeight(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_setSize(_swigobj,_swigarg0)  (_swigobj->setSize(_swigarg0))
static PyObject *_wrap_QRect_setSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QRect_setSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_setSize. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_setSize. Expected _QSize_p.");
        return NULL;
        }
    }
    QRect_setSize(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QRect_containsPoint(_swigobj,_swigarg0,_swigarg1)  (_swigobj->contains(_swigarg0,_swigarg1))
static PyObject *_wrap_QRect_containsPoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    QPoint * _arg1;
    bool  _arg2 = FALSE;
    char * _argc0 = 0;
    char * _argc1 = 0;
    int tempbool2;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|i:QRect_containsPoint",&_argc0,&_argc1,&tempbool2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_containsPoint. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_containsPoint. Expected _QPoint_p.");
        return NULL;
        }
    }
    _arg2 = (bool ) tempbool2;
    _result = (bool )QRect_containsPoint(_arg0,*_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_containsRect(_swigobj,_swigarg0,_swigarg1)  (_swigobj->contains(_swigarg0,_swigarg1))
static PyObject *_wrap_QRect_containsRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    QRect * _arg1;
    bool  _arg2 = FALSE;
    char * _argc0 = 0;
    char * _argc1 = 0;
    int tempbool2;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|i:QRect_containsRect",&_argc0,&_argc1,&tempbool2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_containsRect. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_containsRect. Expected _QRect_p.");
        return NULL;
        }
    }
    _arg2 = (bool ) tempbool2;
    _result = (bool )QRect_containsRect(_arg0,*_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QRect_unite(_swigobj,_swigarg0)  (_swigobj->unite(_swigarg0))
static PyObject *_wrap_QRect_unite(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    QRect * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QRect_unite",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_unite. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_unite. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QRect (QRect_unite(_arg0,*_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QRect_intersect(_swigobj,_swigarg0)  (_swigobj->intersect(_swigarg0))
static PyObject *_wrap_QRect_intersect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    QRect * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QRect_intersect",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_intersect. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_intersect. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = new QRect (QRect_intersect(_arg0,*_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QRect_intersects(_swigobj,_swigarg0)  (_swigobj->intersects(_swigarg0))
static PyObject *_wrap_QRect_intersects(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QRect * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QRect_intersects",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QRect_intersects. Expected _QRect_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QRect_intersects. Expected _QRect_p.");
        return NULL;
        }
    }
    _result = (bool )QRect_intersects(_arg0,*_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define new_QSize() (new QSize())
static PyObject *_wrap_new_QSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_QSize")) 
        return NULL;
    _result = (QSize *)new_QSize();
    SWIG_MakePtr(_ptemp, (char *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_QSizeV(_swigarg0,_swigarg1) (new QSize(_swigarg0,_swigarg1))
static PyObject *_wrap_new_QSizeV(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    int  _arg0;
    int  _arg1;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ii:new_QSizeV",&_arg0,&_arg1)) 
        return NULL;
    _result = (QSize *)new_QSizeV(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QSize_isNull(_swigobj)  (_swigobj->isNull())
static PyObject *_wrap_QSize_isNull(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QSize * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QSize_isNull",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_isNull. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (bool )QSize_isNull(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QSize_isEmpty(_swigobj)  (_swigobj->isEmpty())
static PyObject *_wrap_QSize_isEmpty(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QSize * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QSize_isEmpty",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_isEmpty. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (bool )QSize_isEmpty(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QSize_isValid(_swigobj)  (_swigobj->isValid())
static PyObject *_wrap_QSize_isValid(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QSize * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QSize_isValid",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_isValid. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (bool )QSize_isValid(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QSize_width(_swigobj)  (_swigobj->width())
static PyObject *_wrap_QSize_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QSize * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QSize_width",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_width. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (int )QSize_width(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QSize_height(_swigobj)  (_swigobj->height())
static PyObject *_wrap_QSize_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QSize * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QSize_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_height. Expected _QSize_p.");
        return NULL;
        }
    }
    _result = (int )QSize_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QSize_setWidth(_swigobj,_swigarg0)  (_swigobj->setWidth(_swigarg0))
static PyObject *_wrap_QSize_setWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QSize_setWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_setWidth. Expected _QSize_p.");
        return NULL;
        }
    }
    QSize_setWidth(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QSize_setHeight(_swigobj,_swigarg0)  (_swigobj->setHeight(_swigarg0))
static PyObject *_wrap_QSize_setHeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QSize_setHeight",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QSize_setHeight. Expected _QSize_p.");
        return NULL;
        }
    }
    QSize_setHeight(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define new_Object() (new Object())
static PyObject *_wrap_new_Object(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_Object")) 
        return NULL;
    _result = (Object *)new_Object();
    SWIG_MakePtr(_ptemp, (char *) _result,"_Object_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Object_connect(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->connect(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_Object_connect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _arg0;
    char * _arg1;
    PyObject * _arg2;
    PyObject * _arg3 = 0;
    char * _argc0 = 0;
    PyObject * _obj2 = 0;
    PyObject * _obj3 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssO|O:Object_connect",&_argc0,&_arg1,&_obj2,&_obj3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Object_connect. Expected _Object_p.");
        return NULL;
        }
    }
{
  if(!PyCallable_Check(_obj2))
  {
    PyErr_SetString(PyExc_TypeError, "Need a callable object!");
    return NULL;
  }
  _arg2 = _obj2;
}
    if (_obj3)
{
  _arg3 = _obj3;
}
    Object_connect(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Object_disconnect(_swigobj,_swigarg0,_swigarg1)  (_swigobj->disconnect(_swigarg0,_swigarg1))
static PyObject *_wrap_Object_disconnect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _arg0;
    PyObject * _arg1;
    char * _arg2 = "";
    char * _argc0 = 0;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sO|s:Object_disconnect",&_argc0,&_obj1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Object_disconnect. Expected _Object_p.");
        return NULL;
        }
    }
{
  if(!PyCallable_Check(_obj1))
  {
    PyErr_SetString(PyExc_TypeError, "Need a callable object!");
    return NULL;
  }
  _arg1 = _obj1;
}
    Object_disconnect(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Object_emit(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->emit(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_Object_emit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _arg0;
    char * _arg1;
    PyObject * _arg2;
    int  _arg3 = 0;
    char * _argc0 = 0;
    PyObject * _obj2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssO|i:Object_emit",&_argc0,&_arg1,&_obj2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Object_emit. Expected _Object_p.");
        return NULL;
        }
    }
{
  _arg2 = _obj2;
}
    Object_emit(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Object_timerConnection(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->timerConnection(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_Object_timerConnection(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _arg0;
    char * _arg1;
    int  _arg2;
    PyObject * _arg3;
    PyObject * _arg4 = 0;
    char * _argc0 = 0;
    PyObject * _obj3 = 0;
    PyObject * _obj4 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssiO|O:Object_timerConnection",&_argc0,&_arg1,&_arg2,&_obj3,&_obj4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Object_timerConnection. Expected _Object_p.");
        return NULL;
        }
    }
{
  if(!PyCallable_Check(_obj3))
  {
    PyErr_SetString(PyExc_TypeError, "Need a callable object!");
    return NULL;
  }
  _arg3 = _obj3;
}
    if (_obj4)
{
  _arg4 = _obj4;
}
    Object_timerConnection(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Object_killTimer(_swigobj,_swigarg0)  (_swigobj->killTimer(_swigarg0))
static PyObject *_wrap_Object_killTimer(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Object * _arg0;
    char * _arg1 = "";
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|s:Object_killTimer",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Object_killTimer. Expected _Object_p.");
        return NULL;
        }
    }
    Object_killTimer(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigApplicationToObject(void *ptr) {
    Application *src;
    Object *dest;
    src = (Application *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_Application() (new Application())
static PyObject *_wrap_new_Application(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_Application")) 
        return NULL;
    _result = (Application *)new_Application();
    SWIG_MakePtr(_ptemp, (char *) _result,"_Application_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_Application(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_Application(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_Application",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_Application. Expected _Application_p.");
        return NULL;
        }
    }
    delete_Application(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Application_argc(_swigobj)  (_swigobj->argc())
static PyObject *_wrap_Application_argc(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Application * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Application_argc",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_argc. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (int )Application_argc(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Application_argv(_swigobj)  (_swigobj->argv())
static PyObject *_wrap_Application_argv(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char ** _result;
    Application * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Application_argv",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_argv. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (char **)Application_argv(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_char_pp");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Application_mainWidget(_swigobj)  (_swigobj->mainWidget())
static PyObject *_wrap_Application_mainWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Application * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Application_mainWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_mainWidget. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (Widget *)Application_mainWidget(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Application_setMainWidget(_swigobj,_swigarg0)  (_swigobj->setMainWidget(_swigarg0))
static PyObject *_wrap_Application_setMainWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    Widget * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Application_setMainWidget",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_setMainWidget. Expected _Application_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Application_setMainWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    Application_setMainWidget(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Application_focusWidget(_swigobj)  (_swigobj->focusWidget())
static PyObject *_wrap_Application_focusWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Application * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Application_focusWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_focusWidget. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (Widget *)Application_focusWidget(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Application_execLoop(_swigobj)  (_swigobj->exec())
static PyObject *_wrap_Application_execLoop(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Application * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Application_execLoop",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_execLoop. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (int )Application_execLoop(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Application_processEvents(_swigobj)  (_swigobj->processEvents())
static PyObject *_wrap_Application_processEvents(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Application_processEvents",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_processEvents. Expected _Application_p.");
        return NULL;
        }
    }
    Application_processEvents(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Application_enter_loop(_swigobj)  (_swigobj->enter_loop())
static PyObject *_wrap_Application_enter_loop(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Application * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Application_enter_loop",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_enter_loop. Expected _Application_p.");
        return NULL;
        }
    }
    _result = (int )Application_enter_loop(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Application_exit_loop(_swigobj)  (_swigobj->exit_loop())
static PyObject *_wrap_Application_exit_loop(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Application_exit_loop",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_exit_loop. Expected _Application_p.");
        return NULL;
        }
    }
    Application_exit_loop(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Application_quit(_swigobj)  (_swigobj->quit())
static PyObject *_wrap_Application_quit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Application_quit",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_quit. Expected _Application_p.");
        return NULL;
        }
    }
    Application_quit(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Application_lastWindowClosed(_swigobj)  (_swigobj->lastWindowClosed())
static PyObject *_wrap_Application_lastWindowClosed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Application_lastWindowClosed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_lastWindowClosed. Expected _Application_p.");
        return NULL;
        }
    }
    Application_lastWindowClosed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Application_setOverrideCursor(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setOverrideCursor(_swigarg0,_swigarg1))
static PyObject *_wrap_Application_setOverrideCursor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    QCursor * _arg1;
    bool  _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;
    int tempbool2;

    self = self;
    if(!PyArg_ParseTuple(args,"ssi:Application_setOverrideCursor",&_argc0,&_argc1,&tempbool2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_setOverrideCursor. Expected _Application_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QCursor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Application_setOverrideCursor. Expected _QCursor_p.");
        return NULL;
        }
    }
    _arg2 = (bool ) tempbool2;
    Application_setOverrideCursor(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Application_restoreOverrideCursor(_swigobj)  (_swigobj->restoreOverrideCursor())
static PyObject *_wrap_Application_restoreOverrideCursor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Application * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Application_restoreOverrideCursor",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Application_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Application_restoreOverrideCursor. Expected _Application_p.");
        return NULL;
        }
    }
    Application_restoreOverrideCursor(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigLayoutToObject(void *ptr) {
    Layout *src;
    Object *dest;
    src = (Layout *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define Layout_defaultBorder(_swigobj)  (_swigobj->defaultBorder())
static PyObject *_wrap_Layout_defaultBorder(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Layout * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Layout_defaultBorder",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Layout_defaultBorder. Expected _Layout_p.");
        return NULL;
        }
    }
    _result = (int )Layout_defaultBorder(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Layout_activate(_swigobj)  (_swigobj->activate())
static PyObject *_wrap_Layout_activate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Layout * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Layout_activate",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Layout_activate. Expected _Layout_p.");
        return NULL;
        }
    }
    _result = (bool )Layout_activate(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Layout_freeze(_swigobj,_swigarg0,_swigarg1)  (_swigobj->freeze(_swigarg0,_swigarg1))
static PyObject *_wrap_Layout_freeze(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Layout * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:Layout_freeze",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Layout_freeze. Expected _Layout_p.");
        return NULL;
        }
    }
    Layout_freeze(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Layout_freezeThis(_swigobj)  (_swigobj->freeze())
static PyObject *_wrap_Layout_freezeThis(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Layout * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Layout_freezeThis",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Layout_freezeThis. Expected _Layout_p.");
        return NULL;
        }
    }
    Layout_freezeThis(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Layout_mainWidget(_swigobj)  (_swigobj->mainWidget())
static PyObject *_wrap_Layout_mainWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Layout * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Layout_mainWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Layout_mainWidget. Expected _Layout_p.");
        return NULL;
        }
    }
    _result = (Widget *)Layout_mainWidget(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void *SwigBoxLayoutToLayout(void *ptr) {
    BoxLayout *src;
    Layout *dest;
    src = (BoxLayout *) ptr;
    dest = (Layout *) src;
    return (void *) dest;
}

static void *SwigBoxLayoutToObject(void *ptr) {
    BoxLayout *src;
    Object *dest;
    src = (BoxLayout *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_BoxLayout(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4) (new BoxLayout(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4))
static PyObject *_wrap_new_BoxLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _result;
    Widget * _arg0;
    BoxLayout::Direction  _arg1;
    int  _arg2 = 0;
    int  _arg3 = -1;
    char * _arg4 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"si|iis:new_BoxLayout",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_BoxLayout. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (BoxLayout *)new_BoxLayout(_arg0,_arg1,_arg2,_arg3,_arg4);
    SWIG_MakePtr(_ptemp, (char *) _result,"_BoxLayout_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_BoxSubLayout(_swigarg0,_swigarg1,_swigarg2) (new BoxLayout(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_BoxSubLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _result;
    BoxLayout::Direction  _arg0;
    int  _arg1 = -1;
    char * _arg2 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"i|is:new_BoxSubLayout",&_arg0,&_arg1,&_arg2)) 
        return NULL;
    _result = (BoxLayout *)new_BoxSubLayout(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_BoxLayout_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_BoxLayout(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_BoxLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_BoxLayout",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_BoxLayout. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    delete_BoxLayout(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define BoxLayout_addWidget(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->addWidget(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_BoxLayout_addWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    Widget * _arg1;
    int  _arg2 = 0;
    int  _arg3 = AlignCenter;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|ii:BoxLayout_addWidget",&_argc0,&_argc1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_addWidget. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of BoxLayout_addWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    BoxLayout_addWidget(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define BoxLayout_addSpacing(_swigobj,_swigarg0)  (_swigobj->addSpacing(_swigarg0))
static PyObject *_wrap_BoxLayout_addSpacing(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:BoxLayout_addSpacing",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_addSpacing. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    BoxLayout_addSpacing(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define BoxLayout_addStretch(_swigobj,_swigarg0)  (_swigobj->addStretch(_swigarg0))
static PyObject *_wrap_BoxLayout_addStretch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    int  _arg1 = 0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|i:BoxLayout_addStretch",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_addStretch. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    BoxLayout_addStretch(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define BoxLayout_addLayout(_swigobj,_swigarg0,_swigarg1)  (_swigobj->addLayout(_swigarg0,_swigarg1))
static PyObject *_wrap_BoxLayout_addLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    Layout * _arg1;
    int  _arg2 = 0;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|i:BoxLayout_addLayout",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_addLayout. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of BoxLayout_addLayout. Expected _Layout_p.");
        return NULL;
        }
    }
    BoxLayout_addLayout(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define BoxLayout_direction(_swigobj)  (_swigobj->direction())
static PyObject *_wrap_BoxLayout_direction(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout::Direction  _result;
    BoxLayout * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:BoxLayout_direction",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_direction. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    _result = (BoxLayout::Direction )BoxLayout_direction(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define BoxLayout_addStrut(_swigobj,_swigarg0)  (_swigobj->addStrut(_swigarg0))
static PyObject *_wrap_BoxLayout_addStrut(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    BoxLayout * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:BoxLayout_addStrut",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_BoxLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of BoxLayout_addStrut. Expected _BoxLayout_p.");
        return NULL;
        }
    }
    BoxLayout_addStrut(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigGridLayoutToLayout(void *ptr) {
    GridLayout *src;
    Layout *dest;
    src = (GridLayout *) ptr;
    dest = (Layout *) src;
    return (void *) dest;
}

static void *SwigGridLayoutToObject(void *ptr) {
    GridLayout *src;
    Object *dest;
    src = (GridLayout *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_GridLayout(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5) (new GridLayout(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5))
static PyObject *_wrap_new_GridLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _result;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3 = 0;
    int  _arg4 = -1;
    char * _arg5 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"sii|iis:new_GridLayout",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4,&_arg5)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_GridLayout. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (GridLayout *)new_GridLayout(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
    SWIG_MakePtr(_ptemp, (char *) _result,"_GridLayout_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_GridSubLayout(_swigarg0,_swigarg1,_swigarg2,_swigarg3) (new GridLayout(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_new_GridSubLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _result;
    int  _arg0;
    int  _arg1;
    int  _arg2 = -1;
    char * _arg3 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ii|is:new_GridSubLayout",&_arg0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    _result = (GridLayout *)new_GridSubLayout(_arg0,_arg1,_arg2,_arg3);
    SWIG_MakePtr(_ptemp, (char *) _result,"_GridLayout_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_GridLayout(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_GridLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_GridLayout",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_GridLayout. Expected _GridLayout_p.");
        return NULL;
        }
    }
    delete_GridLayout(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define GridLayout_addWidget(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->addWidget(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_GridLayout_addWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    Widget * _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4 = 0;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssii|i:GridLayout_addWidget",&_argc0,&_argc1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GridLayout_addWidget. Expected _GridLayout_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of GridLayout_addWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    GridLayout_addWidget(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define GridLayout_addMultiCellWidget(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5)  (_swigobj->addMultiCellWidget(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5))
static PyObject *_wrap_GridLayout_addMultiCellWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    Widget * _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    int  _arg5;
    int  _arg6 = 0;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssiiii|i:GridLayout_addMultiCellWidget",&_argc0,&_argc1,&_arg2,&_arg3,&_arg4,&_arg5,&_arg6)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GridLayout_addMultiCellWidget. Expected _GridLayout_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of GridLayout_addMultiCellWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    GridLayout_addMultiCellWidget(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define GridLayout_addLayout(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->addLayout(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_GridLayout_addLayout(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    Layout * _arg1;
    int  _arg2;
    int  _arg3;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssii:GridLayout_addLayout",&_argc0,&_argc1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GridLayout_addLayout. Expected _GridLayout_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Layout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of GridLayout_addLayout. Expected _Layout_p.");
        return NULL;
        }
    }
    GridLayout_addLayout(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define GridLayout_setRowStretch(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setRowStretch(_swigarg0,_swigarg1))
static PyObject *_wrap_GridLayout_setRowStretch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:GridLayout_setRowStretch",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GridLayout_setRowStretch. Expected _GridLayout_p.");
        return NULL;
        }
    }
    GridLayout_setRowStretch(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define GridLayout_setColStretch(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setColStretch(_swigarg0,_swigarg1))
static PyObject *_wrap_GridLayout_setColStretch(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GridLayout * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:GridLayout_setColStretch",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GridLayout_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GridLayout_setColStretch. Expected _GridLayout_p.");
        return NULL;
        }
    }
    GridLayout_setColStretch(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigWidgetToObject(void *ptr) {
    Widget *src;
    Object *dest;
    src = (Widget *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_Widget(_swigarg0,_swigarg1,_swigarg2) (new Widget(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_Widget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    int  _arg2 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ssi:new_Widget",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_Widget. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Widget *)new_Widget(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_Widget(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_Widget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_Widget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_Widget. Expected _Widget_p.");
        return NULL;
        }
    }
    delete_Widget(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_isTopLevel(_swigobj)  (_swigobj->isTopLevel())
static PyObject *_wrap_Widget_isTopLevel(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_isTopLevel",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isTopLevel. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isTopLevel(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_isModal(_swigobj)  (_swigobj->isModal())
static PyObject *_wrap_Widget_isModal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_isModal",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isModal. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isModal(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_isPopup(_swigobj)  (_swigobj->isPopup())
static PyObject *_wrap_Widget_isPopup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_isPopup",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isPopup. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isPopup(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_isDesktop(_swigobj)  (_swigobj->isDesktop())
static PyObject *_wrap_Widget_isDesktop(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_isDesktop",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isDesktop. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isDesktop(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_isEnabled(_swigobj)  (_swigobj->isEnabled())
static PyObject *_wrap_Widget_isEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_isEnabled",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isEnabled. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isEnabled(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_setEnabled(_swigobj,_swigarg0)  (_swigobj->setEnabled(_swigarg0))
static PyObject *_wrap_Widget_setEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Widget_setEnabled",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setEnabled. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setEnabled(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_frameGeometry(_swigobj)  (_swigobj->frameGeometry())
static PyObject *_wrap_Widget_frameGeometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_frameGeometry",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_frameGeometry. Expected _Widget_p.");
        return NULL;
        }
    }
    const QRect & _result_ref = Widget_frameGeometry(_arg0);
    _result = (QRect *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_geometry(_swigobj)  (_swigobj->geometry())
static PyObject *_wrap_Widget_geometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_geometry",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_geometry. Expected _Widget_p.");
        return NULL;
        }
    }
    const QRect & _result_ref = Widget_geometry(_arg0);
    _result = (QRect *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_x(_swigobj)  (_swigobj->x())
static PyObject *_wrap_Widget_x(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_x",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_x. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (int )Widget_x(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_y(_swigobj)  (_swigobj->y())
static PyObject *_wrap_Widget_y(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_y",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_y. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (int )Widget_y(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_pos(_swigobj)  (_swigobj->pos())
static PyObject *_wrap_Widget_pos(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_pos",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_pos. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QPoint (Widget_pos(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_size(_swigobj)  (_swigobj->size())
static PyObject *_wrap_Widget_size(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_size",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_size. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QSize (Widget_size(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_width(_swigobj)  (_swigobj->width())
static PyObject *_wrap_Widget_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_width",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_width. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (int )Widget_width(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_height(_swigobj)  (_swigobj->height())
static PyObject *_wrap_Widget_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_height. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (int )Widget_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_rect(_swigobj)  (_swigobj->rect())
static PyObject *_wrap_Widget_rect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_rect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_rect. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QRect (Widget_rect(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_childrenRect(_swigobj)  (_swigobj->childrenRect())
static PyObject *_wrap_Widget_childrenRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_childrenRect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_childrenRect. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QRect (Widget_childrenRect(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_minimumSize(_swigobj)  (_swigobj->minimumSize())
static PyObject *_wrap_Widget_minimumSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_minimumSize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_minimumSize. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QSize (Widget_minimumSize(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_maximumSize(_swigobj)  (_swigobj->maximumSize())
static PyObject *_wrap_Widget_maximumSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_maximumSize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_maximumSize. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QSize (Widget_maximumSize(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_setMinimumQSize(_swigobj,_swigarg0)  (_swigobj->setMinimumSize(_swigarg0))
static PyObject *_wrap_Widget_setMinimumQSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setMinimumQSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setMinimumQSize. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setMinimumQSize. Expected _QSize_p.");
        return NULL;
        }
    }
    Widget_setMinimumQSize(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_setMinimumSize(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setMinimumSize(_swigarg0,_swigarg1))
static PyObject *_wrap_Widget_setMinimumSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:Widget_setMinimumSize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setMinimumSize. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setMinimumSize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_setMaximumQSize(_swigobj,_swigarg0)  (_swigobj->setMaximumSize(_swigarg0))
static PyObject *_wrap_Widget_setMaximumQSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setMaximumQSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setMaximumQSize. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setMaximumQSize. Expected _QSize_p.");
        return NULL;
        }
    }
    Widget_setMaximumQSize(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_setMaximumSize(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setMaximumSize(_swigarg0,_swigarg1))
static PyObject *_wrap_Widget_setMaximumSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:Widget_setMaximumSize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setMaximumSize. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setMaximumSize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_sizeIncrement(_swigobj)  (_swigobj->sizeIncrement())
static PyObject *_wrap_Widget_sizeIncrement(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_sizeIncrement",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_sizeIncrement. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QSize (Widget_sizeIncrement(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_setQSizeIncrement(_swigobj,_swigarg0)  (_swigobj->setSizeIncrement(_swigarg0))
static PyObject *_wrap_Widget_setQSizeIncrement(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setQSizeIncrement",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setQSizeIncrement. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setQSizeIncrement. Expected _QSize_p.");
        return NULL;
        }
    }
    Widget_setQSizeIncrement(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_setSizeIncrement(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setSizeIncrement(_swigarg0,_swigarg1))
static PyObject *_wrap_Widget_setSizeIncrement(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:Widget_setSizeIncrement",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setSizeIncrement. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setSizeIncrement(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_setFixedQSize(_swigobj,_swigarg0)  (_swigobj->setFixedSize(_swigarg0))
static PyObject *_wrap_Widget_setFixedQSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setFixedQSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setFixedQSize. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setFixedQSize. Expected _QSize_p.");
        return NULL;
        }
    }
    Widget_setFixedQSize(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_setFixedSize(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setFixedSize(_swigarg0,_swigarg1))
static PyObject *_wrap_Widget_setFixedSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:Widget_setFixedSize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setFixedSize. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setFixedSize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_mapToGlobal(_swigobj,_swigarg0)  (_swigobj->mapToGlobal(_swigarg0))
static PyObject *_wrap_Widget_mapToGlobal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    Widget * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_mapToGlobal",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_mapToGlobal. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_mapToGlobal. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = new QPoint (Widget_mapToGlobal(_arg0,*_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_mapFromGlobal(_swigobj,_swigarg0)  (_swigobj->mapFromGlobal(_swigarg0))
static PyObject *_wrap_Widget_mapFromGlobal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    Widget * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_mapFromGlobal",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_mapFromGlobal. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_mapFromGlobal. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = new QPoint (Widget_mapFromGlobal(_arg0,*_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_mapToParent(_swigobj,_swigarg0)  (_swigobj->mapToParent(_swigarg0))
static PyObject *_wrap_Widget_mapToParent(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    Widget * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_mapToParent",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_mapToParent. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_mapToParent. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = new QPoint (Widget_mapToParent(_arg0,*_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_mapFromParent(_swigobj,_swigarg0)  (_swigobj->mapFromParent(_swigarg0))
static PyObject *_wrap_Widget_mapFromParent(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPoint * _result;
    Widget * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_mapFromParent",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_mapFromParent. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_mapFromParent. Expected _QPoint_p.");
        return NULL;
        }
    }
    _result = new QPoint (Widget_mapFromParent(_arg0,*_arg1));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QPoint_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_topLevelWidget(_swigobj)  (_swigobj->topLevelWidget())
static PyObject *_wrap_Widget_topLevelWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_topLevelWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_topLevelWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Widget *)Widget_topLevelWidget(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_backgroundColor(_swigobj)  (_swigobj->backgroundColor())
static PyObject *_wrap_Widget_backgroundColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_backgroundColor",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_backgroundColor. Expected _Widget_p.");
        return NULL;
        }
    }
    const QColor & _result_ref = Widget_backgroundColor(_arg0);
    _result = (QColor *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_foregroundColor(_swigobj)  (_swigobj->foregroundColor())
static PyObject *_wrap_Widget_foregroundColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColor * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_foregroundColor",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_foregroundColor. Expected _Widget_p.");
        return NULL;
        }
    }
    const QColor & _result_ref = Widget_foregroundColor(_arg0);
    _result = (QColor *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_setBackgroundColor(_swigobj,_swigarg0)  (_swigobj->setBackgroundColor(_swigarg0))
static PyObject *_wrap_Widget_setBackgroundColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QColor * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setBackgroundColor",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setBackgroundColor. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setBackgroundColor. Expected _QColor_p.");
        return NULL;
        }
    }
    Widget_setBackgroundColor(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_backgroundPixmap(_swigobj)  (_swigobj->backgroundPixmap())
static PyObject *_wrap_Widget_backgroundPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_backgroundPixmap",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_backgroundPixmap. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)Widget_backgroundPixmap(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_setBackgroundPixmap(_swigobj,_swigarg0)  (_swigobj->setBackgroundPixmap(_swigarg0))
static PyObject *_wrap_Widget_setBackgroundPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QPixmap * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setBackgroundPixmap",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setBackgroundPixmap. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setBackgroundPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    Widget_setBackgroundPixmap(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_colorGroup(_swigobj)  (_swigobj->colorGroup())
static PyObject *_wrap_Widget_colorGroup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QColorGroup * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_colorGroup",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_colorGroup. Expected _Widget_p.");
        return NULL;
        }
    }
    const QColorGroup & _result_ref = Widget_colorGroup(_arg0);
    _result = (QColorGroup *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QColorGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_palette(_swigobj)  (_swigobj->palette())
static PyObject *_wrap_Widget_palette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPalette * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_palette",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_palette. Expected _Widget_p.");
        return NULL;
        }
    }
    const QPalette & _result_ref = Widget_palette(_arg0);
    _result = (QPalette *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPalette_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_setPalette(_swigobj,_swigarg0)  (_swigobj->setPalette(_swigarg0))
static PyObject *_wrap_Widget_setPalette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QPalette * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setPalette",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setPalette. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setPalette. Expected _QPalette_p.");
        return NULL;
        }
    }
    Widget_setPalette(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_font(_swigobj)  (_swigobj->font())
static PyObject *_wrap_Widget_font(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFont * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_font",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_font. Expected _Widget_p.");
        return NULL;
        }
    }
    const QFont & _result_ref = Widget_font(_arg0);
    _result = (QFont *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QFont_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_setFont(_swigobj,_swigarg0)  (_swigobj->setFont(_swigarg0))
static PyObject *_wrap_Widget_setFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QFont * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setFont",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setFont. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setFont. Expected _QFont_p.");
        return NULL;
        }
    }
    Widget_setFont(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_fontMetrics(_swigobj)  (_swigobj->fontMetrics())
static PyObject *_wrap_Widget_fontMetrics(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontMetrics * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_fontMetrics",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_fontMetrics. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QFontMetrics (Widget_fontMetrics(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QFontMetrics_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_fontInfo(_swigobj)  (_swigobj->fontInfo())
static PyObject *_wrap_Widget_fontInfo(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QFontInfo * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_fontInfo",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_fontInfo. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QFontInfo (Widget_fontInfo(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QFontInfo_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_cursor(_swigobj)  (_swigobj->cursor())
static PyObject *_wrap_Widget_cursor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QCursor * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_cursor",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_cursor. Expected _Widget_p.");
        return NULL;
        }
    }
    const QCursor & _result_ref = Widget_cursor(_arg0);
    _result = (QCursor *) &_result_ref;
    SWIG_MakePtr(_ptemp, (char *) _result,"_QCursor_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_setCursor(_swigobj,_swigarg0)  (_swigobj->setCursor(_swigarg0))
static PyObject *_wrap_Widget_setCursor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QCursor * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setCursor",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setCursor. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QCursor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setCursor. Expected _QCursor_p.");
        return NULL;
        }
    }
    Widget_setCursor(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_caption(_swigobj)  (_swigobj->caption())
static PyObject *_wrap_Widget_caption(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_caption",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_caption. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (char *)Widget_caption(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define Widget_setCaption(_swigobj,_swigarg0)  (_swigobj->setCaption(_swigarg0))
static PyObject *_wrap_Widget_setCaption(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setCaption",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setCaption. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setCaption(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_icon(_swigobj)  (_swigobj->icon())
static PyObject *_wrap_Widget_icon(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_icon",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_icon. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)Widget_icon(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_setIcon(_swigobj,_swigarg0)  (_swigobj->setIcon(_swigarg0))
static PyObject *_wrap_Widget_setIcon(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QPixmap * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setIcon",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setIcon. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setIcon. Expected _QPixmap_p.");
        return NULL;
        }
    }
    Widget_setIcon(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_iconText(_swigobj)  (_swigobj->iconText())
static PyObject *_wrap_Widget_iconText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_iconText",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_iconText. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (char *)Widget_iconText(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define Widget_setIconText(_swigobj,_swigarg0)  (_swigobj->setIconText(_swigarg0))
static PyObject *_wrap_Widget_setIconText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setIconText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setIconText. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setIconText(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_hasMouseTracking(_swigobj)  (_swigobj->hasMouseTracking())
static PyObject *_wrap_Widget_hasMouseTracking(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_hasMouseTracking",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_hasMouseTracking. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_hasMouseTracking(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_setMouseTracking(_swigobj,_swigarg0)  (_swigobj->setMouseTracking(_swigarg0))
static PyObject *_wrap_Widget_setMouseTracking(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Widget_setMouseTracking",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setMouseTracking. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setMouseTracking(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_isActiveWindow(_swigobj)  (_swigobj->isActiveWindow())
static PyObject *_wrap_Widget_isActiveWindow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_isActiveWindow",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isActiveWindow. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isActiveWindow(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_setActiveWindow(_swigobj)  (_swigobj->setActiveWindow())
static PyObject *_wrap_Widget_setActiveWindow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_setActiveWindow",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setActiveWindow. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setActiveWindow(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_isFocusEnabled(_swigobj)  (_swigobj->isFocusEnabled())
static PyObject *_wrap_Widget_isFocusEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_isFocusEnabled",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isFocusEnabled. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isFocusEnabled(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_focusPolicy(_swigobj)  (_swigobj->focusPolicy())
static PyObject *_wrap_Widget_focusPolicy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget::FocusPolicy  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_focusPolicy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_focusPolicy. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Widget::FocusPolicy )Widget_focusPolicy(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_setFocusPolicy(_swigobj,_swigarg0)  (_swigobj->setFocusPolicy(_swigarg0))
static PyObject *_wrap_Widget_setFocusPolicy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    Widget::FocusPolicy  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Widget_setFocusPolicy",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setFocusPolicy. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setFocusPolicy(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_hasFocus(_swigobj)  (_swigobj->hasFocus())
static PyObject *_wrap_Widget_hasFocus(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_hasFocus",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_hasFocus. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_hasFocus(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_setFocus(_swigobj)  (_swigobj->setFocus())
static PyObject *_wrap_Widget_setFocus(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_setFocus",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setFocus. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setFocus(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_clearFocus(_swigobj)  (_swigobj->clearFocus())
static PyObject *_wrap_Widget_clearFocus(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_clearFocus",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_clearFocus. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_clearFocus(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_grabMouse(_swigobj)  (_swigobj->grabMouse())
static PyObject *_wrap_Widget_grabMouse(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_grabMouse",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_grabMouse. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_grabMouse(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_grabMouseCursor(_swigobj,_swigarg0)  (_swigobj->grabMouse(_swigarg0))
static PyObject *_wrap_Widget_grabMouseCursor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QCursor * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_grabMouseCursor",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_grabMouseCursor. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QCursor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_grabMouseCursor. Expected _QCursor_p.");
        return NULL;
        }
    }
    Widget_grabMouseCursor(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_releaseMouse(_swigobj)  (_swigobj->releaseMouse())
static PyObject *_wrap_Widget_releaseMouse(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_releaseMouse",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_releaseMouse. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_releaseMouse(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_grabKeyboard(_swigobj)  (_swigobj->grabKeyboard())
static PyObject *_wrap_Widget_grabKeyboard(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_grabKeyboard",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_grabKeyboard. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_grabKeyboard(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_releaseKeyboard(_swigobj)  (_swigobj->releaseKeyboard())
static PyObject *_wrap_Widget_releaseKeyboard(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_releaseKeyboard",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_releaseKeyboard. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_releaseKeyboard(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_isUpdatesEnabled(_swigobj)  (_swigobj->isUpdatesEnabled())
static PyObject *_wrap_Widget_isUpdatesEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_isUpdatesEnabled",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isUpdatesEnabled. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isUpdatesEnabled(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_setUpdatesEnabled(_swigobj,_swigarg0)  (_swigobj->setUpdatesEnabled(_swigarg0))
static PyObject *_wrap_Widget_setUpdatesEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Widget_setUpdatesEnabled",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setUpdatesEnabled. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setUpdatesEnabled(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_update(_swigobj)  (_swigobj->update())
static PyObject *_wrap_Widget_update(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_update",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_update. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_update(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_updateRegion(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->update(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_Widget_updateRegion(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siiii:Widget_updateRegion",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_updateRegion. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_updateRegion(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_repaint(_swigobj,_swigarg0)  (_swigobj->repaint(_swigarg0))
static PyObject *_wrap_Widget_repaint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1 = 1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|i:Widget_repaint",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_repaint. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_repaint(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_repaintRegion(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4)  (_swigobj->repaint(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4))
static PyObject *_wrap_Widget_repaintRegion(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    int  _arg5 = 1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siiii|i:Widget_repaintRegion",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4,&_arg5)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_repaintRegion. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_repaintRegion(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_repaintRect(_swigobj,_swigarg0,_swigarg1)  (_swigobj->repaint(_swigarg0,_swigarg1))
static PyObject *_wrap_Widget_repaintRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QRect * _arg1;
    int  _arg2 = 1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|i:Widget_repaintRect",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_repaintRect. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_repaintRect. Expected _QRect_p.");
        return NULL;
        }
    }
    Widget_repaintRect(_arg0,*_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_show(_swigobj)  (_swigobj->show())
static PyObject *_wrap_Widget_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_show. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_hide(_swigobj)  (_swigobj->hide())
static PyObject *_wrap_Widget_hide(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_hide",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_hide. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_hide(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_iconify(_swigobj)  (_swigobj->iconify())
static PyObject *_wrap_Widget_iconify(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_iconify",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_iconify. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_iconify(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_close(_swigobj,_swigarg0)  (_swigobj->close(_swigarg0))
static PyObject *_wrap_Widget_close(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    int  _arg1 = 0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|i:Widget_close",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_close. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_close(_arg0,_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_isVisible(_swigobj)  (_swigobj->isVisible())
static PyObject *_wrap_Widget_isVisible(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_isVisible",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_isVisible. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (bool )Widget_isVisible(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Widget_raiseWidget(_swigobj)  (_swigobj->raise())
static PyObject *_wrap_Widget_raiseWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_raiseWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_raiseWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_raiseWidget(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_lowerWidget(_swigobj)  (_swigobj->lower())
static PyObject *_wrap_Widget_lowerWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_lowerWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_lowerWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_lowerWidget(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_move(_swigobj,_swigarg0,_swigarg1)  (_swigobj->move(_swigarg0,_swigarg1))
static PyObject *_wrap_Widget_move(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:Widget_move",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_move. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_move(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_movePoint(_swigobj,_swigarg0)  (_swigobj->move(_swigarg0))
static PyObject *_wrap_Widget_movePoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_movePoint",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_movePoint. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_movePoint. Expected _QPoint_p.");
        return NULL;
        }
    }
    Widget_movePoint(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_resize(_swigobj,_swigarg0,_swigarg1)  (_swigobj->resize(_swigarg0,_swigarg1))
static PyObject *_wrap_Widget_resize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:Widget_resize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_resize. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_resize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_resizeSize(_swigobj,_swigarg0)  (_swigobj->resize(_swigarg0))
static PyObject *_wrap_Widget_resizeSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_resizeSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_resizeSize. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_resizeSize. Expected _QSize_p.");
        return NULL;
        }
    }
    Widget_resizeSize(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_setGeometry(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->setGeometry(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_Widget_setGeometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siiii:Widget_setGeometry",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setGeometry. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_setGeometry(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_setGeometryRect(_swigobj,_swigarg0)  (_swigobj->setGeometry(_swigarg0))
static PyObject *_wrap_Widget_setGeometryRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_setGeometryRect",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_setGeometryRect. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_setGeometryRect. Expected _QRect_p.");
        return NULL;
        }
    }
    Widget_setGeometryRect(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_sizeHint(_swigobj)  (_swigobj->sizeHint())
static PyObject *_wrap_Widget_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_sizeHint. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = new QSize (Widget_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_adjustSize(_swigobj)  (_swigobj->adjustSize())
static PyObject *_wrap_Widget_adjustSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_adjustSize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_adjustSize. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_adjustSize(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_recreate(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4)  (_swigobj->recreate(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4))
static PyObject *_wrap_Widget_recreate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    Widget * _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    int  _arg5 = 1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssiii|i:Widget_recreate",&_argc0,&_argc1,&_arg2,&_arg3,&_arg4,&_arg5)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_recreate. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_recreate. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_recreate(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_erase(_swigobj)  (_swigobj->erase())
static PyObject *_wrap_Widget_erase(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_erase",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_erase. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_erase(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_eraseRection(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->erase(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_Widget_eraseRection(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siiii:Widget_eraseRection",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_eraseRection. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_eraseRection(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_eraseRect(_swigobj,_swigarg0)  (_swigobj->erase(_swigarg0))
static PyObject *_wrap_Widget_eraseRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_eraseRect",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_eraseRect. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_eraseRect. Expected _QRect_p.");
        return NULL;
        }
    }
    Widget_eraseRect(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_scroll(_swigobj,_swigarg0,_swigarg1)  (_swigobj->scroll(_swigarg0,_swigarg1))
static PyObject *_wrap_Widget_scroll(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:Widget_scroll",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_scroll. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_scroll(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_drawText(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->drawText(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_Widget_drawText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _arg3;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siis:Widget_drawText",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_drawText. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_drawText(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_drawTextPoint(_swigobj,_swigarg0,_swigarg1)  (_swigobj->drawText(_swigarg0,_swigarg1))
static PyObject *_wrap_Widget_drawTextPoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    QPoint * _arg1;
    char * _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sss:Widget_drawTextPoint",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_drawTextPoint. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Widget_drawTextPoint. Expected _QPoint_p.");
        return NULL;
        }
    }
    Widget_drawTextPoint(_arg0,*_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_parentWidget(_swigobj)  (_swigobj->parentWidget())
static PyObject *_wrap_Widget_parentWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Widget * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_parentWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_parentWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Widget *)Widget_parentWidget(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Widget_addPopupMenu(_swigobj,_swigarg0,_swigarg1)  (_swigobj->addPopupMenu(_swigarg0,_swigarg1))
static PyObject *_wrap_Widget_addPopupMenu(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _arg1;
    PopupMenu * _arg2;
    char * _argc0 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sss:Widget_addPopupMenu",&_argc0,&_arg1,&_argc2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_addPopupMenu. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of Widget_addPopupMenu. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    Widget_addPopupMenu(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_addSeparator(_swigobj)  (_swigobj->addSeparator())
static PyObject *_wrap_Widget_addSeparator(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Widget_addSeparator",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_addSeparator. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_addSeparator(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_addSplitter(_swigobj,_swigarg0,_swigarg1)  (_swigobj->addSplitter(_swigarg0,_swigarg1))
static PyObject *_wrap_Widget_addSplitter(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:Widget_addSplitter",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_addSplitter. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_addSplitter(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Widget_tooltip(_swigobj,_swigarg0)  (_swigobj->tooltip(_swigarg0))
static PyObject *_wrap_Widget_tooltip(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Widget_tooltip",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Widget_tooltip. Expected _Widget_p.");
        return NULL;
        }
    }
    Widget_tooltip(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigButtonToWidget(void *ptr) {
    Button *src;
    Widget *dest;
    src = (Button *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigButtonToObject(void *ptr) {
    Button *src;
    Object *dest;
    src = (Button *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_Button(_swigarg0,_swigarg1) (new Button(_swigarg0,_swigarg1))
static PyObject *_wrap_new_Button(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_Button",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_Button. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Button *)new_Button(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Button_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_Button(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_Button(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_Button",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_Button. Expected _Button_p.");
        return NULL;
        }
    }
    delete_Button(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Button_text(_swigobj)  (_swigobj->text())
static PyObject *_wrap_Button_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    Button * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Button_text",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_text. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (char *)Button_text(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define Button_setText(_swigobj,_swigarg0)  (_swigobj->setText(_swigarg0))
static PyObject *_wrap_Button_setText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Button_setText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_setText. Expected _Button_p.");
        return NULL;
        }
    }
    Button_setText(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Button_pixmap(_swigobj)  (_swigobj->pixmap())
static PyObject *_wrap_Button_pixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    Button * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Button_pixmap",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_pixmap. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)Button_pixmap(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Button_setPixmap(_swigobj,_swigarg0)  (_swigobj->setPixmap(_swigarg0))
static PyObject *_wrap_Button_setPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    QPixmap * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Button_setPixmap",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_setPixmap. Expected _Button_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Button_setPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    Button_setPixmap(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Button_isToggleButton(_swigobj)  (_swigobj->isToggleButton())
static PyObject *_wrap_Button_isToggleButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Button * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Button_isToggleButton",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_isToggleButton. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (bool )Button_isToggleButton(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Button_isDown(_swigobj)  (_swigobj->isDown())
static PyObject *_wrap_Button_isDown(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Button * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Button_isDown",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_isDown. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (bool )Button_isDown(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Button_isOn(_swigobj)  (_swigobj->isOn())
static PyObject *_wrap_Button_isOn(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Button * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Button_isOn",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_isOn. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (bool )Button_isOn(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Button_autoResize(_swigobj)  (_swigobj->autoResize())
static PyObject *_wrap_Button_autoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Button * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Button_autoResize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_autoResize. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (bool )Button_autoResize(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Button_setAutoResize(_swigobj,_swigarg0)  (_swigobj->setAutoResize(_swigarg0))
static PyObject *_wrap_Button_setAutoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Button_setAutoResize",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_setAutoResize. Expected _Button_p.");
        return NULL;
        }
    }
    Button_setAutoResize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Button_setAutoRepeat(_swigobj,_swigarg0)  (_swigobj->setAutoRepeat(_swigarg0))
static PyObject *_wrap_Button_setAutoRepeat(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Button_setAutoRepeat",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_setAutoRepeat. Expected _Button_p.");
        return NULL;
        }
    }
    Button_setAutoRepeat(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Button_autoRepeat(_swigobj)  (_swigobj->autoRepeat())
static PyObject *_wrap_Button_autoRepeat(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Button * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Button_autoRepeat",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_autoRepeat. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (bool )Button_autoRepeat(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Button_setDown(_swigobj,_swigarg0)  (_swigobj->setDown(_swigarg0))
static PyObject *_wrap_Button_setDown(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    bool  _arg1;
    char * _argc0 = 0;
    int tempbool1;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Button_setDown",&_argc0,&tempbool1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_setDown. Expected _Button_p.");
        return NULL;
        }
    }
    _arg1 = (bool ) tempbool1;
    Button_setDown(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Button_pressed(_swigobj)  (_swigobj->pressed())
static PyObject *_wrap_Button_pressed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Button_pressed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_pressed. Expected _Button_p.");
        return NULL;
        }
    }
    Button_pressed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Button_released(_swigobj)  (_swigobj->released())
static PyObject *_wrap_Button_released(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Button_released",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_released. Expected _Button_p.");
        return NULL;
        }
    }
    Button_released(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Button_clicked(_swigobj)  (_swigobj->clicked())
static PyObject *_wrap_Button_clicked(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Button_clicked",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_clicked. Expected _Button_p.");
        return NULL;
        }
    }
    Button_clicked(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Button_toggled(_swigobj,_swigarg0)  (_swigobj->toggled(_swigarg0))
static PyObject *_wrap_Button_toggled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Button_toggled",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Button_toggled. Expected _Button_p.");
        return NULL;
        }
    }
    Button_toggled(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigCheckBoxToButton(void *ptr) {
    CheckBox *src;
    Button *dest;
    src = (CheckBox *) ptr;
    dest = (Button *) src;
    return (void *) dest;
}

static void *SwigCheckBoxToWidget(void *ptr) {
    CheckBox *src;
    Widget *dest;
    src = (CheckBox *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigCheckBoxToObject(void *ptr) {
    CheckBox *src;
    Object *dest;
    src = (CheckBox *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_CheckBox(_swigarg0,_swigarg1,_swigarg2) (new CheckBox(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_CheckBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    CheckBox * _result;
    char * _arg0;
    Widget * _arg1;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss|s:new_CheckBox",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_CheckBox. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (CheckBox *)new_CheckBox(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_CheckBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_CheckBoxN(_swigarg0,_swigarg1) (new CheckBox(_swigarg0,_swigarg1))
static PyObject *_wrap_new_CheckBoxN(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    CheckBox * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_CheckBoxN",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_CheckBoxN. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (CheckBox *)new_CheckBoxN(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_CheckBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define CheckBox_isChecked(_swigobj)  (_swigobj->isChecked())
static PyObject *_wrap_CheckBox_isChecked(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    CheckBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:CheckBox_isChecked",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_CheckBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of CheckBox_isChecked. Expected _CheckBox_p.");
        return NULL;
        }
    }
    _result = (bool )CheckBox_isChecked(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define CheckBox_setChecked(_swigobj,_swigarg0)  (_swigobj->setChecked(_swigarg0))
static PyObject *_wrap_CheckBox_setChecked(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    CheckBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:CheckBox_setChecked",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_CheckBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of CheckBox_setChecked. Expected _CheckBox_p.");
        return NULL;
        }
    }
    CheckBox_setChecked(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define CheckBox_sizeHint(_swigobj)  (_swigobj->sizeHint())
static PyObject *_wrap_CheckBox_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    CheckBox * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:CheckBox_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_CheckBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of CheckBox_sizeHint. Expected _CheckBox_p.");
        return NULL;
        }
    }
    _result = new QSize (CheckBox_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void *SwigPushButtonToButton(void *ptr) {
    PushButton *src;
    Button *dest;
    src = (PushButton *) ptr;
    dest = (Button *) src;
    return (void *) dest;
}

static void *SwigPushButtonToWidget(void *ptr) {
    PushButton *src;
    Widget *dest;
    src = (PushButton *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigPushButtonToObject(void *ptr) {
    PushButton *src;
    Object *dest;
    src = (PushButton *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_PushButtonN(_swigarg0,_swigarg1) (new PushButton(_swigarg0,_swigarg1))
static PyObject *_wrap_new_PushButtonN(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_PushButtonN",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_PushButtonN. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (PushButton *)new_PushButtonN(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_PushButton_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_PushButton(_swigarg0,_swigarg1,_swigarg2) (new PushButton(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_PushButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _result;
    char * _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s|ss:new_PushButton",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_PushButton. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (PushButton *)new_PushButton(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_PushButton_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define PushButton_setToggleButton(_swigobj,_swigarg0)  (_swigobj->setToggleButton(_swigarg0))
static PyObject *_wrap_PushButton_setToggleButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:PushButton_setToggleButton",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setToggleButton. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_setToggleButton(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PushButton_autoDefault(_swigobj)  (_swigobj->autoDefault())
static PyObject *_wrap_PushButton_autoDefault(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    PushButton * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:PushButton_autoDefault",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_autoDefault. Expected _PushButton_p.");
        return NULL;
        }
    }
    _result = (bool )PushButton_autoDefault(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define PushButton_setAutoDefault(_swigobj,_swigarg0)  (_swigobj->setAutoDefault(_swigarg0))
static PyObject *_wrap_PushButton_setAutoDefault(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:PushButton_setAutoDefault",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setAutoDefault. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_setAutoDefault(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PushButton_isDefault(_swigobj)  (_swigobj->isDefault())
static PyObject *_wrap_PushButton_isDefault(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    PushButton * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:PushButton_isDefault",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_isDefault. Expected _PushButton_p.");
        return NULL;
        }
    }
    _result = (bool )PushButton_isDefault(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define PushButton_setDefault(_swigobj,_swigarg0)  (_swigobj->setDefault(_swigarg0))
static PyObject *_wrap_PushButton_setDefault(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:PushButton_setDefault",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setDefault. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_setDefault(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PushButton_sizeHint(_swigobj)  (_swigobj->sizeHint())
static PyObject *_wrap_PushButton_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    PushButton * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:PushButton_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_sizeHint. Expected _PushButton_p.");
        return NULL;
        }
    }
    _result = new QSize (PushButton_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define PushButton_move(_swigobj,_swigarg0,_swigarg1)  (_swigobj->move(_swigarg0,_swigarg1))
static PyObject *_wrap_PushButton_move(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:PushButton_move",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_move. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_move(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PushButton_movePoint(_swigobj,_swigarg0)  (_swigobj->move(_swigarg0))
static PyObject *_wrap_PushButton_movePoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:PushButton_movePoint",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_movePoint. Expected _PushButton_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of PushButton_movePoint. Expected _QPoint_p.");
        return NULL;
        }
    }
    PushButton_movePoint(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PushButton_resize(_swigobj,_swigarg0,_swigarg1)  (_swigobj->resize(_swigarg0,_swigarg1))
static PyObject *_wrap_PushButton_resize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:PushButton_resize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_resize. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_resize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PushButton_resizeSize(_swigobj,_swigarg0)  (_swigobj->resize(_swigarg0))
static PyObject *_wrap_PushButton_resizeSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:PushButton_resizeSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_resizeSize. Expected _PushButton_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of PushButton_resizeSize. Expected _QSize_p.");
        return NULL;
        }
    }
    PushButton_resizeSize(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PushButton_setGeometry(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->setGeometry(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_PushButton_setGeometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siiii:PushButton_setGeometry",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setGeometry. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_setGeometry(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PushButton_setGeometryRect(_swigobj,_swigarg0)  (_swigobj->setGeometry(_swigarg0))
static PyObject *_wrap_PushButton_setGeometryRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:PushButton_setGeometryRect",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setGeometryRect. Expected _PushButton_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of PushButton_setGeometryRect. Expected _QRect_p.");
        return NULL;
        }
    }
    PushButton_setGeometryRect(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PushButton_setOn(_swigobj,_swigarg0)  (_swigobj->setOn(_swigarg0))
static PyObject *_wrap_PushButton_setOn(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:PushButton_setOn",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_setOn. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_setOn(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PushButton_toggle(_swigobj)  (_swigobj->toggle())
static PyObject *_wrap_PushButton_toggle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PushButton * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:PushButton_toggle",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PushButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PushButton_toggle. Expected _PushButton_p.");
        return NULL;
        }
    }
    PushButton_toggle(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigRadioButtonToButton(void *ptr) {
    RadioButton *src;
    Button *dest;
    src = (RadioButton *) ptr;
    dest = (Button *) src;
    return (void *) dest;
}

static void *SwigRadioButtonToWidget(void *ptr) {
    RadioButton *src;
    Widget *dest;
    src = (RadioButton *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigRadioButtonToObject(void *ptr) {
    RadioButton *src;
    Object *dest;
    src = (RadioButton *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_RadioButton(_swigarg0,_swigarg1,_swigarg2) (new RadioButton(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_RadioButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    RadioButton * _result;
    char * _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s|ss:new_RadioButton",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_RadioButton. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (RadioButton *)new_RadioButton(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_RadioButton_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_RadioButtonN(_swigarg0,_swigarg1) (new RadioButton(_swigarg0,_swigarg1))
static PyObject *_wrap_new_RadioButtonN(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    RadioButton * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_RadioButtonN",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_RadioButtonN. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (RadioButton *)new_RadioButtonN(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_RadioButton_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define RadioButton_isChecked(_swigobj)  (_swigobj->isChecked())
static PyObject *_wrap_RadioButton_isChecked(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    RadioButton * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:RadioButton_isChecked",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_RadioButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of RadioButton_isChecked. Expected _RadioButton_p.");
        return NULL;
        }
    }
    _result = (bool )RadioButton_isChecked(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define RadioButton_setChecked(_swigobj,_swigarg0)  (_swigobj->setChecked(_swigarg0))
static PyObject *_wrap_RadioButton_setChecked(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    RadioButton * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:RadioButton_setChecked",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_RadioButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of RadioButton_setChecked. Expected _RadioButton_p.");
        return NULL;
        }
    }
    RadioButton_setChecked(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define RadioButton_sizeHint(_swigobj)  (_swigobj->sizeHint())
static PyObject *_wrap_RadioButton_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    RadioButton * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:RadioButton_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_RadioButton_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of RadioButton_sizeHint. Expected _RadioButton_p.");
        return NULL;
        }
    }
    _result = new QSize (RadioButton_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void *SwigComboBoxToWidget(void *ptr) {
    ComboBox *src;
    Widget *dest;
    src = (ComboBox *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigComboBoxToObject(void *ptr) {
    ComboBox *src;
    Object *dest;
    src = (ComboBox *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_ComboBox(_swigarg0,_swigarg1,_swigarg2) (new ComboBox(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_ComboBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _result;
    int  _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"i|ss:new_ComboBox",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_ComboBox. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ComboBox *)new_ComboBox(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ComboBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_ComboBoxOld(_swigarg0,_swigarg1) (new ComboBox(_swigarg0,_swigarg1))
static PyObject *_wrap_new_ComboBoxOld(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_ComboBoxOld",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_ComboBoxOld. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ComboBox *)new_ComboBoxOld(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ComboBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_ComboBox(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_ComboBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_ComboBox",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_ComboBox. Expected _ComboBox_p.");
        return NULL;
        }
    }
    delete_ComboBox(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_count(_swigobj)  (_swigobj->count())
static PyObject *_wrap_ComboBox_count(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ComboBox_count",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_count. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (int )ComboBox_count(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ComboBox_insertList(_swigobj,_swigarg0)  (_swigobj->insertList(_swigarg0))
static PyObject *_wrap_ComboBox_insertList(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    PyObject * _arg1;
    char * _argc0 = 0;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sO:ComboBox_insertList",&_argc0,&_obj1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_insertList. Expected _ComboBox_p.");
        return NULL;
        }
    }
{
  if(!PySequence_Check(_obj1))
  {
    PyErr_SetString(PyExc_TypeError, "Need a list!");
    return NULL;
  }
  _arg1 = _obj1;
}
    ComboBox_insertList(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_insertText(_swigobj,_swigarg0,_swigarg1)  (_swigobj->insertItem(_swigarg0,_swigarg1))
static PyObject *_wrap_ComboBox_insertText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    char * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|i:ComboBox_insertText",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_insertText. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_insertText(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_insertPixmap(_swigobj,_swigarg0,_swigarg1)  (_swigobj->insertItem(_swigarg0,_swigarg1))
static PyObject *_wrap_ComboBox_insertPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    QPixmap * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|i:ComboBox_insertPixmap",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_insertPixmap. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_insertPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    ComboBox_insertPixmap(_arg0,*_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_removeItem(_swigobj,_swigarg0)  (_swigobj->removeItem(_swigarg0))
static PyObject *_wrap_ComboBox_removeItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ComboBox_removeItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_removeItem. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_removeItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_clear(_swigobj)  (_swigobj->clear())
static PyObject *_wrap_ComboBox_clear(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ComboBox_clear",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_clear. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_clear(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_currentText(_swigobj)  (_swigobj->currentText())
static PyObject *_wrap_ComboBox_currentText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ComboBox_currentText",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_currentText. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (char *)ComboBox_currentText(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define ComboBox_text(_swigobj,_swigarg0)  (_swigobj->text(_swigarg0))
static PyObject *_wrap_ComboBox_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ComboBox_text",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_text. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (char *)ComboBox_text(_arg0,_arg1);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define ComboBox_pixmap(_swigobj,_swigarg0)  (_swigobj->pixmap(_swigarg0))
static PyObject *_wrap_ComboBox_pixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"si:ComboBox_pixmap",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_pixmap. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)ComboBox_pixmap(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define ComboBox_changeText(_swigobj,_swigarg0,_swigarg1)  (_swigobj->changeItem(_swigarg0,_swigarg1))
static PyObject *_wrap_ComboBox_changeText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    char * _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssi:ComboBox_changeText",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_changeText. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_changeText(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_changePixmap(_swigobj,_swigarg0,_swigarg1)  (_swigobj->changeItem(_swigarg0,_swigarg1))
static PyObject *_wrap_ComboBox_changePixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    QPixmap * _arg1;
    int  _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssi:ComboBox_changePixmap",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_changePixmap. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_changePixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    ComboBox_changePixmap(_arg0,*_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_currentItem(_swigobj)  (_swigobj->currentItem())
static PyObject *_wrap_ComboBox_currentItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ComboBox_currentItem",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_currentItem. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (int )ComboBox_currentItem(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ComboBox_setCurrentItem(_swigobj,_swigarg0)  (_swigobj->setCurrentItem(_swigarg0))
static PyObject *_wrap_ComboBox_setCurrentItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ComboBox_setCurrentItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setCurrentItem. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_setCurrentItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_autoResize(_swigobj)  (_swigobj->autoResize())
static PyObject *_wrap_ComboBox_autoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ComboBox_autoResize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_autoResize. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (bool )ComboBox_autoResize(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ComboBox_setAutoResize(_swigobj,_swigarg0)  (_swigobj->setAutoResize(_swigarg0))
static PyObject *_wrap_ComboBox_setAutoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ComboBox_setAutoResize",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setAutoResize. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_setAutoResize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_sizeHint(_swigobj)  (_swigobj->sizeHint())
static PyObject *_wrap_ComboBox_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    ComboBox * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:ComboBox_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_sizeHint. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = new QSize (ComboBox_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define ComboBox_setBackgroundColor(_swigobj,_swigarg0)  (_swigobj->setBackgroundColor(_swigarg0))
static PyObject *_wrap_ComboBox_setBackgroundColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    QColor * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:ComboBox_setBackgroundColor",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setBackgroundColor. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QColor_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_setBackgroundColor. Expected _QColor_p.");
        return NULL;
        }
    }
    ComboBox_setBackgroundColor(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_setPalette(_swigobj,_swigarg0)  (_swigobj->setPalette(_swigarg0))
static PyObject *_wrap_ComboBox_setPalette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    QPalette * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:ComboBox_setPalette",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setPalette. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_setPalette. Expected _QPalette_p.");
        return NULL;
        }
    }
    ComboBox_setPalette(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_setFont(_swigobj,_swigarg0)  (_swigobj->setFont(_swigarg0))
static PyObject *_wrap_ComboBox_setFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    QFont * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:ComboBox_setFont",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setFont. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_setFont. Expected _QFont_p.");
        return NULL;
        }
    }
    ComboBox_setFont(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_setEnabled(_swigobj,_swigarg0)  (_swigobj->setEnabled(_swigarg0))
static PyObject *_wrap_ComboBox_setEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ComboBox_setEnabled",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setEnabled. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_setEnabled(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_setSizeLimit(_swigobj,_swigarg0)  (_swigobj->setSizeLimit(_swigarg0))
static PyObject *_wrap_ComboBox_setSizeLimit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ComboBox_setSizeLimit",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setSizeLimit. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_setSizeLimit(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_sizeLimit(_swigobj)  (_swigobj->sizeLimit())
static PyObject *_wrap_ComboBox_sizeLimit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ComboBox_sizeLimit",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_sizeLimit. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (int )ComboBox_sizeLimit(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ComboBox_setMaxCount(_swigobj,_swigarg0)  (_swigobj->setMaxCount(_swigarg0))
static PyObject *_wrap_ComboBox_setMaxCount(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ComboBox_setMaxCount",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setMaxCount. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_setMaxCount(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_maxCount(_swigobj)  (_swigobj->maxCount())
static PyObject *_wrap_ComboBox_maxCount(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ComboBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ComboBox_maxCount",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_maxCount. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = (int )ComboBox_maxCount(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ComboBox_setInsertionPolicy(_swigobj,_swigarg0)  (_swigobj->setInsertionPolicy(_swigarg0))
static PyObject *_wrap_ComboBox_setInsertionPolicy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    ComboBox::Policy * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:ComboBox_setInsertionPolicy",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_setInsertionPolicy. Expected _ComboBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_ComboBox::Policy_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ComboBox_setInsertionPolicy. Expected _ComboBox::Policy_p.");
        return NULL;
        }
    }
    ComboBox_setInsertionPolicy(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_InsertionPolicy(_swigobj,_swigarg0)  (_swigobj->InsertionPolicy(_swigarg0))
static PyObject *_wrap_ComboBox_InsertionPolicy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:ComboBox_InsertionPolicy",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_InsertionPolicy. Expected _ComboBox_p.");
        return NULL;
        }
    }
    ComboBox_InsertionPolicy(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ComboBox_insertionPolicy(_swigobj)  (_swigobj->insertionPolicy())
static PyObject *_wrap_ComboBox_insertionPolicy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ComboBox::Policy * _result;
    ComboBox * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:ComboBox_insertionPolicy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ComboBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ComboBox_insertionPolicy. Expected _ComboBox_p.");
        return NULL;
        }
    }
    _result = new ComboBox::Policy (ComboBox_insertionPolicy(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_ComboBox::Policy_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void *SwigDialogToWidget(void *ptr) {
    Dialog *src;
    Widget *dest;
    src = (Dialog *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigDialogToObject(void *ptr) {
    Dialog *src;
    Object *dest;
    src = (Dialog *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_Dialog(_swigarg0,_swigarg1,_swigarg2) (new Dialog(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_Dialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    int  _arg2 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ssi:new_Dialog",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_Dialog. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Dialog *)new_Dialog(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Dialog_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_Dialog(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_Dialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_Dialog",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_Dialog. Expected _Dialog_p.");
        return NULL;
        }
    }
    delete_Dialog(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Dialog_execDialog(_swigobj)  (_swigobj->exec())
static PyObject *_wrap_Dialog_execDialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Dialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Dialog_execDialog",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_execDialog. Expected _Dialog_p.");
        return NULL;
        }
    }
    _result = (int )Dialog_execDialog(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Dialog_result(_swigobj)  (_swigobj->result())
static PyObject *_wrap_Dialog_result(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Dialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Dialog_result",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_result. Expected _Dialog_p.");
        return NULL;
        }
    }
    _result = (int )Dialog_result(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Dialog_show(_swigobj)  (_swigobj->show())
static PyObject *_wrap_Dialog_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Dialog_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_show. Expected _Dialog_p.");
        return NULL;
        }
    }
    Dialog_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Dialog_move(_swigobj,_swigarg0,_swigarg1)  (_swigobj->move(_swigarg0,_swigarg1))
static PyObject *_wrap_Dialog_move(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:Dialog_move",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_move. Expected _Dialog_p.");
        return NULL;
        }
    }
    Dialog_move(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Dialog_movePoint(_swigobj,_swigarg0)  (_swigobj->move(_swigarg0))
static PyObject *_wrap_Dialog_movePoint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    QPoint * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Dialog_movePoint",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_movePoint. Expected _Dialog_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPoint_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Dialog_movePoint. Expected _QPoint_p.");
        return NULL;
        }
    }
    Dialog_movePoint(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Dialog_resize(_swigobj,_swigarg0,_swigarg1)  (_swigobj->resize(_swigarg0,_swigarg1))
static PyObject *_wrap_Dialog_resize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:Dialog_resize",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_resize. Expected _Dialog_p.");
        return NULL;
        }
    }
    Dialog_resize(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Dialog_resizeSize(_swigobj,_swigarg0)  (_swigobj->resize(_swigarg0))
static PyObject *_wrap_Dialog_resizeSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    QSize * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Dialog_resizeSize",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_resizeSize. Expected _Dialog_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QSize_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Dialog_resizeSize. Expected _QSize_p.");
        return NULL;
        }
    }
    Dialog_resizeSize(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Dialog_setGeometry(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->setGeometry(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_Dialog_setGeometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siiii:Dialog_setGeometry",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_setGeometry. Expected _Dialog_p.");
        return NULL;
        }
    }
    Dialog_setGeometry(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Dialog_setGeometryRect(_swigobj,_swigarg0)  (_swigobj->setGeometry(_swigarg0))
static PyObject *_wrap_Dialog_setGeometryRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Dialog * _arg0;
    QRect * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Dialog_setGeometryRect",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Dialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Dialog_setGeometryRect. Expected _Dialog_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QRect_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Dialog_setGeometryRect. Expected _QRect_p.");
        return NULL;
        }
    }
    Dialog_setGeometryRect(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigTabDialogToDialog(void *ptr) {
    TabDialog *src;
    Dialog *dest;
    src = (TabDialog *) ptr;
    dest = (Dialog *) src;
    return (void *) dest;
}

static void *SwigTabDialogToWidget(void *ptr) {
    TabDialog *src;
    Widget *dest;
    src = (TabDialog *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigTabDialogToObject(void *ptr) {
    TabDialog *src;
    Object *dest;
    src = (TabDialog *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_TabDialog(_swigarg0,_swigarg1,_swigarg2) (new TabDialog(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_TabDialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    int  _arg2 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ssi:new_TabDialog",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_TabDialog. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (TabDialog *)new_TabDialog(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_TabDialog_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_TabDialog(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_TabDialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_TabDialog",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_TabDialog. Expected _TabDialog_p.");
        return NULL;
        }
    }
    delete_TabDialog(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define TabDialog_show(_swigobj)  (_swigobj->show())
static PyObject *_wrap_TabDialog_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:TabDialog_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_show. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define TabDialog_setFont(_swigobj,_swigarg0)  (_swigobj->setFont(_swigarg0))
static PyObject *_wrap_TabDialog_setFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    QFont * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:TabDialog_setFont",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_setFont. Expected _TabDialog_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of TabDialog_setFont. Expected _QFont_p.");
        return NULL;
        }
    }
    TabDialog_setFont(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define TabDialog_addTab(_swigobj,_swigarg0,_swigarg1)  (_swigobj->addTab(_swigarg0,_swigarg1))
static PyObject *_wrap_TabDialog_addTab(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    Widget * _arg1;
    char * _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sss:TabDialog_addTab",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_addTab. Expected _TabDialog_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of TabDialog_addTab. Expected _Widget_p.");
        return NULL;
        }
    }
    TabDialog_addTab(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define TabDialog_isTabEnabled(_swigobj,_swigarg0)  (_swigobj->isTabEnabled(_swigarg0))
static PyObject *_wrap_TabDialog_isTabEnabled(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    TabDialog * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:TabDialog_isTabEnabled",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_isTabEnabled. Expected _TabDialog_p.");
        return NULL;
        }
    }
    _result = (bool )TabDialog_isTabEnabled(_arg0,_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define TabDialog_setDefaultButton(_swigobj,_swigarg0)  (_swigobj->setDefaultButton(_swigarg0))
static PyObject *_wrap_TabDialog_setDefaultButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _arg1 = "Defaults";
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|s:TabDialog_setDefaultButton",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_setDefaultButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_setDefaultButton(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define TabDialog_hasDefaultButton(_swigobj)  (_swigobj->hasDefaultButton())
static PyObject *_wrap_TabDialog_hasDefaultButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    TabDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:TabDialog_hasDefaultButton",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_hasDefaultButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    _result = (bool )TabDialog_hasDefaultButton(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define TabDialog_setCancelButton(_swigobj,_swigarg0)  (_swigobj->setCancelButton(_swigarg0))
static PyObject *_wrap_TabDialog_setCancelButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _arg1 = "Cancel";
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|s:TabDialog_setCancelButton",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_setCancelButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_setCancelButton(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define TabDialog_hasCancelButton(_swigobj)  (_swigobj->hasCancelButton())
static PyObject *_wrap_TabDialog_hasCancelButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    TabDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:TabDialog_hasCancelButton",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_hasCancelButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    _result = (bool )TabDialog_hasCancelButton(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define TabDialog_setApplyButton(_swigobj,_swigarg0)  (_swigobj->setApplyButton(_swigarg0))
static PyObject *_wrap_TabDialog_setApplyButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _arg1 = "Apply";
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|s:TabDialog_setApplyButton",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_setApplyButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_setApplyButton(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define TabDialog_hasApplyButton(_swigobj)  (_swigobj->hasApplyButton())
static PyObject *_wrap_TabDialog_hasApplyButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    TabDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:TabDialog_hasApplyButton",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_hasApplyButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    _result = (bool )TabDialog_hasApplyButton(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define TabDialog_setOKButton(_swigobj,_swigarg0)  (_swigobj->setOKButton(_swigarg0))
static PyObject *_wrap_TabDialog_setOKButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _arg1 = "OK";
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|s:TabDialog_setOKButton",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_setOKButton. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_setOKButton(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define TabDialog_aboutToShow(_swigobj)  (_swigobj->aboutToShow())
static PyObject *_wrap_TabDialog_aboutToShow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:TabDialog_aboutToShow",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_aboutToShow. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_aboutToShow(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define TabDialog_applyButtonPressed(_swigobj)  (_swigobj->applyButtonPressed())
static PyObject *_wrap_TabDialog_applyButtonPressed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:TabDialog_applyButtonPressed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_applyButtonPressed. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_applyButtonPressed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define TabDialog_cancelButtonPressed(_swigobj)  (_swigobj->cancelButtonPressed())
static PyObject *_wrap_TabDialog_cancelButtonPressed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:TabDialog_cancelButtonPressed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_cancelButtonPressed. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_cancelButtonPressed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define TabDialog_defaultButtonPressed(_swigobj)  (_swigobj->defaultButtonPressed())
static PyObject *_wrap_TabDialog_defaultButtonPressed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TabDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:TabDialog_defaultButtonPressed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TabDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of TabDialog_defaultButtonPressed. Expected _TabDialog_p.");
        return NULL;
        }
    }
    TabDialog_defaultButtonPressed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigLineEditToWidget(void *ptr) {
    LineEdit *src;
    Widget *dest;
    src = (LineEdit *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigLineEditToObject(void *ptr) {
    LineEdit *src;
    Object *dest;
    src = (LineEdit *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_LineEdit(_swigarg0,_swigarg1) (new LineEdit(_swigarg0,_swigarg1))
static PyObject *_wrap_new_LineEdit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_LineEdit",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_LineEdit. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (LineEdit *)new_LineEdit(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_LineEdit_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_LineEdit(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_LineEdit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_LineEdit",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_LineEdit. Expected _LineEdit_p.");
        return NULL;
        }
    }
    delete_LineEdit(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define LineEdit_text(_swigobj)  (_swigobj->text())
static PyObject *_wrap_LineEdit_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    LineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:LineEdit_text",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_text. Expected _LineEdit_p.");
        return NULL;
        }
    }
    _result = (char *)LineEdit_text(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define LineEdit_maxLength(_swigobj)  (_swigobj->maxLength())
static PyObject *_wrap_LineEdit_maxLength(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    LineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:LineEdit_maxLength",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_maxLength. Expected _LineEdit_p.");
        return NULL;
        }
    }
    _result = (int )LineEdit_maxLength(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define LineEdit_setMaxLength(_swigobj,_swigarg0)  (_swigobj->setMaxLength(_swigarg0))
static PyObject *_wrap_LineEdit_setMaxLength(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:LineEdit_setMaxLength",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_setMaxLength. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_setMaxLength(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define LineEdit_setFrame(_swigobj,_swigarg0)  (_swigobj->setFrame(_swigarg0))
static PyObject *_wrap_LineEdit_setFrame(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:LineEdit_setFrame",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_setFrame. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_setFrame(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define LineEdit_frame(_swigobj)  (_swigobj->frame())
static PyObject *_wrap_LineEdit_frame(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    LineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:LineEdit_frame",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_frame. Expected _LineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )LineEdit_frame(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define LineEdit_setEchoMode(_swigobj,_swigarg0)  (_swigobj->setEchoMode(_swigarg0))
static PyObject *_wrap_LineEdit_setEchoMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    LineEdit::EchoMode  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:LineEdit_setEchoMode",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_setEchoMode. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_setEchoMode(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define LineEdit_echoMode(_swigobj)  (_swigobj->echoMode())
static PyObject *_wrap_LineEdit_echoMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit::EchoMode * _result;
    LineEdit * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:LineEdit_echoMode",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_echoMode. Expected _LineEdit_p.");
        return NULL;
        }
    }
    _result = new LineEdit::EchoMode (LineEdit_echoMode(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_LineEdit::EchoMode_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define LineEdit_setText(_swigobj,_swigarg0)  (_swigobj->setText(_swigarg0))
static PyObject *_wrap_LineEdit_setText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:LineEdit_setText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_setText. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_setText(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define LineEdit_selectAll(_swigobj)  (_swigobj->selectAll())
static PyObject *_wrap_LineEdit_selectAll(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:LineEdit_selectAll",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_selectAll. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_selectAll(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define LineEdit_deselect(_swigobj)  (_swigobj->deselect())
static PyObject *_wrap_LineEdit_deselect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    LineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:LineEdit_deselect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_LineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of LineEdit_deselect. Expected _LineEdit_p.");
        return NULL;
        }
    }
    LineEdit_deselect(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigFrameToWidget(void *ptr) {
    Frame *src;
    Widget *dest;
    src = (Frame *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigFrameToObject(void *ptr) {
    Frame *src;
    Object *dest;
    src = (Frame *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_Frame(_swigarg0,_swigarg1) (new Frame(_swigarg0,_swigarg1))
static PyObject *_wrap_new_Frame(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Frame * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_Frame",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_Frame. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Frame *)new_Frame(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Frame_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Frame_frameStyle(_swigobj)  (_swigobj->frameStyle())
static PyObject *_wrap_Frame_frameStyle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Frame_frameStyle",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_frameStyle. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_frameStyle(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Frame_frameShape(_swigobj)  (_swigobj->frameShape())
static PyObject *_wrap_Frame_frameShape(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Frame_frameShape",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_frameShape. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_frameShape(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Frame_frameShadow(_swigobj)  (_swigobj->frameShadow())
static PyObject *_wrap_Frame_frameShadow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Frame_frameShadow",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_frameShadow. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_frameShadow(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Frame_setFrameStyle(_swigobj,_swigarg0)  (_swigobj->setFrameStyle(_swigarg0))
static PyObject *_wrap_Frame_setFrameStyle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Frame * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Frame_setFrameStyle",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_setFrameStyle. Expected _Frame_p.");
        return NULL;
        }
    }
    Frame_setFrameStyle(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Frame_lineShapesOk(_swigobj)  (_swigobj->lineShapesOk())
static PyObject *_wrap_Frame_lineShapesOk(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Frame_lineShapesOk",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_lineShapesOk. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (bool )Frame_lineShapesOk(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Frame_lineWidth(_swigobj)  (_swigobj->lineWidth())
static PyObject *_wrap_Frame_lineWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Frame_lineWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_lineWidth. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_lineWidth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Frame_setLineWidth(_swigobj,_swigarg0)  (_swigobj->setLineWidth(_swigarg0))
static PyObject *_wrap_Frame_setLineWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Frame * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Frame_setLineWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_setLineWidth. Expected _Frame_p.");
        return NULL;
        }
    }
    Frame_setLineWidth(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Frame_midLineWidth(_swigobj)  (_swigobj->midLineWidth())
static PyObject *_wrap_Frame_midLineWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Frame_midLineWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_midLineWidth. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_midLineWidth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Frame_setMidLineWidth(_swigobj,_swigarg0)  (_swigobj->setMidLineWidth(_swigarg0))
static PyObject *_wrap_Frame_setMidLineWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Frame * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Frame_setMidLineWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_setMidLineWidth. Expected _Frame_p.");
        return NULL;
        }
    }
    Frame_setMidLineWidth(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Frame_frameWidth(_swigobj)  (_swigobj->frameWidth())
static PyObject *_wrap_Frame_frameWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Frame * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Frame_frameWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_frameWidth. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = (int )Frame_frameWidth(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Frame_frameRect(_swigobj)  (_swigobj->frameRect())
static PyObject *_wrap_Frame_frameRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Frame * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Frame_frameRect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_frameRect. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = new QRect (Frame_frameRect(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Frame_contentsRect(_swigobj)  (_swigobj->contentsRect())
static PyObject *_wrap_Frame_contentsRect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QRect * _result;
    Frame * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Frame_contentsRect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Frame_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Frame_contentsRect. Expected _Frame_p.");
        return NULL;
        }
    }
    _result = new QRect (Frame_contentsRect(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QRect_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

static void *SwigGroupBoxToFrame(void *ptr) {
    GroupBox *src;
    Frame *dest;
    src = (GroupBox *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigGroupBoxToWidget(void *ptr) {
    GroupBox *src;
    Widget *dest;
    src = (GroupBox *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigGroupBoxToObject(void *ptr) {
    GroupBox *src;
    Object *dest;
    src = (GroupBox *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_GroupBox(_swigarg0,_swigarg1) (new GroupBox(_swigarg0,_swigarg1))
static PyObject *_wrap_new_GroupBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GroupBox * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_GroupBox",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_GroupBox. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (GroupBox *)new_GroupBox(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_GroupBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_GroupBoxTitle(_swigarg0,_swigarg1,_swigarg2) (new GroupBox(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_GroupBoxTitle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GroupBox * _result;
    char * _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s|ss:new_GroupBoxTitle",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_GroupBoxTitle. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (GroupBox *)new_GroupBoxTitle(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_GroupBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define GroupBox_title(_swigobj)  (_swigobj->title())
static PyObject *_wrap_GroupBox_title(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    GroupBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:GroupBox_title",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GroupBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GroupBox_title. Expected _GroupBox_p.");
        return NULL;
        }
    }
    _result = (char *)GroupBox_title(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define GroupBox_setTitle(_swigobj,_swigarg0)  (_swigobj->setTitle(_swigarg0))
static PyObject *_wrap_GroupBox_setTitle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GroupBox * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:GroupBox_setTitle",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GroupBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GroupBox_setTitle. Expected _GroupBox_p.");
        return NULL;
        }
    }
    GroupBox_setTitle(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define GroupBox_alignment(_swigobj)  (_swigobj->alignment())
static PyObject *_wrap_GroupBox_alignment(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    GroupBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:GroupBox_alignment",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GroupBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GroupBox_alignment. Expected _GroupBox_p.");
        return NULL;
        }
    }
    _result = (int )GroupBox_alignment(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define GroupBox_setAlignment(_swigobj,_swigarg0)  (_swigobj->setAlignment(_swigarg0))
static PyObject *_wrap_GroupBox_setAlignment(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GroupBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:GroupBox_setAlignment",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_GroupBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of GroupBox_setAlignment. Expected _GroupBox_p.");
        return NULL;
        }
    }
    GroupBox_setAlignment(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigButtonGroupToGroupBox(void *ptr) {
    ButtonGroup *src;
    GroupBox *dest;
    src = (ButtonGroup *) ptr;
    dest = (GroupBox *) src;
    return (void *) dest;
}

static void *SwigButtonGroupToFrame(void *ptr) {
    ButtonGroup *src;
    Frame *dest;
    src = (ButtonGroup *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigButtonGroupToWidget(void *ptr) {
    ButtonGroup *src;
    Widget *dest;
    src = (ButtonGroup *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigButtonGroupToObject(void *ptr) {
    ButtonGroup *src;
    Object *dest;
    src = (ButtonGroup *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_ButtonGroup(_swigarg0,_swigarg1) (new ButtonGroup(_swigarg0,_swigarg1))
static PyObject *_wrap_new_ButtonGroup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ButtonGroup * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_ButtonGroup",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_ButtonGroup. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ButtonGroup *)new_ButtonGroup(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ButtonGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_ButtonGroupTitle(_swigarg0,_swigarg1,_swigarg2) (new ButtonGroup(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_ButtonGroupTitle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ButtonGroup * _result;
    char * _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s|ss:new_ButtonGroupTitle",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_ButtonGroupTitle. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ButtonGroup *)new_ButtonGroupTitle(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ButtonGroup_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_ButtonGroup(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_ButtonGroup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ButtonGroup * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_ButtonGroup",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_ButtonGroup. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    delete_ButtonGroup(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ButtonGroup_isExclusive(_swigobj)  (_swigobj->isExclusive())
static PyObject *_wrap_ButtonGroup_isExclusive(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ButtonGroup * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ButtonGroup_isExclusive",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_isExclusive. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    _result = (bool )ButtonGroup_isExclusive(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ButtonGroup_setExclusive(_swigobj,_swigarg0)  (_swigobj->setExclusive(_swigarg0))
static PyObject *_wrap_ButtonGroup_setExclusive(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ButtonGroup * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ButtonGroup_setExclusive",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_setExclusive. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    ButtonGroup_setExclusive(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ButtonGroup_insert(_swigobj,_swigarg0,_swigarg1)  (_swigobj->insert(_swigarg0,_swigarg1))
static PyObject *_wrap_ButtonGroup_insert(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ButtonGroup * _arg0;
    Button * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|i:ButtonGroup_insert",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_insert. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ButtonGroup_insert. Expected _Button_p.");
        return NULL;
        }
    }
    _result = (int )ButtonGroup_insert(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ButtonGroup_remove(_swigobj,_swigarg0)  (_swigobj->remove(_swigarg0))
static PyObject *_wrap_ButtonGroup_remove(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ButtonGroup * _arg0;
    Button * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:ButtonGroup_remove",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_remove. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Button_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ButtonGroup_remove. Expected _Button_p.");
        return NULL;
        }
    }
    ButtonGroup_remove(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ButtonGroup_find(_swigobj,_swigarg0)  (_swigobj->find(_swigarg0))
static PyObject *_wrap_ButtonGroup_find(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Button * _result;
    ButtonGroup * _arg0;
    int  _arg1;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"si:ButtonGroup_find",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_find. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    _result = (Button *)ButtonGroup_find(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Button_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define ButtonGroup_count(_swigobj)  (_swigobj->count())
static PyObject *_wrap_ButtonGroup_count(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ButtonGroup * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ButtonGroup_count",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_count. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    _result = (int )ButtonGroup_count(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ButtonGroup_setButtonState(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setButtonState(_swigarg0,_swigarg1))
static PyObject *_wrap_ButtonGroup_setButtonState(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ButtonGroup * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:ButtonGroup_setButtonState",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ButtonGroup_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ButtonGroup_setButtonState. Expected _ButtonGroup_p.");
        return NULL;
        }
    }
    ButtonGroup_setButtonState(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigLabelToFrame(void *ptr) {
    Label *src;
    Frame *dest;
    src = (Label *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigLabelToWidget(void *ptr) {
    Label *src;
    Widget *dest;
    src = (Label *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigLabelToObject(void *ptr) {
    Label *src;
    Object *dest;
    src = (Label *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_Label(_swigarg0,_swigarg1) (new Label(_swigarg0,_swigarg1))
static PyObject *_wrap_new_Label(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_Label",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_Label. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Label *)new_Label(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Label_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_LabelT(_swigarg0,_swigarg1,_swigarg2) (new Label(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_LabelT(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _result;
    char * _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s|ss:new_LabelT",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_LabelT. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Label *)new_LabelT(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Label_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_LabelBuddy(_swigarg0,_swigarg1,_swigarg2,_swigarg3) (new Label(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_new_LabelBuddy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _result;
    Widget * _arg0;
    char * _arg1;
    Widget * _arg2;
    char * _arg3 = 0;
    char * _argc0 = 0;
    char * _argc2 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"sss|s:new_LabelBuddy",&_argc0,&_arg1,&_argc2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_LabelBuddy. Expected _Widget_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of new_LabelBuddy. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (Label *)new_LabelBuddy(_arg0,_arg1,_arg2,_arg3);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Label_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_Label(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_Label(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_Label",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_Label. Expected _Label_p.");
        return NULL;
        }
    }
    delete_Label(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Label_text(_swigobj)  (_swigobj->text())
static PyObject *_wrap_Label_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    Label * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Label_text",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_text. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (char *)Label_text(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define Label_pixmap(_swigobj)  (_swigobj->pixmap())
static PyObject *_wrap_Label_pixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    Label * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Label_pixmap",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_pixmap. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)Label_pixmap(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Label_alignment(_swigobj)  (_swigobj->alignment())
static PyObject *_wrap_Label_alignment(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Label * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Label_alignment",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_alignment. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (int )Label_alignment(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Label_setAlignment(_swigobj,_swigarg0)  (_swigobj->setAlignment(_swigarg0))
static PyObject *_wrap_Label_setAlignment(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Label_setAlignment",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setAlignment. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setAlignment(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Label_margin(_swigobj)  (_swigobj->margin())
static PyObject *_wrap_Label_margin(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    Label * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Label_margin",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_margin. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (int )Label_margin(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Label_setMargin(_swigobj,_swigarg0)  (_swigobj->setMargin(_swigarg0))
static PyObject *_wrap_Label_setMargin(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Label_setMargin",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setMargin. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setMargin(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Label_autoResize(_swigobj)  (_swigobj->autoResize())
static PyObject *_wrap_Label_autoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    Label * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:Label_autoResize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_autoResize. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (bool )Label_autoResize(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define Label_setAutoResize(_swigobj,_swigarg0)  (_swigobj->setAutoResize(_swigarg0))
static PyObject *_wrap_Label_setAutoResize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Label_setAutoResize",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setAutoResize. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setAutoResize(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Label_sizeHint(_swigobj)  (_swigobj->sizeHint())
static PyObject *_wrap_Label_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    Label * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Label_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_sizeHint. Expected _Label_p.");
        return NULL;
        }
    }
    _result = new QSize (Label_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Label_setBuddy(_swigobj,_swigarg0)  (_swigobj->setBuddy(_swigarg0))
static PyObject *_wrap_Label_setBuddy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    Widget * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Label_setBuddy",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setBuddy. Expected _Label_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Label_setBuddy. Expected _Widget_p.");
        return NULL;
        }
    }
    Label_setBuddy(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Label_buddy(_swigobj)  (_swigobj->buddy())
static PyObject *_wrap_Label_buddy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    Label * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:Label_buddy",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_buddy. Expected _Label_p.");
        return NULL;
        }
    }
    _result = (Widget *)Label_buddy(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define Label_setText(_swigobj,_swigarg0)  (_swigobj->setText(_swigarg0))
static PyObject *_wrap_Label_setText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Label_setText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setText. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setText(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Label_setPixmap(_swigobj,_swigarg0)  (_swigobj->setPixmap(_swigarg0))
static PyObject *_wrap_Label_setPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    QPixmap * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:Label_setPixmap",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setPixmap. Expected _Label_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of Label_setPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    Label_setPixmap(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Label_setInt(_swigobj,_swigarg0)  (_swigobj->setNum(_swigarg0))
static PyObject *_wrap_Label_setInt(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:Label_setInt",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setInt. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setInt(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define Label_setDouble(_swigobj,_swigarg0)  (_swigobj->setNum(_swigarg0))
static PyObject *_wrap_Label_setDouble(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Label * _arg0;
    double  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sd:Label_setDouble",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Label_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of Label_setDouble. Expected _Label_p.");
        return NULL;
        }
    }
    Label_setDouble(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigTableViewToFrame(void *ptr) {
    TableView *src;
    Frame *dest;
    src = (TableView *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigTableViewToWidget(void *ptr) {
    TableView *src;
    Widget *dest;
    src = (TableView *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigTableViewToObject(void *ptr) {
    TableView *src;
    Object *dest;
    src = (TableView *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_TableView(_swigarg0,_swigarg1) (new TableView(_swigarg0,_swigarg1))
static PyObject *_wrap_new_TableView(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TableView * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_TableView",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_TableView. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (TableView *)new_TableView(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_TableView_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_TableView(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_TableView(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    TableView * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_TableView",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_TableView_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_TableView. Expected _TableView_p.");
        return NULL;
        }
    }
    delete_TableView(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigListBoxToTableView(void *ptr) {
    ListBox *src;
    TableView *dest;
    src = (ListBox *) ptr;
    dest = (TableView *) src;
    return (void *) dest;
}

static void *SwigListBoxToFrame(void *ptr) {
    ListBox *src;
    Frame *dest;
    src = (ListBox *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigListBoxToWidget(void *ptr) {
    ListBox *src;
    Widget *dest;
    src = (ListBox *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigListBoxToObject(void *ptr) {
    ListBox *src;
    Object *dest;
    src = (ListBox *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_ListBox(_swigarg0,_swigarg1) (new ListBox(_swigarg0,_swigarg1))
static PyObject *_wrap_new_ListBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_ListBox",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_ListBox. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ListBox *)new_ListBox(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ListBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_ListBox(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_ListBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_ListBox",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_ListBox. Expected _ListBox_p.");
        return NULL;
        }
    }
    delete_ListBox(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_setFont(_swigobj,_swigarg0)  (_swigobj->setFont(_swigarg0))
static PyObject *_wrap_ListBox_setFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    QFont * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:ListBox_setFont",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setFont. Expected _ListBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ListBox_setFont. Expected _QFont_p.");
        return NULL;
        }
    }
    ListBox_setFont(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_count(_swigobj)  (_swigobj->count())
static PyObject *_wrap_ListBox_count(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    unsigned int  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_count",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_count. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (unsigned int )ListBox_count(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_insertStrList(_swigobj,_swigarg0,_swigarg1)  (_swigobj->insertStrList(_swigarg0,_swigarg1))
static PyObject *_wrap_ListBox_insertStrList(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    PyObject * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sO|i:ListBox_insertStrList",&_argc0,&_obj1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_insertStrList. Expected _ListBox_p.");
        return NULL;
        }
    }
{
  if(!PySequence_Check(_obj1))
  {
    PyErr_SetString(PyExc_TypeError, "Need a list!");
    return NULL;
  }
  _arg1 = _obj1;
}
    ListBox_insertStrList(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_insertText(_swigobj,_swigarg0,_swigarg1)  (_swigobj->insertItem(_swigarg0,_swigarg1))
static PyObject *_wrap_ListBox_insertText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|i:ListBox_insertText",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_insertText. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_insertText(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_insertPixmap(_swigobj,_swigarg0,_swigarg1)  (_swigobj->insertItem(_swigarg0,_swigarg1))
static PyObject *_wrap_ListBox_insertPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    QPixmap * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|i:ListBox_insertPixmap",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_insertPixmap. Expected _ListBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ListBox_insertPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    ListBox_insertPixmap(_arg0,*_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_inSort(_swigobj,_swigarg0)  (_swigobj->inSort(_swigarg0))
static PyObject *_wrap_ListBox_inSort(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:ListBox_inSort",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_inSort. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_inSort(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_removeItem(_swigobj,_swigarg0)  (_swigobj->removeItem(_swigarg0))
static PyObject *_wrap_ListBox_removeItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_removeItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_removeItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_removeItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_clear(_swigobj)  (_swigobj->clear())
static PyObject *_wrap_ListBox_clear(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_clear",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_clear. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_clear(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_text(_swigobj,_swigarg0)  (_swigobj->text(_swigarg0))
static PyObject *_wrap_ListBox_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_text",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_text. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (char *)ListBox_text(_arg0,_arg1);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define ListBox_pixmap(_swigobj,_swigarg0)  (_swigobj->pixmap(_swigarg0))
static PyObject *_wrap_ListBox_pixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QPixmap * _result;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_pixmap",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_pixmap. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (QPixmap *)ListBox_pixmap(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QPixmap_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define ListBox_changeText(_swigobj,_swigarg0,_swigarg1)  (_swigobj->changeItem(_swigarg0,_swigarg1))
static PyObject *_wrap_ListBox_changeText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssi:ListBox_changeText",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_changeText. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_changeText(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_changePixmap(_swigobj,_swigarg0,_swigarg1)  (_swigobj->changeItem(_swigarg0,_swigarg1))
static PyObject *_wrap_ListBox_changePixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    QPixmap * _arg1;
    int  _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssi:ListBox_changePixmap",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_changePixmap. Expected _ListBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ListBox_changePixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    ListBox_changePixmap(_arg0,*_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_autoUpdate(_swigobj)  (_swigobj->autoUpdate())
static PyObject *_wrap_ListBox_autoUpdate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_autoUpdate",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_autoUpdate. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_autoUpdate(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_setAutoUpdate(_swigobj,_swigarg0)  (_swigobj->setAutoUpdate(_swigarg0))
static PyObject *_wrap_ListBox_setAutoUpdate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_setAutoUpdate",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setAutoUpdate. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setAutoUpdate(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_numItemsVisible(_swigobj)  (_swigobj->numItemsVisible())
static PyObject *_wrap_ListBox_numItemsVisible(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_numItemsVisible",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_numItemsVisible. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (int )ListBox_numItemsVisible(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_currentItem(_swigobj)  (_swigobj->currentItem())
static PyObject *_wrap_ListBox_currentItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_currentItem",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_currentItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (int )ListBox_currentItem(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_setCurrentItem(_swigobj,_swigarg0)  (_swigobj->setCurrentItem(_swigarg0))
static PyObject *_wrap_ListBox_setCurrentItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_setCurrentItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setCurrentItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setCurrentItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_centerCurrentItem(_swigobj)  (_swigobj->centerCurrentItem())
static PyObject *_wrap_ListBox_centerCurrentItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_centerCurrentItem",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_centerCurrentItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_centerCurrentItem(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_topItem(_swigobj)  (_swigobj->topItem())
static PyObject *_wrap_ListBox_topItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_topItem",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_topItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (int )ListBox_topItem(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_setTopItem(_swigobj,_swigarg0)  (_swigobj->setTopItem(_swigarg0))
static PyObject *_wrap_ListBox_setTopItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_setTopItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setTopItem. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setTopItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_dragSelect(_swigobj)  (_swigobj->dragSelect())
static PyObject *_wrap_ListBox_dragSelect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_dragSelect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_dragSelect. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_dragSelect(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_setDragSelect(_swigobj,_swigarg0)  (_swigobj->setDragSelect(_swigarg0))
static PyObject *_wrap_ListBox_setDragSelect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_setDragSelect",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setDragSelect. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setDragSelect(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_autoScroll(_swigobj)  (_swigobj->autoScroll())
static PyObject *_wrap_ListBox_autoScroll(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_autoScroll",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_autoScroll. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_autoScroll(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_setAutoScroll(_swigobj,_swigarg0)  (_swigobj->setAutoScroll(_swigarg0))
static PyObject *_wrap_ListBox_setAutoScroll(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_setAutoScroll",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setAutoScroll. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setAutoScroll(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_autoScrollBar(_swigobj)  (_swigobj->autoScrollBar())
static PyObject *_wrap_ListBox_autoScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_autoScrollBar",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_autoScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_autoScrollBar(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_setAutoScrollBar(_swigobj,_swigarg0)  (_swigobj->setAutoScrollBar(_swigarg0))
static PyObject *_wrap_ListBox_setAutoScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_setAutoScrollBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setAutoScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setAutoScrollBar(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_scrollBar(_swigobj)  (_swigobj->scrollBar())
static PyObject *_wrap_ListBox_scrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_scrollBar",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_scrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_scrollBar(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_setScrollBar(_swigobj,_swigarg0)  (_swigobj->setScrollBar(_swigarg0))
static PyObject *_wrap_ListBox_setScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_setScrollBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setScrollBar(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_autoBottomScrollBar(_swigobj)  (_swigobj->autoBottomScrollBar())
static PyObject *_wrap_ListBox_autoBottomScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_autoBottomScrollBar",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_autoBottomScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_autoBottomScrollBar(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_setAutoBottomScrollBar(_swigobj,_swigarg0)  (_swigobj->setAutoBottomScrollBar(_swigarg0))
static PyObject *_wrap_ListBox_setAutoBottomScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_setAutoBottomScrollBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setAutoBottomScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setAutoBottomScrollBar(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_bottomScrollBar(_swigobj)  (_swigobj->bottomScrollBar())
static PyObject *_wrap_ListBox_bottomScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_bottomScrollBar",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_bottomScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_bottomScrollBar(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_setBottomScrollBar(_swigobj,_swigarg0)  (_swigobj->setBottomScrollBar(_swigarg0))
static PyObject *_wrap_ListBox_setBottomScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_setBottomScrollBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setBottomScrollBar. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setBottomScrollBar(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_smoothScrolling(_swigobj)  (_swigobj->smoothScrolling())
static PyObject *_wrap_ListBox_smoothScrolling(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_smoothScrolling",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_smoothScrolling. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (bool )ListBox_smoothScrolling(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_setSmoothScrolling(_swigobj,_swigarg0)  (_swigobj->setSmoothScrolling(_swigarg0))
static PyObject *_wrap_ListBox_setSmoothScrolling(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_setSmoothScrolling",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setSmoothScrolling. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setSmoothScrolling(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ListBox_standardItemHeight(_swigobj)  (_swigobj->itemHeight())
static PyObject *_wrap_ListBox_standardItemHeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_standardItemHeight",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_standardItemHeight. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (int )ListBox_standardItemHeight(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_itemHeight(_swigobj,_swigarg0)  (_swigobj->itemHeight(_swigarg0))
static PyObject *_wrap_ListBox_itemHeight(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_itemHeight",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_itemHeight. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (int )ListBox_itemHeight(_arg0,_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ListBox_maxItemWidth(_swigobj)  (_swigobj->maxItemWidth())
static PyObject *_wrap_ListBox_maxItemWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    long  _result;
    ListBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ListBox_maxItemWidth",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_maxItemWidth. Expected _ListBox_p.");
        return NULL;
        }
    }
    _result = (long )ListBox_maxItemWidth(_arg0);
    _resultobj = Py_BuildValue("l",_result);
    return _resultobj;
}

#define ListBox_setMultiSelection(_swigobj,_swigarg0)  (_swigobj->setMultiSelection(_swigarg0))
static PyObject *_wrap_ListBox_setMultiSelection(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ListBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ListBox_setMultiSelection",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ListBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ListBox_setMultiSelection. Expected _ListBox_p.");
        return NULL;
        }
    }
    ListBox_setMultiSelection(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigMultiLineEditToTableView(void *ptr) {
    MultiLineEdit *src;
    TableView *dest;
    src = (MultiLineEdit *) ptr;
    dest = (TableView *) src;
    return (void *) dest;
}

static void *SwigMultiLineEditToFrame(void *ptr) {
    MultiLineEdit *src;
    Frame *dest;
    src = (MultiLineEdit *) ptr;
    dest = (Frame *) src;
    return (void *) dest;
}

static void *SwigMultiLineEditToWidget(void *ptr) {
    MultiLineEdit *src;
    Widget *dest;
    src = (MultiLineEdit *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigMultiLineEditToObject(void *ptr) {
    MultiLineEdit *src;
    Object *dest;
    src = (MultiLineEdit *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_MultiLineEdit(_swigarg0,_swigarg1) (new MultiLineEdit(_swigarg0,_swigarg1))
static PyObject *_wrap_new_MultiLineEdit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_MultiLineEdit",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_MultiLineEdit. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (MultiLineEdit *)new_MultiLineEdit(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_MultiLineEdit_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_MultiLineEdit(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_MultiLineEdit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_MultiLineEdit",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_MultiLineEdit. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    delete_MultiLineEdit(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_textLine(_swigobj,_swigarg0)  (_swigobj->textLine(_swigarg0))
static PyObject *_wrap_MultiLineEdit_textLine(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    MultiLineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:MultiLineEdit_textLine",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_textLine. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (char *)MultiLineEdit_textLine(_arg0,_arg1);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define MultiLineEdit_text(_swigobj)  (_swigobj->text())
static PyObject *_wrap_MultiLineEdit_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_text",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_text. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (char *)MultiLineEdit_text(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define MultiLineEdit_numLines(_swigobj)  (_swigobj->numLines())
static PyObject *_wrap_MultiLineEdit_numLines(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_numLines",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_numLines. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (int )MultiLineEdit_numLines(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define MultiLineEdit_isReadOnly(_swigobj)  (_swigobj->isReadOnly())
static PyObject *_wrap_MultiLineEdit_isReadOnly(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_isReadOnly",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_isReadOnly. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )MultiLineEdit_isReadOnly(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define MultiLineEdit_isOverwriteMode(_swigobj)  (_swigobj->isOverwriteMode())
static PyObject *_wrap_MultiLineEdit_isOverwriteMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_isOverwriteMode",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_isOverwriteMode. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )MultiLineEdit_isOverwriteMode(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define MultiLineEdit_setFont(_swigobj,_swigarg0)  (_swigobj->setFont(_swigarg0))
static PyObject *_wrap_MultiLineEdit_setFont(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    QFont * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:MultiLineEdit_setFont",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setFont. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QFont_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of MultiLineEdit_setFont. Expected _QFont_p.");
        return NULL;
        }
    }
    MultiLineEdit_setFont(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_insertLine(_swigobj,_swigarg0,_swigarg1)  (_swigobj->insertLine(_swigarg0,_swigarg1))
static PyObject *_wrap_MultiLineEdit_insertLine(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _arg1;
    int  _arg2 = -1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|i:MultiLineEdit_insertLine",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_insertLine. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_insertLine(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_insertAt(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->insertAt(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_MultiLineEdit_insertAt(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _arg1;
    int  _arg2;
    int  _arg3;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssii:MultiLineEdit_insertAt",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_insertAt. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_insertAt(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_removeLine(_swigobj,_swigarg0)  (_swigobj->removeLine(_swigarg0))
static PyObject *_wrap_MultiLineEdit_removeLine(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:MultiLineEdit_removeLine",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_removeLine. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_removeLine(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_setCursorPosition(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->setCursorPosition(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_MultiLineEdit_setCursorPosition(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3 = FALSE;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii|i:MultiLineEdit_setCursorPosition",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setCursorPosition. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_setCursorPosition(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_getCursorPosition(_swigobj,_swigarg0,_swigarg1)  (_swigobj->getCursorPosition(_swigarg0,_swigarg1))
static PyObject *_wrap_MultiLineEdit_getCursorPosition(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int * _arg1;
    int * _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sss:MultiLineEdit_getCursorPosition",&_argc0,&_argc1,&_argc2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_getCursorPosition. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of MultiLineEdit_getCursorPosition. Expected _int_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_int_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of MultiLineEdit_getCursorPosition. Expected _int_p.");
        return NULL;
        }
    }
    MultiLineEdit_getCursorPosition(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_atBeginning(_swigobj)  (_swigobj->atBeginning())
static PyObject *_wrap_MultiLineEdit_atBeginning(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_atBeginning",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_atBeginning. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )MultiLineEdit_atBeginning(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define MultiLineEdit_atEnd(_swigobj)  (_swigobj->atEnd())
static PyObject *_wrap_MultiLineEdit_atEnd(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_atEnd",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_atEnd. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )MultiLineEdit_atEnd(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define MultiLineEdit_autoUpdate(_swigobj)  (_swigobj->autoUpdate())
static PyObject *_wrap_MultiLineEdit_autoUpdate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_autoUpdate",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_autoUpdate. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    _result = (bool )MultiLineEdit_autoUpdate(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define MultiLineEdit_setAutoUpdate(_swigobj,_swigarg0)  (_swigobj->setAutoUpdate(_swigarg0))
static PyObject *_wrap_MultiLineEdit_setAutoUpdate(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:MultiLineEdit_setAutoUpdate",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setAutoUpdate. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_setAutoUpdate(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_clear(_swigobj)  (_swigobj->clear())
static PyObject *_wrap_MultiLineEdit_clear(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_clear",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_clear. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_clear(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_setText(_swigobj,_swigarg0)  (_swigobj->setText(_swigarg0))
static PyObject *_wrap_MultiLineEdit_setText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:MultiLineEdit_setText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setText. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_setText(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_append(_swigobj,_swigarg0)  (_swigobj->append(_swigarg0))
static PyObject *_wrap_MultiLineEdit_append(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:MultiLineEdit_append",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_append. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_append(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_deselect(_swigobj)  (_swigobj->deselect())
static PyObject *_wrap_MultiLineEdit_deselect(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_deselect",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_deselect. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_deselect(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_selectAll(_swigobj)  (_swigobj->selectAll())
static PyObject *_wrap_MultiLineEdit_selectAll(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_selectAll",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_selectAll. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_selectAll(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_setReadOnly(_swigobj,_swigarg0)  (_swigobj->setReadOnly(_swigarg0))
static PyObject *_wrap_MultiLineEdit_setReadOnly(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:MultiLineEdit_setReadOnly",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setReadOnly. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_setReadOnly(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_setOverwriteMode(_swigobj,_swigarg0)  (_swigobj->setOverwriteMode(_swigarg0))
static PyObject *_wrap_MultiLineEdit_setOverwriteMode(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:MultiLineEdit_setOverwriteMode",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_setOverwriteMode. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_setOverwriteMode(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_paste(_swigobj)  (_swigobj->paste())
static PyObject *_wrap_MultiLineEdit_paste(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_paste",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_paste. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_paste(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_copyText(_swigobj)  (_swigobj->copyText())
static PyObject *_wrap_MultiLineEdit_copyText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_copyText",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_copyText. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_copyText(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_cut(_swigobj)  (_swigobj->cut())
static PyObject *_wrap_MultiLineEdit_cut(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_cut",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_cut. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_cut(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_textChanged(_swigobj)  (_swigobj->textChanged())
static PyObject *_wrap_MultiLineEdit_textChanged(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_textChanged",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_textChanged. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_textChanged(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MultiLineEdit_returnPressed(_swigobj)  (_swigobj->returnPressed())
static PyObject *_wrap_MultiLineEdit_returnPressed(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MultiLineEdit * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:MultiLineEdit_returnPressed",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MultiLineEdit_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MultiLineEdit_returnPressed. Expected _MultiLineEdit_p.");
        return NULL;
        }
    }
    MultiLineEdit_returnPressed(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigScrollBarToWidget(void *ptr) {
    ScrollBar *src;
    Widget *dest;
    src = (ScrollBar *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigScrollBarToObject(void *ptr) {
    ScrollBar *src;
    Object *dest;
    src = (ScrollBar *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_ScrollBar(_swigarg0,_swigarg1) (new ScrollBar(_swigarg0,_swigarg1))
static PyObject *_wrap_new_ScrollBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_ScrollBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_ScrollBar. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ScrollBar *)new_ScrollBar(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ScrollBar_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_ScrollBarOrientation(_swigarg0,_swigarg1,_swigarg2) (new ScrollBar(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_ScrollBarOrientation(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _result;
    ScrollBar::Orientation  _arg0;
    Widget * _arg1 = 0;
    char * _arg2 = 0;
    char * _argc1 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"i|ss:new_ScrollBarOrientation",&_arg0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of new_ScrollBarOrientation. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ScrollBar *)new_ScrollBarOrientation(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ScrollBar_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_ScrollBarValues(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7) (new ScrollBar(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7))
static PyObject *_wrap_new_ScrollBarValues(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _result;
    int  _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    ScrollBar::Orientation  _arg5;
    Widget * _arg6 = 0;
    char * _arg7 = 0;
    char * _argc6 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"iiiiii|ss:new_ScrollBarValues",&_arg0,&_arg1,&_arg2,&_arg3,&_arg4,&_arg5,&_argc6,&_arg7)) 
        return NULL;
    if (_argc6) {
        if (SWIG_GetPtr(_argc6,(void **) &_arg6,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 7 of new_ScrollBarValues. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ScrollBar *)new_ScrollBarValues(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ScrollBar_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define ScrollBar_setOrientation(_swigobj,_swigarg0)  (_swigobj->setOrientation(_swigarg0))
static PyObject *_wrap_ScrollBar_setOrientation(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    ScrollBar::Orientation  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ScrollBar_setOrientation",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setOrientation. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_setOrientation(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ScrollBar_orientation(_swigobj)  (_swigobj->orientation())
static PyObject *_wrap_ScrollBar_orientation(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar::Orientation  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_orientation",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_orientation. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (ScrollBar::Orientation )ScrollBar_orientation(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ScrollBar_setTracking(_swigobj,_swigarg0)  (_swigobj->setTracking(_swigarg0))
static PyObject *_wrap_ScrollBar_setTracking(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ScrollBar_setTracking",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setTracking. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_setTracking(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ScrollBar_tracking(_swigobj)  (_swigobj->tracking())
static PyObject *_wrap_ScrollBar_tracking(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_tracking",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_tracking. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (bool )ScrollBar_tracking(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ScrollBar_draggingSlider(_swigobj)  (_swigobj->draggingSlider())
static PyObject *_wrap_ScrollBar_draggingSlider(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_draggingSlider",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_draggingSlider. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (bool )ScrollBar_draggingSlider(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ScrollBar_setPalette(_swigobj,_swigarg0)  (_swigobj->setPalette(_swigarg0))
static PyObject *_wrap_ScrollBar_setPalette(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    QPalette * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:ScrollBar_setPalette",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setPalette. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPalette_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ScrollBar_setPalette. Expected _QPalette_p.");
        return NULL;
        }
    }
    ScrollBar_setPalette(_arg0,*_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ScrollBar_sizeHint(_swigobj)  (_swigobj->sizeHint())
static PyObject *_wrap_ScrollBar_sizeHint(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QSize * _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_sizeHint",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_sizeHint. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = new QSize (ScrollBar_sizeHint(_arg0));
    SWIG_MakePtr(_ptemp, (void *) _result,"_QSize_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define ScrollBar_value(_swigobj)  (_swigobj->value())
static PyObject *_wrap_ScrollBar_value(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_value",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_value. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (int )ScrollBar_value(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ScrollBar_setValue(_swigobj,_swigarg0)  (_swigobj->setValue(_swigarg0))
static PyObject *_wrap_ScrollBar_setValue(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:ScrollBar_setValue",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setValue. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_setValue(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ScrollBar_addPage(_swigobj)  (_swigobj->addPage())
static PyObject *_wrap_ScrollBar_addPage(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_addPage",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_addPage. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_addPage(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ScrollBar_subtractPage(_swigobj)  (_swigobj->subtractPage())
static PyObject *_wrap_ScrollBar_subtractPage(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_subtractPage",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_subtractPage. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_subtractPage(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ScrollBar_addLine(_swigobj)  (_swigobj->addLine())
static PyObject *_wrap_ScrollBar_addLine(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_addLine",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_addLine. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_addLine(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ScrollBar_subtractLine(_swigobj)  (_swigobj->subtractLine())
static PyObject *_wrap_ScrollBar_subtractLine(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_subtractLine",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_subtractLine. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_subtractLine(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ScrollBar_minValue(_swigobj)  (_swigobj->minValue())
static PyObject *_wrap_ScrollBar_minValue(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_minValue",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_minValue. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (int )ScrollBar_minValue(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ScrollBar_maxValue(_swigobj)  (_swigobj->maxValue())
static PyObject *_wrap_ScrollBar_maxValue(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_maxValue",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_maxValue. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (int )ScrollBar_maxValue(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ScrollBar_setRange(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setRange(_swigarg0,_swigarg1))
static PyObject *_wrap_ScrollBar_setRange(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:ScrollBar_setRange",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setRange. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_setRange(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ScrollBar_lineStep(_swigobj)  (_swigobj->lineStep())
static PyObject *_wrap_ScrollBar_lineStep(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_lineStep",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_lineStep. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (int )ScrollBar_lineStep(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ScrollBar_pageStep(_swigobj)  (_swigobj->pageStep())
static PyObject *_wrap_ScrollBar_pageStep(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    ScrollBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ScrollBar_pageStep",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_pageStep. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    _result = (int )ScrollBar_pageStep(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define ScrollBar_setSteps(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setSteps(_swigarg0,_swigarg1))
static PyObject *_wrap_ScrollBar_setSteps(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrollBar * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:ScrollBar_setSteps",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ScrollBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ScrollBar_setSteps. Expected _ScrollBar_p.");
        return NULL;
        }
    }
    ScrollBar_setSteps(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define new_FileDialog() (new FileDialog())
static PyObject *_wrap_new_FileDialog(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_FileDialog")) 
        return NULL;
    _result = (FileDialog *)new_FileDialog();
    SWIG_MakePtr(_ptemp, (char *) _result,"_FileDialog_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define FileDialog_left(_swigobj)  (_swigobj->left())
static PyObject *_wrap_FileDialog_left(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    FileDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:FileDialog_left",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_left. Expected _FileDialog_p.");
        return NULL;
        }
    }
    _result = (int )FileDialog_left(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define FileDialog_top(_swigobj)  (_swigobj->top())
static PyObject *_wrap_FileDialog_top(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    FileDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:FileDialog_top",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_top. Expected _FileDialog_p.");
        return NULL;
        }
    }
    _result = (int )FileDialog_top(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define FileDialog_width(_swigobj)  (_swigobj->width())
static PyObject *_wrap_FileDialog_width(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    FileDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:FileDialog_width",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_width. Expected _FileDialog_p.");
        return NULL;
        }
    }
    _result = (int )FileDialog_width(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define FileDialog_height(_swigobj)  (_swigobj->height())
static PyObject *_wrap_FileDialog_height(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    FileDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:FileDialog_height",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_height. Expected _FileDialog_p.");
        return NULL;
        }
    }
    _result = (int )FileDialog_height(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define FileDialog_show(_swigobj)  (_swigobj->show())
static PyObject *_wrap_FileDialog_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:FileDialog_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_show. Expected _FileDialog_p.");
        return NULL;
        }
    }
    FileDialog_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define FileDialog_create(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4)  (_swigobj->create(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4))
static PyObject *_wrap_FileDialog_create(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    char * _arg1;
    char * _arg2 = 0;
    QWidget * _arg3 = 0;
    char * _arg4 = 0;
    bool  _arg5 = FALSE;
    char * _argc0 = 0;
    char * _argc3 = 0;
    int tempbool5;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|sssi:FileDialog_create",&_argc0,&_arg1,&_arg2,&_argc3,&_arg4,&tempbool5)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_create. Expected _FileDialog_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_QWidget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of FileDialog_create. Expected _QWidget_p.");
        return NULL;
        }
    }
    _arg5 = (bool ) tempbool5;
    FileDialog_create(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define FileDialog_createWithParent(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->create(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_FileDialog_createWithParent(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    QWidget * _arg1 = 0;
    char * _arg2 = 0;
    bool  _arg3 = FALSE;
    char * _argc0 = 0;
    char * _argc1 = 0;
    int tempbool3;

    self = self;
    if(!PyArg_ParseTuple(args,"s|ssi:FileDialog_createWithParent",&_argc0,&_argc1,&_arg2,&tempbool3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_createWithParent. Expected _FileDialog_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QWidget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of FileDialog_createWithParent. Expected _QWidget_p.");
        return NULL;
        }
    }
    _arg3 = (bool ) tempbool3;
    FileDialog_createWithParent(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define FileDialog_path(_swigobj)  (_swigobj->path())
static PyObject *_wrap_FileDialog_path(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    FileDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:FileDialog_path",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_path. Expected _FileDialog_p.");
        return NULL;
        }
    }
    _result = (char *)FileDialog_path(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define FileDialog_selectedFile(_swigobj)  (_swigobj->selectedFile())
static PyObject *_wrap_FileDialog_selectedFile(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    FileDialog * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:FileDialog_selectedFile",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_selectedFile. Expected _FileDialog_p.");
        return NULL;
        }
    }
    _result = (char *)FileDialog_selectedFile(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define FileDialog_fileHighlighted(_swigobj,_swigarg0)  (_swigobj->fileHighlighted(_swigarg0))
static PyObject *_wrap_FileDialog_fileHighlighted(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:FileDialog_fileHighlighted",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_fileHighlighted. Expected _FileDialog_p.");
        return NULL;
        }
    }
    FileDialog_fileHighlighted(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define FileDialog_fileSelected(_swigobj,_swigarg0)  (_swigobj->fileSelected(_swigarg0))
static PyObject *_wrap_FileDialog_fileSelected(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:FileDialog_fileSelected",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_fileSelected. Expected _FileDialog_p.");
        return NULL;
        }
    }
    FileDialog_fileSelected(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define FileDialog_dirEntered(_swigobj,_swigarg0)  (_swigobj->dirEntered(_swigarg0))
static PyObject *_wrap_FileDialog_dirEntered(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    FileDialog * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:FileDialog_dirEntered",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_FileDialog_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of FileDialog_dirEntered. Expected _FileDialog_p.");
        return NULL;
        }
    }
    FileDialog_dirEntered(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define new_QMenuBar(_swigarg0,_swigarg1) (new QMenuBar(_swigarg0,_swigarg1))
static PyObject *_wrap_new_QMenuBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _result;
    Object * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_QMenuBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Object_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QMenuBar. Expected _Object_p.");
        return NULL;
        }
    }
    _result = (QMenuBar *)new_QMenuBar(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QMenuBar_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_QMenuBar(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_QMenuBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_QMenuBar",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_QMenuBar. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    delete_QMenuBar(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QMenuBar_updateItem(_swigobj,_swigarg0)  (_swigobj->updateItem(_swigarg0))
static PyObject *_wrap_QMenuBar_updateItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QMenuBar_updateItem",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_updateItem. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    QMenuBar_updateItem(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QMenuBar_show(_swigobj)  (_swigobj->show())
static PyObject *_wrap_QMenuBar_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QMenuBar_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_show. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    QMenuBar_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QMenuBar_hide(_swigobj)  (_swigobj->hide())
static PyObject *_wrap_QMenuBar_hide(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QMenuBar_hide",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_hide. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    QMenuBar_hide(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QMenuBar_eventFilter(_swigobj,_swigarg0,_swigarg1)  (_swigobj->eventFilter(_swigarg0,_swigarg1))
static PyObject *_wrap_QMenuBar_eventFilter(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    QMenuBar * _arg0;
    QObject * _arg1;
    QEvent * _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sss:QMenuBar_eventFilter",&_argc0,&_argc1,&_argc2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_eventFilter. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QObject_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QMenuBar_eventFilter. Expected _QObject_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QEvent_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QMenuBar_eventFilter. Expected _QEvent_p.");
        return NULL;
        }
    }
    _result = (bool )QMenuBar_eventFilter(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QMenuBar_heightForWidth(_swigobj,_swigarg0)  (_swigobj->heightForWidth(_swigarg0))
static PyObject *_wrap_QMenuBar_heightForWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QMenuBar * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QMenuBar_heightForWidth",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_heightForWidth. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    _result = (int )QMenuBar_heightForWidth(_arg0,_arg1);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QMenuBar_separator(_swigobj)  (_swigobj->separator())
static PyObject *_wrap_QMenuBar_separator(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar::Separator  _result;
    QMenuBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QMenuBar_separator",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_separator. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    _result = (QMenuBar::Separator )QMenuBar_separator(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QMenuBar_setSeparator(_swigobj,_swigarg0)  (_swigobj->setSeparator(_swigarg0))
static PyObject *_wrap_QMenuBar_setSeparator(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMenuBar * _arg0;
    QMenuBar::Separator  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QMenuBar_setSeparator",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_setSeparator. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    QMenuBar_setSeparator(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QMenuBar_insertItem(_swigobj,_swigarg0,_swigarg1)  (_swigobj->insertItem(_swigarg0,_swigarg1))
static PyObject *_wrap_QMenuBar_insertItem(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QMenuBar * _arg0;
    char * _arg1;
    PopupMenu * _arg2;
    char * _argc0 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sss:QMenuBar_insertItem",&_argc0,&_arg1,&_argc2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMenuBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMenuBar_insertItem. Expected _QMenuBar_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of QMenuBar_insertItem. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    _result = (int )QMenuBar_insertItem(_arg0,_arg1,_arg2);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define new_PopupMenu(_swigarg0,_swigarg1) (new PopupMenu(_swigarg0,_swigarg1))
static PyObject *_wrap_new_PopupMenu(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_PopupMenu",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_PopupMenu. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (PopupMenu *)new_PopupMenu(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_PopupMenu_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_PopupMenu(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_PopupMenu(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_PopupMenu",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_PopupMenu. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    delete_PopupMenu(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PopupMenu_insert(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4)  (_swigobj->insert(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4))
static PyObject *_wrap_PopupMenu_insert(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    int  _arg1;
    char * _arg2;
    QPixmap * _arg3;
    PopupMenu * _arg4;
    PyObject * _arg5;
    char * _argc0 = 0;
    char * _argc3 = 0;
    char * _argc4 = 0;
    PyObject * _obj5 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sisssO:PopupMenu_insert",&_argc0,&_arg1,&_arg2,&_argc3,&_argc4,&_obj5)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_insert. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of PopupMenu_insert. Expected _QPixmap_p.");
        return NULL;
        }
    }
    if (_argc4) {
        if (SWIG_GetPtr(_argc4,(void **) &_arg4,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 5 of PopupMenu_insert. Expected _PopupMenu_p.");
        return NULL;
        }
    }
{
  /*
if(!PyCFunction_Check(_obj5))
  {
    PyErr_SetString(PyExc_TypeError, "Function object expected!");
    return NULL;	
  }
  */ 	
  _arg5 = _obj5;
}
    PopupMenu_insert(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PopupMenu_move(_swigobj,_swigarg0,_swigarg1)  (_swigobj->move(_swigarg0,_swigarg1))
static PyObject *_wrap_PopupMenu_move(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:PopupMenu_move",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_move. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    PopupMenu_move(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PopupMenu_modal(_swigobj)  (_swigobj->modal())
static PyObject *_wrap_PopupMenu_modal(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    PopupMenu * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:PopupMenu_modal",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_modal. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    _result = (int )PopupMenu_modal(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define PopupMenu_show(_swigobj)  (_swigobj->show())
static PyObject *_wrap_PopupMenu_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:PopupMenu_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_show. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    PopupMenu_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PopupMenu_hide(_swigobj)  (_swigobj->hide())
static PyObject *_wrap_PopupMenu_hide(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:PopupMenu_hide",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_hide. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    PopupMenu_hide(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PopupMenu_popup(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->popup(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_PopupMenu_popup(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3 = 0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii|i:PopupMenu_popup",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_popup. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    PopupMenu_popup(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define PopupMenu_selected(_swigobj,_swigarg0)  (_swigobj->selected(_swigarg0))
static PyObject *_wrap_PopupMenu_selected(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    PopupMenu * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:PopupMenu_selected",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_PopupMenu_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of PopupMenu_selected. Expected _PopupMenu_p.");
        return NULL;
        }
    }
    PopupMenu_selected(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define new_MenuData() (new MenuData())
static PyObject *_wrap_new_MenuData(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MenuData * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_MenuData")) 
        return NULL;
    _result = (MenuData *)new_MenuData();
    SWIG_MakePtr(_ptemp, (char *) _result,"_MenuData_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_MenuData(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_MenuData(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MenuData * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_MenuData",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MenuData_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_MenuData. Expected _MenuData_p.");
        return NULL;
        }
    }
    delete_MenuData(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define MenuData_insertItemText(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->insertItemText(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_MenuData_insertItemText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    MenuData * _arg0;
    char * _arg1;
    QObject * _arg2;
    char * _arg3;
    int  _arg4 = 0;
    char * _argc0 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssss|i:MenuData_insertItemText",&_argc0,&_arg1,&_argc2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MenuData_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MenuData_insertItemText. Expected _MenuData_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QObject_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of MenuData_insertItemText. Expected _QObject_p.");
        return NULL;
        }
    }
    _result = (int )MenuData_insertItemText(_arg0,_arg1,_arg2,_arg3,_arg4);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define MenuData_insertItemQPixmap(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->insertItemQPixmap(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_MenuData_insertItemQPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    MenuData * _arg0;
    QPixmap * _arg1;
    QObject * _arg2;
    char * _arg3;
    int  _arg4 = 0;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc2 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssss|i:MenuData_insertItemQPixmap",&_argc0,&_argc1,&_argc2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MenuData_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MenuData_insertItemQPixmap. Expected _MenuData_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of MenuData_insertItemQPixmap. Expected _QPixmap_p.");
        return NULL;
        }
    }
    if (_argc2) {
        if (SWIG_GetPtr(_argc2,(void **) &_arg2,"_QObject_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 3 of MenuData_insertItemQPixmap. Expected _QObject_p.");
        return NULL;
        }
    }
    _result = (int )MenuData_insertItemQPixmap(_arg0,*_arg1,_arg2,_arg3,_arg4);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define MenuData_insertItemQPixmapText(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4)  (_swigobj->insertItemQPixmapText(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4))
static PyObject *_wrap_MenuData_insertItemQPixmapText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    MenuData * _arg0;
    QPixmap * _arg1;
    char * _arg2;
    QObject * _arg3;
    char * _arg4;
    int  _arg5 = 0;
    char * _argc0 = 0;
    char * _argc1 = 0;
    char * _argc3 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sssss|i:MenuData_insertItemQPixmapText",&_argc0,&_argc1,&_arg2,&_argc3,&_arg4,&_arg5)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MenuData_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MenuData_insertItemQPixmapText. Expected _MenuData_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_QPixmap_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of MenuData_insertItemQPixmapText. Expected _QPixmap_p.");
        return NULL;
        }
    }
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_QObject_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of MenuData_insertItemQPixmapText. Expected _QObject_p.");
        return NULL;
        }
    }
    _result = (int )MenuData_insertItemQPixmapText(_arg0,*_arg1,_arg2,_arg3,_arg4,_arg5);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define MenuData_insertSeparator(_swigobj,_swigarg0)  (_swigobj->insertSeparator(_swigarg0))
static PyObject *_wrap_MenuData_insertSeparator(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    MenuData * _arg0;
    int  _arg1 = -1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|i:MenuData_insertSeparator",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_MenuData_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of MenuData_insertSeparator. Expected _MenuData_p.");
        return NULL;
        }
    }
    MenuData_insertSeparator(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define new_QMessageBox(_swigarg0,_swigarg1) (new QMessageBox(_swigarg0,_swigarg1))
static PyObject *_wrap_new_QMessageBox(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMessageBox * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_QMessageBox",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_QMessageBox. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (QMessageBox *)new_QMessageBox(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_QMessageBox_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define QMessageBox_information(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7)  (_swigobj->information(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7))
static PyObject *_wrap_QMessageBox_information(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QMessageBox * _arg0;
    Widget * _arg1;
    char * _arg2;
    char * _arg3;
    char * _arg4 = "OK";
    char * _arg5 = 0;
    char * _arg6 = 0;
    int  _arg7 = 0;
    int  _arg8 = -1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssss|sssii:QMessageBox_information",&_argc0,&_argc1,&_arg2,&_arg3,&_arg4,&_arg5,&_arg6,&_arg7,&_arg8)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMessageBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMessageBox_information. Expected _QMessageBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QMessageBox_information. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (int )QMessageBox_information(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7,_arg8);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QMessageBox_warning(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7)  (_swigobj->warning(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7))
static PyObject *_wrap_QMessageBox_warning(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QMessageBox * _arg0;
    Widget * _arg1;
    char * _arg2;
    char * _arg3;
    char * _arg4 = "OK";
    char * _arg5 = 0;
    char * _arg6 = 0;
    int  _arg7 = 0;
    int  _arg8 = -1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssss|sssii:QMessageBox_warning",&_argc0,&_argc1,&_arg2,&_arg3,&_arg4,&_arg5,&_arg6,&_arg7,&_arg8)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMessageBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMessageBox_warning. Expected _QMessageBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QMessageBox_warning. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (int )QMessageBox_warning(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7,_arg8);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QMessageBox_critical(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7)  (_swigobj->critical(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7))
static PyObject *_wrap_QMessageBox_critical(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    QMessageBox * _arg0;
    Widget * _arg1;
    char * _arg2;
    char * _arg3;
    char * _arg4 = "OK";
    char * _arg5 = 0;
    char * _arg6 = 0;
    int  _arg7 = 0;
    int  _arg8 = -1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssss|sssii:QMessageBox_critical",&_argc0,&_argc1,&_arg2,&_arg3,&_arg4,&_arg5,&_arg6,&_arg7,&_arg8)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMessageBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMessageBox_critical. Expected _QMessageBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QMessageBox_critical. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (int )QMessageBox_critical(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7,_arg8);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define QMessageBox_about(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->about(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_QMessageBox_about(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMessageBox * _arg0;
    Widget * _arg1;
    char * _arg2;
    char * _arg3;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssss:QMessageBox_about",&_argc0,&_argc1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMessageBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMessageBox_about. Expected _QMessageBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QMessageBox_about. Expected _Widget_p.");
        return NULL;
        }
    }
    QMessageBox_about(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QMessageBox_aboutQt(_swigobj,_swigarg0,_swigarg1)  (_swigobj->aboutQt(_swigarg0,_swigarg1))
static PyObject *_wrap_QMessageBox_aboutQt(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMessageBox * _arg0;
    Widget * _arg1;
    char * _arg2 = 0;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss|s:QMessageBox_aboutQt",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMessageBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMessageBox_aboutQt. Expected _QMessageBox_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of QMessageBox_aboutQt. Expected _Widget_p.");
        return NULL;
        }
    }
    QMessageBox_aboutQt(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QMessageBox_text(_swigobj)  (_swigobj->text())
static PyObject *_wrap_QMessageBox_text(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    QMessageBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QMessageBox_text",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMessageBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMessageBox_text. Expected _QMessageBox_p.");
        return NULL;
        }
    }
    _result = (char *)QMessageBox_text(_arg0);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define QMessageBox_setText(_swigobj,_swigarg0)  (_swigobj->setText(_swigarg0))
static PyObject *_wrap_QMessageBox_setText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMessageBox * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:QMessageBox_setText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMessageBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMessageBox_setText. Expected _QMessageBox_p.");
        return NULL;
        }
    }
    QMessageBox_setText(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QMessageBox_buttonText(_swigobj,_swigarg0)  (_swigobj->buttonText(_swigarg0))
static PyObject *_wrap_QMessageBox_buttonText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    QMessageBox * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:QMessageBox_buttonText",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMessageBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMessageBox_buttonText. Expected _QMessageBox_p.");
        return NULL;
        }
    }
    _result = (char *)QMessageBox_buttonText(_arg0,_arg1);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

#define QMessageBox_setButtonText(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setButtonText(_swigarg0,_swigarg1))
static PyObject *_wrap_QMessageBox_setButtonText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMessageBox * _arg0;
    int  _arg1;
    char * _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sis:QMessageBox_setButtonText",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMessageBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMessageBox_setButtonText. Expected _QMessageBox_p.");
        return NULL;
        }
    }
    QMessageBox_setButtonText(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define QMessageBox_adjustSize(_swigobj)  (_swigobj->adjustSize())
static PyObject *_wrap_QMessageBox_adjustSize(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    QMessageBox * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:QMessageBox_adjustSize",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_QMessageBox_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of QMessageBox_adjustSize. Expected _QMessageBox_p.");
        return NULL;
        }
    }
    QMessageBox_adjustSize(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *Swigqdbt_tabularToWidget(void *ptr) {
    qdbt_tabular *src;
    Widget *dest;
    src = (qdbt_tabular *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *Swigqdbt_tabularToObject(void *ptr) {
    qdbt_tabular *src;
    Object *dest;
    src = (qdbt_tabular *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_qdbt_tabular(_swigarg0,_swigarg1) (new qdbt_tabular(_swigarg0,_swigarg1))
static PyObject *_wrap_new_qdbt_tabular(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _result;
    Widget * _arg0;
    char * _arg1;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss:new_qdbt_tabular",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_qdbt_tabular. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (qdbt_tabular *)new_qdbt_tabular(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_qdbt_tabular_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define qdbt_tabular_setColumnWidth(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setColumnWidth(_swigarg0,_swigarg1))
static PyObject *_wrap_qdbt_tabular_setColumnWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:qdbt_tabular_setColumnWidth",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_setColumnWidth. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    qdbt_tabular_setColumnWidth(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define qdbt_tabular_setDimensions(_swigobj,_swigarg0,_swigarg1)  (_swigobj->setDimensions(_swigarg0,_swigarg1))
static PyObject *_wrap_qdbt_tabular_setDimensions(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    int  _arg1;
    int  _arg2;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sii:qdbt_tabular_setDimensions",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_setDimensions. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    qdbt_tabular_setDimensions(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define qdbt_tabular_setGeometry(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->setGeometry(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_qdbt_tabular_setGeometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siiii:qdbt_tabular_setGeometry",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_setGeometry. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    qdbt_tabular_setGeometry(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define qdbt_tabular_insertRow(_swigobj,_swigarg0,_swigarg1)  (_swigobj->insertRow(_swigarg0,_swigarg1))
static PyObject *_wrap_qdbt_tabular_insertRow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    int  _arg1 = -1;
    bool  _arg2 = TRUE;
    char * _argc0 = 0;
    int tempbool2;

    self = self;
    if(!PyArg_ParseTuple(args,"s|ii:qdbt_tabular_insertRow",&_argc0,&_arg1,&tempbool2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_insertRow. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    _arg2 = (bool ) tempbool2;
    qdbt_tabular_insertRow(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define qdbt_tabular_removeRow(_swigobj,_swigarg0)  (_swigobj->removeRow(_swigarg0))
static PyObject *_wrap_qdbt_tabular_removeRow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:qdbt_tabular_removeRow",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_removeRow. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    qdbt_tabular_removeRow(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define qdbt_tabular_insertCol(_swigobj,_swigarg0)  (_swigobj->insertCol(_swigarg0))
static PyObject *_wrap_qdbt_tabular_insertCol(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    int  _arg1 = -1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|i:qdbt_tabular_insertCol",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_insertCol. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    qdbt_tabular_insertCol(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define qdbt_tabular_removeCol(_swigobj,_swigarg0)  (_swigobj->removeCol(_swigarg0))
static PyObject *_wrap_qdbt_tabular_removeCol(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    int  _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"si:qdbt_tabular_removeCol",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_removeCol. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    qdbt_tabular_removeCol(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define qdbt_tabular_clear(_swigobj)  (_swigobj->clear())
static PyObject *_wrap_qdbt_tabular_clear(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:qdbt_tabular_clear",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_clear. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    qdbt_tabular_clear(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define qdbt_tabular_numRows(_swigobj)  (_swigobj->numRows())
static PyObject *_wrap_qdbt_tabular_numRows(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    qdbt_tabular * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:qdbt_tabular_numRows",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_numRows. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    _result = (int )qdbt_tabular_numRows(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define qdbt_tabular_numCols(_swigobj)  (_swigobj->numCols())
static PyObject *_wrap_qdbt_tabular_numCols(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    qdbt_tabular * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:qdbt_tabular_numCols",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_numCols. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    _result = (int )qdbt_tabular_numCols(_arg0);
    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define qdbt_tabular_cellTextAndPixmap(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6)  (_swigobj->cellTextAndPixmap(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6))
static PyObject *_wrap_qdbt_tabular_cellTextAndPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    char * _arg1;
    char * _arg2;
    int  _arg3;
    int  _arg4;
    char * _arg5 = "black";
    int  _arg6 = AlignLeft;
    bool  _arg7 = FALSE;
    char * _argc0 = 0;
    int tempbool7;

    self = self;
    if(!PyArg_ParseTuple(args,"sssii|sii:qdbt_tabular_cellTextAndPixmap",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4,&_arg5,&_arg6,&tempbool7)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_cellTextAndPixmap. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    _arg7 = (bool ) tempbool7;
    qdbt_tabular_cellTextAndPixmap(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define qdbt_tabular_cellText(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5)  (_swigobj->cellText(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5))
static PyObject *_wrap_qdbt_tabular_cellText(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    char * _arg1;
    int  _arg2;
    int  _arg3;
    char * _arg4 = "black";
    int  _arg5 = AlignLeft;
    bool  _arg6 = FALSE;
    char * _argc0 = 0;
    int tempbool6;

    self = self;
    if(!PyArg_ParseTuple(args,"ssii|sii:qdbt_tabular_cellText",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4,&_arg5,&tempbool6)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_cellText. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    _arg6 = (bool ) tempbool6;
    qdbt_tabular_cellText(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define qdbt_tabular_cellPixmap(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->cellPixmap(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_qdbt_tabular_cellPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    char * _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4 = AlignLeft;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ssii|i:qdbt_tabular_cellPixmap",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_cellPixmap. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    qdbt_tabular_cellPixmap(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define qdbt_tabular_section(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->section(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_qdbt_tabular_section(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    qdbt_tabular * _arg0;
    int  _arg1;
    char * _arg2;
    int  _arg3 = AlignLeft;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sis|i:qdbt_tabular_section",&_argc0,&_arg1,&_arg2,&_arg3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_qdbt_tabular_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of qdbt_tabular_section. Expected _qdbt_tabular_p.");
        return NULL;
        }
    }
    qdbt_tabular_section(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigtreeviewToWidget(void *ptr) {
    treeview *src;
    Widget *dest;
    src = (treeview *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigtreeviewToObject(void *ptr) {
    treeview *src;
    Object *dest;
    src = (treeview *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_treeview(_swigarg0,_swigarg1,_swigarg2) (new treeview(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_treeview(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    int  _arg2 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ssi:new_treeview",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_treeview. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (treeview *)new_treeview(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_treeview_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define treeview_setGeometry(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->setGeometry(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_treeview_setGeometry(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;
    int  _arg4;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"siiii:treeview_setGeometry",&_argc0,&_arg1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_treeview_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of treeview_setGeometry. Expected _treeview_p.");
        return NULL;
        }
    }
    treeview_setGeometry(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define treeview_create(_swigobj,_swigarg0,_swigarg1)  (_swigobj->create(_swigarg0,_swigarg1))
static PyObject *_wrap_treeview_create(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _arg0;
    char * _arg1 = "/";
    bool  _arg2 = FALSE;
    char * _argc0 = 0;
    int tempbool2;

    self = self;
    if(!PyArg_ParseTuple(args,"s|si:treeview_create",&_argc0,&_arg1,&tempbool2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_treeview_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of treeview_create. Expected _treeview_p.");
        return NULL;
        }
    }
    _arg2 = (bool ) tempbool2;
    treeview_create(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define treeview_setRootIconPath(_swigobj,_swigarg0)  (_swigobj->setRootIconPath(_swigarg0))
static PyObject *_wrap_treeview_setRootIconPath(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:treeview_setRootIconPath",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_treeview_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of treeview_setRootIconPath. Expected _treeview_p.");
        return NULL;
        }
    }
    treeview_setRootIconPath(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define treeview_setParentIconPath(_swigobj,_swigarg0)  (_swigobj->setParentIconPath(_swigarg0))
static PyObject *_wrap_treeview_setParentIconPath(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:treeview_setParentIconPath",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_treeview_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of treeview_setParentIconPath. Expected _treeview_p.");
        return NULL;
        }
    }
    treeview_setParentIconPath(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define treeview_setChildIconPath(_swigobj,_swigarg0)  (_swigobj->setChildIconPath(_swigarg0))
static PyObject *_wrap_treeview_setChildIconPath(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:treeview_setChildIconPath",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_treeview_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of treeview_setChildIconPath. Expected _treeview_p.");
        return NULL;
        }
    }
    treeview_setChildIconPath(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define treeview_setParentOpenIcon(_swigobj,_swigarg0)  (_swigobj->setParentOpenIcon(_swigarg0))
static PyObject *_wrap_treeview_setParentOpenIcon(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:treeview_setParentOpenIcon",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_treeview_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of treeview_setParentOpenIcon. Expected _treeview_p.");
        return NULL;
        }
    }
    treeview_setParentOpenIcon(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define treeview_insertParent(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->insertParent(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_treeview_insertParent(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _arg0;
    char * _arg1;
    char * _arg2;
    char * _arg3 = 0;
    bool  _arg4 = FALSE;
    char * _argc0 = 0;
    int tempbool4;

    self = self;
    if(!PyArg_ParseTuple(args,"sss|si:treeview_insertParent",&_argc0,&_arg1,&_arg2,&_arg3,&tempbool4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_treeview_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of treeview_insertParent. Expected _treeview_p.");
        return NULL;
        }
    }
    _arg4 = (bool ) tempbool4;
    treeview_insertParent(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define treeview_insertChild(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->insertChild(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_treeview_insertChild(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _arg0;
    char * _arg1;
    char * _arg2;
    char * _arg3 = 0;
    bool  _arg4 = FALSE;
    char * _argc0 = 0;
    int tempbool4;

    self = self;
    if(!PyArg_ParseTuple(args,"sss|si:treeview_insertChild",&_argc0,&_arg1,&_arg2,&_arg3,&tempbool4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_treeview_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of treeview_insertChild. Expected _treeview_p.");
        return NULL;
        }
    }
    _arg4 = (bool ) tempbool4;
    treeview_insertChild(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define treeview_updateTree(_swigobj,_swigarg0)  (_swigobj->updateTree(_swigarg0))
static PyObject *_wrap_treeview_updateTree(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _arg0;
    char * _arg1 = "/";
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|s:treeview_updateTree",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_treeview_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of treeview_updateTree. Expected _treeview_p.");
        return NULL;
        }
    }
    treeview_updateTree(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define treeview_removePath(_swigobj,_swigarg0)  (_swigobj->removePath(_swigarg0))
static PyObject *_wrap_treeview_removePath(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _arg0;
    char * _arg1 = "/";
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|s:treeview_removePath",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_treeview_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of treeview_removePath. Expected _treeview_p.");
        return NULL;
        }
    }
    treeview_removePath(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define treeview_setCurrentPath(_swigobj,_swigarg0)  (_swigobj->setCurrentPath(_swigarg0))
static PyObject *_wrap_treeview_setCurrentPath(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    treeview * _arg0;
    char * _arg1 = "/";
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s|s:treeview_setCurrentPath",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_treeview_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of treeview_setCurrentPath. Expected _treeview_p.");
        return NULL;
        }
    }
    treeview_setCurrentPath(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigsplitterToWidget(void *ptr) {
    splitter *src;
    Widget *dest;
    src = (splitter *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigsplitterToObject(void *ptr) {
    splitter *src;
    Object *dest;
    src = (splitter *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_splitter(_swigarg0,_swigarg1) (new splitter(_swigarg0,_swigarg1))
static PyObject *_wrap_new_splitter(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    splitter * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ss:new_splitter",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_splitter. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (splitter *)new_splitter(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_splitter_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define splitter_setVertical(_swigobj)  (_swigobj->setVertical())
static PyObject *_wrap_splitter_setVertical(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    splitter * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:splitter_setVertical",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_splitter_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of splitter_setVertical. Expected _splitter_p.");
        return NULL;
        }
    }
    splitter_setVertical(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigmainwindowToWidget(void *ptr) {
    mainwindow *src;
    Widget *dest;
    src = (mainwindow *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigmainwindowToObject(void *ptr) {
    mainwindow *src;
    Object *dest;
    src = (mainwindow *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_mainwindow(_swigarg0,_swigarg1,_swigarg2) (new mainwindow(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_new_mainwindow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    mainwindow * _result;
    Widget * _arg0 = 0;
    char * _arg1 = 0;
    long  _arg2 = 0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"|ssl:new_mainwindow",&_argc0,&_arg1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_mainwindow. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (mainwindow *)new_mainwindow(_arg0,_arg1,_arg2);
    SWIG_MakePtr(_ptemp, (char *) _result,"_mainwindow_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_mainwindow(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_mainwindow(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    mainwindow * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_mainwindow",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_mainwindow_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_mainwindow. Expected _mainwindow_p.");
        return NULL;
        }
    }
    delete_mainwindow(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define mainwindow_setCentralWidget(_swigobj,_swigarg0)  (_swigobj->setCentralWidget(_swigarg0))
static PyObject *_wrap_mainwindow_setCentralWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    mainwindow * _arg0;
    Widget * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:mainwindow_setCentralWidget",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_mainwindow_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of mainwindow_setCentralWidget. Expected _mainwindow_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of mainwindow_setCentralWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    mainwindow_setCentralWidget(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define mainwindow_addToolBar(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->addToolBar(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_mainwindow_addToolBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    mainwindow * _arg0;
    ToolBar * _arg1;
    char * _arg2;
    char * _arg3 = 0;
    bool  _arg4 = FALSE;
    char * _argc0 = 0;
    char * _argc1 = 0;
    int tempbool4;

    self = self;
    if(!PyArg_ParseTuple(args,"sss|si:mainwindow_addToolBar",&_argc0,&_argc1,&_arg2,&_arg3,&tempbool4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_mainwindow_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of mainwindow_addToolBar. Expected _mainwindow_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_ToolBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of mainwindow_addToolBar. Expected _ToolBar_p.");
        return NULL;
        }
    }
    _arg4 = (bool ) tempbool4;
    mainwindow_addToolBar(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define mainwindow_removeToolBar(_swigobj,_swigarg0)  (_swigobj->removeToolBar(_swigarg0))
static PyObject *_wrap_mainwindow_removeToolBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    mainwindow * _arg0;
    ToolBar * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:mainwindow_removeToolBar",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_mainwindow_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of mainwindow_removeToolBar. Expected _mainwindow_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_ToolBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of mainwindow_removeToolBar. Expected _ToolBar_p.");
        return NULL;
        }
    }
    mainwindow_removeToolBar(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define mainwindow_show(_swigobj)  (_swigobj->show())
static PyObject *_wrap_mainwindow_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    mainwindow * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:mainwindow_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_mainwindow_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of mainwindow_show. Expected _mainwindow_p.");
        return NULL;
        }
    }
    mainwindow_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define mainwindow_addStatusBar(_swigobj)  (_swigobj->addStatusBar())
static PyObject *_wrap_mainwindow_addStatusBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    mainwindow * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:mainwindow_addStatusBar",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_mainwindow_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of mainwindow_addStatusBar. Expected _mainwindow_p.");
        return NULL;
        }
    }
    mainwindow_addStatusBar(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define mainwindow_centralWidget(_swigobj)  (_swigobj->centralWidget())
static PyObject *_wrap_mainwindow_centralWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Widget * _result;
    mainwindow * _arg0;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"s:mainwindow_centralWidget",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_mainwindow_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of mainwindow_centralWidget. Expected _mainwindow_p.");
        return NULL;
        }
    }
    _result = (Widget *)mainwindow_centralWidget(_arg0);
    SWIG_MakePtr(_ptemp, (char *) _result,"_Widget_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define mainwindow_addWidgetToStatusBar(_swigobj,_swigarg0,_swigarg1,_swigarg2)  (_swigobj->addWidgetToStatusBar(_swigarg0,_swigarg1,_swigarg2))
static PyObject *_wrap_mainwindow_addWidgetToStatusBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    mainwindow * _arg0;
    Widget * _arg1;
    int  _arg2;
    bool  _arg3 = FALSE;
    char * _argc0 = 0;
    char * _argc1 = 0;
    int tempbool3;

    self = self;
    if(!PyArg_ParseTuple(args,"ssi|i:mainwindow_addWidgetToStatusBar",&_argc0,&_argc1,&_arg2,&tempbool3)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_mainwindow_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of mainwindow_addWidgetToStatusBar. Expected _mainwindow_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of mainwindow_addWidgetToStatusBar. Expected _Widget_p.");
        return NULL;
        }
    }
    _arg3 = (bool ) tempbool3;
    mainwindow_addWidgetToStatusBar(_arg0,_arg1,_arg2,_arg3);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define mainwindow_removeWidgetFromStatusBar(_swigobj,_swigarg0)  (_swigobj->removeWidgetFromStatusBar(_swigarg0))
static PyObject *_wrap_mainwindow_removeWidgetFromStatusBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    mainwindow * _arg0;
    Widget * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:mainwindow_removeWidgetFromStatusBar",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_mainwindow_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of mainwindow_removeWidgetFromStatusBar. Expected _mainwindow_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of mainwindow_removeWidgetFromStatusBar. Expected _Widget_p.");
        return NULL;
        }
    }
    mainwindow_removeWidgetFromStatusBar(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigToolBarToWidget(void *ptr) {
    ToolBar *src;
    Widget *dest;
    src = (ToolBar *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigToolBarToObject(void *ptr) {
    ToolBar *src;
    Object *dest;
    src = (ToolBar *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_ToolBar(_swigarg0,_swigarg1) (new ToolBar(_swigarg0,_swigarg1))
static PyObject *_wrap_new_ToolBar(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ToolBar * _result;
    Widget * _arg0;
    char * _arg1;
    char * _argc0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"ss:new_ToolBar",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_ToolBar. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (ToolBar *)new_ToolBar(_arg0,_arg1);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ToolBar_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define ToolBar_addSeparator(_swigobj)  (_swigobj->addSeparator())
static PyObject *_wrap_ToolBar_addSeparator(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ToolBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ToolBar_addSeparator",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ToolBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ToolBar_addSeparator. Expected _ToolBar_p.");
        return NULL;
        }
    }
    ToolBar_addSeparator(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ToolBar_setOrientation(_swigobj,_swigarg0)  (_swigobj->setOrientation(_swigarg0))
static PyObject *_wrap_ToolBar_setOrientation(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ToolBar * _arg0;
    char * _arg1;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:ToolBar_setOrientation",&_argc0,&_arg1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ToolBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ToolBar_setOrientation. Expected _ToolBar_p.");
        return NULL;
        }
    }
    ToolBar_setOrientation(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ToolBar_show(_swigobj)  (_swigobj->show())
static PyObject *_wrap_ToolBar_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ToolBar * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:ToolBar_show",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ToolBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ToolBar_show. Expected _ToolBar_p.");
        return NULL;
        }
    }
    ToolBar_show(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define ToolBar_setStretchableWidget(_swigobj,_swigarg0)  (_swigobj->setStretchableWidget(_swigarg0))
static PyObject *_wrap_ToolBar_setStretchableWidget(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ToolBar * _arg0;
    Widget * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:ToolBar_setStretchableWidget",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_ToolBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of ToolBar_setStretchableWidget. Expected _ToolBar_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of ToolBar_setStretchableWidget. Expected _Widget_p.");
        return NULL;
        }
    }
    ToolBar_setStretchableWidget(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigToolButtonToWidget(void *ptr) {
    ToolButton *src;
    Widget *dest;
    src = (ToolButton *) ptr;
    dest = (Widget *) src;
    return (void *) dest;
}

static void *SwigToolButtonToObject(void *ptr) {
    ToolButton *src;
    Object *dest;
    src = (ToolButton *) ptr;
    dest = (Object *) src;
    return (void *) dest;
}

#define new_ToolButton(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4) (new ToolButton(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4))
static PyObject *_wrap_new_ToolButton(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ToolButton * _result;
    char * _arg0;
    char * _arg1;
    char * _arg2;
    ToolBar * _arg3;
    char * _arg4;
    char * _argc3 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"sssss:new_ToolButton",&_arg0,&_arg1,&_arg2,&_argc3,&_arg4)) 
        return NULL;
    if (_argc3) {
        if (SWIG_GetPtr(_argc3,(void **) &_arg3,"_ToolBar_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 4 of new_ToolButton. Expected _ToolBar_p.");
        return NULL;
        }
    }
    _result = (ToolButton *)new_ToolButton(_arg0,_arg1,_arg2,_arg3,_arg4);
    SWIG_MakePtr(_ptemp, (char *) _result,"_ToolButton_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define new_WhatsThis() (new WhatsThis())
static PyObject *_wrap_new_WhatsThis(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    WhatsThis * _result;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,":new_WhatsThis")) 
        return NULL;
    _result = (WhatsThis *)new_WhatsThis();
    SWIG_MakePtr(_ptemp, (char *) _result,"_WhatsThis_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define delete_WhatsThis(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_WhatsThis(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    WhatsThis * _arg0;
    char * _argc0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"s:delete_WhatsThis",&_argc0)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_WhatsThis_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_WhatsThis. Expected _WhatsThis_p.");
        return NULL;
        }
    }
    delete_WhatsThis(_arg0);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define WhatsThis_add(_swigobj,_swigarg0,_swigarg1)  (_swigobj->add(_swigarg0,_swigarg1))
static PyObject *_wrap_WhatsThis_add(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    WhatsThis * _arg0;
    Widget * _arg1;
    char * _arg2;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sss:WhatsThis_add",&_argc0,&_argc1,&_arg2)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_WhatsThis_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of WhatsThis_add. Expected _WhatsThis_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of WhatsThis_add. Expected _Widget_p.");
        return NULL;
        }
    }
    WhatsThis_add(_arg0,_arg1,_arg2);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define WhatsThis_addWithPixmap(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3)  (_swigobj->addWithPixmap(_swigarg0,_swigarg1,_swigarg2,_swigarg3))
static PyObject *_wrap_WhatsThis_addWithPixmap(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    WhatsThis * _arg0;
    Widget * _arg1;
    char * _arg2;
    char * _arg3;
    char * _arg4;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"sssss:WhatsThis_addWithPixmap",&_argc0,&_argc1,&_arg2,&_arg3,&_arg4)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_WhatsThis_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of WhatsThis_addWithPixmap. Expected _WhatsThis_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of WhatsThis_addWithPixmap. Expected _Widget_p.");
        return NULL;
        }
    }
    WhatsThis_addWithPixmap(_arg0,_arg1,_arg2,_arg3,_arg4);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define WhatsThis_remove(_swigobj,_swigarg0)  (_swigobj->remove(_swigarg0))
static PyObject *_wrap_WhatsThis_remove(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    WhatsThis * _arg0;
    Widget * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:WhatsThis_remove",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_WhatsThis_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of WhatsThis_remove. Expected _WhatsThis_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of WhatsThis_remove. Expected _Widget_p.");
        return NULL;
        }
    }
    WhatsThis_remove(_arg0,_arg1);
    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define WhatsThis_textFor(_swigobj,_swigarg0)  (_swigobj->textFor(_swigarg0))
static PyObject *_wrap_WhatsThis_textFor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    char * _result;
    WhatsThis * _arg0;
    Widget * _arg1;
    char * _argc0 = 0;
    char * _argc1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"ss:WhatsThis_textFor",&_argc0,&_argc1)) 
        return NULL;
    if (_argc0) {
        if (SWIG_GetPtr(_argc0,(void **) &_arg0,"_WhatsThis_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of WhatsThis_textFor. Expected _WhatsThis_p.");
        return NULL;
        }
    }
    if (_argc1) {
        if (SWIG_GetPtr(_argc1,(void **) &_arg1,"_Widget_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of WhatsThis_textFor. Expected _Widget_p.");
        return NULL;
        }
    }
    _result = (char *)WhatsThis_textFor(_arg0,_arg1);
    _resultobj = Py_BuildValue("s", _result);
    return _resultobj;
}

static PyMethodDef pythonqtcMethods[] = {
	 { "WhatsThis_textFor", _wrap_WhatsThis_textFor, 1 },
	 { "WhatsThis_remove", _wrap_WhatsThis_remove, 1 },
	 { "WhatsThis_addWithPixmap", _wrap_WhatsThis_addWithPixmap, 1 },
	 { "WhatsThis_add", _wrap_WhatsThis_add, 1 },
	 { "delete_WhatsThis", _wrap_delete_WhatsThis, 1 },
	 { "new_WhatsThis", _wrap_new_WhatsThis, 1 },
	 { "new_ToolButton", _wrap_new_ToolButton, 1 },
	 { "ToolBar_setStretchableWidget", _wrap_ToolBar_setStretchableWidget, 1 },
	 { "ToolBar_show", _wrap_ToolBar_show, 1 },
	 { "ToolBar_setOrientation", _wrap_ToolBar_setOrientation, 1 },
	 { "ToolBar_addSeparator", _wrap_ToolBar_addSeparator, 1 },
	 { "new_ToolBar", _wrap_new_ToolBar, 1 },
	 { "mainwindow_removeWidgetFromStatusBar", _wrap_mainwindow_removeWidgetFromStatusBar, 1 },
	 { "mainwindow_addWidgetToStatusBar", _wrap_mainwindow_addWidgetToStatusBar, 1 },
	 { "mainwindow_centralWidget", _wrap_mainwindow_centralWidget, 1 },
	 { "mainwindow_addStatusBar", _wrap_mainwindow_addStatusBar, 1 },
	 { "mainwindow_show", _wrap_mainwindow_show, 1 },
	 { "mainwindow_removeToolBar", _wrap_mainwindow_removeToolBar, 1 },
	 { "mainwindow_addToolBar", _wrap_mainwindow_addToolBar, 1 },
	 { "mainwindow_setCentralWidget", _wrap_mainwindow_setCentralWidget, 1 },
	 { "delete_mainwindow", _wrap_delete_mainwindow, 1 },
	 { "new_mainwindow", _wrap_new_mainwindow, 1 },
	 { "splitter_setVertical", _wrap_splitter_setVertical, 1 },
	 { "new_splitter", _wrap_new_splitter, 1 },
	 { "treeview_setCurrentPath", _wrap_treeview_setCurrentPath, 1 },
	 { "treeview_removePath", _wrap_treeview_removePath, 1 },
	 { "treeview_updateTree", _wrap_treeview_updateTree, 1 },
	 { "treeview_insertChild", _wrap_treeview_insertChild, 1 },
	 { "treeview_insertParent", _wrap_treeview_insertParent, 1 },
	 { "treeview_setParentOpenIcon", _wrap_treeview_setParentOpenIcon, 1 },
	 { "treeview_setChildIconPath", _wrap_treeview_setChildIconPath, 1 },
	 { "treeview_setParentIconPath", _wrap_treeview_setParentIconPath, 1 },
	 { "treeview_setRootIconPath", _wrap_treeview_setRootIconPath, 1 },
	 { "treeview_create", _wrap_treeview_create, 1 },
	 { "treeview_setGeometry", _wrap_treeview_setGeometry, 1 },
	 { "new_treeview", _wrap_new_treeview, 1 },
	 { "qdbt_tabular_section", _wrap_qdbt_tabular_section, 1 },
	 { "qdbt_tabular_cellPixmap", _wrap_qdbt_tabular_cellPixmap, 1 },
	 { "qdbt_tabular_cellText", _wrap_qdbt_tabular_cellText, 1 },
	 { "qdbt_tabular_cellTextAndPixmap", _wrap_qdbt_tabular_cellTextAndPixmap, 1 },
	 { "qdbt_tabular_numCols", _wrap_qdbt_tabular_numCols, 1 },
	 { "qdbt_tabular_numRows", _wrap_qdbt_tabular_numRows, 1 },
	 { "qdbt_tabular_clear", _wrap_qdbt_tabular_clear, 1 },
	 { "qdbt_tabular_removeCol", _wrap_qdbt_tabular_removeCol, 1 },
	 { "qdbt_tabular_insertCol", _wrap_qdbt_tabular_insertCol, 1 },
	 { "qdbt_tabular_removeRow", _wrap_qdbt_tabular_removeRow, 1 },
	 { "qdbt_tabular_insertRow", _wrap_qdbt_tabular_insertRow, 1 },
	 { "qdbt_tabular_setGeometry", _wrap_qdbt_tabular_setGeometry, 1 },
	 { "qdbt_tabular_setDimensions", _wrap_qdbt_tabular_setDimensions, 1 },
	 { "qdbt_tabular_setColumnWidth", _wrap_qdbt_tabular_setColumnWidth, 1 },
	 { "new_qdbt_tabular", _wrap_new_qdbt_tabular, 1 },
	 { "QMessageBox_adjustSize", _wrap_QMessageBox_adjustSize, 1 },
	 { "QMessageBox_setButtonText", _wrap_QMessageBox_setButtonText, 1 },
	 { "QMessageBox_buttonText", _wrap_QMessageBox_buttonText, 1 },
	 { "QMessageBox_setText", _wrap_QMessageBox_setText, 1 },
	 { "QMessageBox_text", _wrap_QMessageBox_text, 1 },
	 { "QMessageBox_aboutQt", _wrap_QMessageBox_aboutQt, 1 },
	 { "QMessageBox_about", _wrap_QMessageBox_about, 1 },
	 { "QMessageBox_critical", _wrap_QMessageBox_critical, 1 },
	 { "QMessageBox_warning", _wrap_QMessageBox_warning, 1 },
	 { "QMessageBox_information", _wrap_QMessageBox_information, 1 },
	 { "new_QMessageBox", _wrap_new_QMessageBox, 1 },
	 { "MenuData_insertSeparator", _wrap_MenuData_insertSeparator, 1 },
	 { "MenuData_insertItemQPixmapText", _wrap_MenuData_insertItemQPixmapText, 1 },
	 { "MenuData_insertItemQPixmap", _wrap_MenuData_insertItemQPixmap, 1 },
	 { "MenuData_insertItemText", _wrap_MenuData_insertItemText, 1 },
	 { "delete_MenuData", _wrap_delete_MenuData, 1 },
	 { "new_MenuData", _wrap_new_MenuData, 1 },
	 { "PopupMenu_selected", _wrap_PopupMenu_selected, 1 },
	 { "PopupMenu_popup", _wrap_PopupMenu_popup, 1 },
	 { "PopupMenu_hide", _wrap_PopupMenu_hide, 1 },
	 { "PopupMenu_show", _wrap_PopupMenu_show, 1 },
	 { "PopupMenu_modal", _wrap_PopupMenu_modal, 1 },
	 { "PopupMenu_move", _wrap_PopupMenu_move, 1 },
	 { "PopupMenu_insert", _wrap_PopupMenu_insert, 1 },
	 { "delete_PopupMenu", _wrap_delete_PopupMenu, 1 },
	 { "new_PopupMenu", _wrap_new_PopupMenu, 1 },
	 { "QMenuBar_insertItem", _wrap_QMenuBar_insertItem, 1 },
	 { "QMenuBar_setSeparator", _wrap_QMenuBar_setSeparator, 1 },
	 { "QMenuBar_separator", _wrap_QMenuBar_separator, 1 },
	 { "QMenuBar_heightForWidth", _wrap_QMenuBar_heightForWidth, 1 },
	 { "QMenuBar_eventFilter", _wrap_QMenuBar_eventFilter, 1 },
	 { "QMenuBar_hide", _wrap_QMenuBar_hide, 1 },
	 { "QMenuBar_show", _wrap_QMenuBar_show, 1 },
	 { "QMenuBar_updateItem", _wrap_QMenuBar_updateItem, 1 },
	 { "delete_QMenuBar", _wrap_delete_QMenuBar, 1 },
	 { "new_QMenuBar", _wrap_new_QMenuBar, 1 },
	 { "FileDialog_dirEntered", _wrap_FileDialog_dirEntered, 1 },
	 { "FileDialog_fileSelected", _wrap_FileDialog_fileSelected, 1 },
	 { "FileDialog_fileHighlighted", _wrap_FileDialog_fileHighlighted, 1 },
	 { "FileDialog_selectedFile", _wrap_FileDialog_selectedFile, 1 },
	 { "FileDialog_path", _wrap_FileDialog_path, 1 },
	 { "FileDialog_createWithParent", _wrap_FileDialog_createWithParent, 1 },
	 { "FileDialog_create", _wrap_FileDialog_create, 1 },
	 { "FileDialog_show", _wrap_FileDialog_show, 1 },
	 { "FileDialog_height", _wrap_FileDialog_height, 1 },
	 { "FileDialog_width", _wrap_FileDialog_width, 1 },
	 { "FileDialog_top", _wrap_FileDialog_top, 1 },
	 { "FileDialog_left", _wrap_FileDialog_left, 1 },
	 { "new_FileDialog", _wrap_new_FileDialog, 1 },
	 { "ScrollBar_setSteps", _wrap_ScrollBar_setSteps, 1 },
	 { "ScrollBar_pageStep", _wrap_ScrollBar_pageStep, 1 },
	 { "ScrollBar_lineStep", _wrap_ScrollBar_lineStep, 1 },
	 { "ScrollBar_setRange", _wrap_ScrollBar_setRange, 1 },
	 { "ScrollBar_maxValue", _wrap_ScrollBar_maxValue, 1 },
	 { "ScrollBar_minValue", _wrap_ScrollBar_minValue, 1 },
	 { "ScrollBar_subtractLine", _wrap_ScrollBar_subtractLine, 1 },
	 { "ScrollBar_addLine", _wrap_ScrollBar_addLine, 1 },
	 { "ScrollBar_subtractPage", _wrap_ScrollBar_subtractPage, 1 },
	 { "ScrollBar_addPage", _wrap_ScrollBar_addPage, 1 },
	 { "ScrollBar_setValue", _wrap_ScrollBar_setValue, 1 },
	 { "ScrollBar_value", _wrap_ScrollBar_value, 1 },
	 { "ScrollBar_sizeHint", _wrap_ScrollBar_sizeHint, 1 },
	 { "ScrollBar_setPalette", _wrap_ScrollBar_setPalette, 1 },
	 { "ScrollBar_draggingSlider", _wrap_ScrollBar_draggingSlider, 1 },
	 { "ScrollBar_tracking", _wrap_ScrollBar_tracking, 1 },
	 { "ScrollBar_setTracking", _wrap_ScrollBar_setTracking, 1 },
	 { "ScrollBar_orientation", _wrap_ScrollBar_orientation, 1 },
	 { "ScrollBar_setOrientation", _wrap_ScrollBar_setOrientation, 1 },
	 { "new_ScrollBarValues", _wrap_new_ScrollBarValues, 1 },
	 { "new_ScrollBarOrientation", _wrap_new_ScrollBarOrientation, 1 },
	 { "new_ScrollBar", _wrap_new_ScrollBar, 1 },
	 { "MultiLineEdit_returnPressed", _wrap_MultiLineEdit_returnPressed, 1 },
	 { "MultiLineEdit_textChanged", _wrap_MultiLineEdit_textChanged, 1 },
	 { "MultiLineEdit_cut", _wrap_MultiLineEdit_cut, 1 },
	 { "MultiLineEdit_copyText", _wrap_MultiLineEdit_copyText, 1 },
	 { "MultiLineEdit_paste", _wrap_MultiLineEdit_paste, 1 },
	 { "MultiLineEdit_setOverwriteMode", _wrap_MultiLineEdit_setOverwriteMode, 1 },
	 { "MultiLineEdit_setReadOnly", _wrap_MultiLineEdit_setReadOnly, 1 },
	 { "MultiLineEdit_selectAll", _wrap_MultiLineEdit_selectAll, 1 },
	 { "MultiLineEdit_deselect", _wrap_MultiLineEdit_deselect, 1 },
	 { "MultiLineEdit_append", _wrap_MultiLineEdit_append, 1 },
	 { "MultiLineEdit_setText", _wrap_MultiLineEdit_setText, 1 },
	 { "MultiLineEdit_clear", _wrap_MultiLineEdit_clear, 1 },
	 { "MultiLineEdit_setAutoUpdate", _wrap_MultiLineEdit_setAutoUpdate, 1 },
	 { "MultiLineEdit_autoUpdate", _wrap_MultiLineEdit_autoUpdate, 1 },
	 { "MultiLineEdit_atEnd", _wrap_MultiLineEdit_atEnd, 1 },
	 { "MultiLineEdit_atBeginning", _wrap_MultiLineEdit_atBeginning, 1 },
	 { "MultiLineEdit_getCursorPosition", _wrap_MultiLineEdit_getCursorPosition, 1 },
	 { "MultiLineEdit_setCursorPosition", _wrap_MultiLineEdit_setCursorPosition, 1 },
	 { "MultiLineEdit_removeLine", _wrap_MultiLineEdit_removeLine, 1 },
	 { "MultiLineEdit_insertAt", _wrap_MultiLineEdit_insertAt, 1 },
	 { "MultiLineEdit_insertLine", _wrap_MultiLineEdit_insertLine, 1 },
	 { "MultiLineEdit_setFont", _wrap_MultiLineEdit_setFont, 1 },
	 { "MultiLineEdit_isOverwriteMode", _wrap_MultiLineEdit_isOverwriteMode, 1 },
	 { "MultiLineEdit_isReadOnly", _wrap_MultiLineEdit_isReadOnly, 1 },
	 { "MultiLineEdit_numLines", _wrap_MultiLineEdit_numLines, 1 },
	 { "MultiLineEdit_text", _wrap_MultiLineEdit_text, 1 },
	 { "MultiLineEdit_textLine", _wrap_MultiLineEdit_textLine, 1 },
	 { "delete_MultiLineEdit", _wrap_delete_MultiLineEdit, 1 },
	 { "new_MultiLineEdit", _wrap_new_MultiLineEdit, 1 },
	 { "ListBox_setMultiSelection", _wrap_ListBox_setMultiSelection, 1 },
	 { "ListBox_maxItemWidth", _wrap_ListBox_maxItemWidth, 1 },
	 { "ListBox_itemHeight", _wrap_ListBox_itemHeight, 1 },
	 { "ListBox_standardItemHeight", _wrap_ListBox_standardItemHeight, 1 },
	 { "ListBox_setSmoothScrolling", _wrap_ListBox_setSmoothScrolling, 1 },
	 { "ListBox_smoothScrolling", _wrap_ListBox_smoothScrolling, 1 },
	 { "ListBox_setBottomScrollBar", _wrap_ListBox_setBottomScrollBar, 1 },
	 { "ListBox_bottomScrollBar", _wrap_ListBox_bottomScrollBar, 1 },
	 { "ListBox_setAutoBottomScrollBar", _wrap_ListBox_setAutoBottomScrollBar, 1 },
	 { "ListBox_autoBottomScrollBar", _wrap_ListBox_autoBottomScrollBar, 1 },
	 { "ListBox_setScrollBar", _wrap_ListBox_setScrollBar, 1 },
	 { "ListBox_scrollBar", _wrap_ListBox_scrollBar, 1 },
	 { "ListBox_setAutoScrollBar", _wrap_ListBox_setAutoScrollBar, 1 },
	 { "ListBox_autoScrollBar", _wrap_ListBox_autoScrollBar, 1 },
	 { "ListBox_setAutoScroll", _wrap_ListBox_setAutoScroll, 1 },
	 { "ListBox_autoScroll", _wrap_ListBox_autoScroll, 1 },
	 { "ListBox_setDragSelect", _wrap_ListBox_setDragSelect, 1 },
	 { "ListBox_dragSelect", _wrap_ListBox_dragSelect, 1 },
	 { "ListBox_setTopItem", _wrap_ListBox_setTopItem, 1 },
	 { "ListBox_topItem", _wrap_ListBox_topItem, 1 },
	 { "ListBox_centerCurrentItem", _wrap_ListBox_centerCurrentItem, 1 },
	 { "ListBox_setCurrentItem", _wrap_ListBox_setCurrentItem, 1 },
	 { "ListBox_currentItem", _wrap_ListBox_currentItem, 1 },
	 { "ListBox_numItemsVisible", _wrap_ListBox_numItemsVisible, 1 },
	 { "ListBox_setAutoUpdate", _wrap_ListBox_setAutoUpdate, 1 },
	 { "ListBox_autoUpdate", _wrap_ListBox_autoUpdate, 1 },
	 { "ListBox_changePixmap", _wrap_ListBox_changePixmap, 1 },
	 { "ListBox_changeText", _wrap_ListBox_changeText, 1 },
	 { "ListBox_pixmap", _wrap_ListBox_pixmap, 1 },
	 { "ListBox_text", _wrap_ListBox_text, 1 },
	 { "ListBox_clear", _wrap_ListBox_clear, 1 },
	 { "ListBox_removeItem", _wrap_ListBox_removeItem, 1 },
	 { "ListBox_inSort", _wrap_ListBox_inSort, 1 },
	 { "ListBox_insertPixmap", _wrap_ListBox_insertPixmap, 1 },
	 { "ListBox_insertText", _wrap_ListBox_insertText, 1 },
	 { "ListBox_insertStrList", _wrap_ListBox_insertStrList, 1 },
	 { "ListBox_count", _wrap_ListBox_count, 1 },
	 { "ListBox_setFont", _wrap_ListBox_setFont, 1 },
	 { "delete_ListBox", _wrap_delete_ListBox, 1 },
	 { "new_ListBox", _wrap_new_ListBox, 1 },
	 { "delete_TableView", _wrap_delete_TableView, 1 },
	 { "new_TableView", _wrap_new_TableView, 1 },
	 { "Label_setDouble", _wrap_Label_setDouble, 1 },
	 { "Label_setInt", _wrap_Label_setInt, 1 },
	 { "Label_setPixmap", _wrap_Label_setPixmap, 1 },
	 { "Label_setText", _wrap_Label_setText, 1 },
	 { "Label_buddy", _wrap_Label_buddy, 1 },
	 { "Label_setBuddy", _wrap_Label_setBuddy, 1 },
	 { "Label_sizeHint", _wrap_Label_sizeHint, 1 },
	 { "Label_setAutoResize", _wrap_Label_setAutoResize, 1 },
	 { "Label_autoResize", _wrap_Label_autoResize, 1 },
	 { "Label_setMargin", _wrap_Label_setMargin, 1 },
	 { "Label_margin", _wrap_Label_margin, 1 },
	 { "Label_setAlignment", _wrap_Label_setAlignment, 1 },
	 { "Label_alignment", _wrap_Label_alignment, 1 },
	 { "Label_pixmap", _wrap_Label_pixmap, 1 },
	 { "Label_text", _wrap_Label_text, 1 },
	 { "delete_Label", _wrap_delete_Label, 1 },
	 { "new_LabelBuddy", _wrap_new_LabelBuddy, 1 },
	 { "new_LabelT", _wrap_new_LabelT, 1 },
	 { "new_Label", _wrap_new_Label, 1 },
	 { "ButtonGroup_setButtonState", _wrap_ButtonGroup_setButtonState, 1 },
	 { "ButtonGroup_count", _wrap_ButtonGroup_count, 1 },
	 { "ButtonGroup_find", _wrap_ButtonGroup_find, 1 },
	 { "ButtonGroup_remove", _wrap_ButtonGroup_remove, 1 },
	 { "ButtonGroup_insert", _wrap_ButtonGroup_insert, 1 },
	 { "ButtonGroup_setExclusive", _wrap_ButtonGroup_setExclusive, 1 },
	 { "ButtonGroup_isExclusive", _wrap_ButtonGroup_isExclusive, 1 },
	 { "delete_ButtonGroup", _wrap_delete_ButtonGroup, 1 },
	 { "new_ButtonGroupTitle", _wrap_new_ButtonGroupTitle, 1 },
	 { "new_ButtonGroup", _wrap_new_ButtonGroup, 1 },
	 { "GroupBox_setAlignment", _wrap_GroupBox_setAlignment, 1 },
	 { "GroupBox_alignment", _wrap_GroupBox_alignment, 1 },
	 { "GroupBox_setTitle", _wrap_GroupBox_setTitle, 1 },
	 { "GroupBox_title", _wrap_GroupBox_title, 1 },
	 { "new_GroupBoxTitle", _wrap_new_GroupBoxTitle, 1 },
	 { "new_GroupBox", _wrap_new_GroupBox, 1 },
	 { "Frame_contentsRect", _wrap_Frame_contentsRect, 1 },
	 { "Frame_frameRect", _wrap_Frame_frameRect, 1 },
	 { "Frame_frameWidth", _wrap_Frame_frameWidth, 1 },
	 { "Frame_setMidLineWidth", _wrap_Frame_setMidLineWidth, 1 },
	 { "Frame_midLineWidth", _wrap_Frame_midLineWidth, 1 },
	 { "Frame_setLineWidth", _wrap_Frame_setLineWidth, 1 },
	 { "Frame_lineWidth", _wrap_Frame_lineWidth, 1 },
	 { "Frame_lineShapesOk", _wrap_Frame_lineShapesOk, 1 },
	 { "Frame_setFrameStyle", _wrap_Frame_setFrameStyle, 1 },
	 { "Frame_frameShadow", _wrap_Frame_frameShadow, 1 },
	 { "Frame_frameShape", _wrap_Frame_frameShape, 1 },
	 { "Frame_frameStyle", _wrap_Frame_frameStyle, 1 },
	 { "new_Frame", _wrap_new_Frame, 1 },
	 { "LineEdit_deselect", _wrap_LineEdit_deselect, 1 },
	 { "LineEdit_selectAll", _wrap_LineEdit_selectAll, 1 },
	 { "LineEdit_setText", _wrap_LineEdit_setText, 1 },
	 { "LineEdit_echoMode", _wrap_LineEdit_echoMode, 1 },
	 { "LineEdit_setEchoMode", _wrap_LineEdit_setEchoMode, 1 },
	 { "LineEdit_frame", _wrap_LineEdit_frame, 1 },
	 { "LineEdit_setFrame", _wrap_LineEdit_setFrame, 1 },
	 { "LineEdit_setMaxLength", _wrap_LineEdit_setMaxLength, 1 },
	 { "LineEdit_maxLength", _wrap_LineEdit_maxLength, 1 },
	 { "LineEdit_text", _wrap_LineEdit_text, 1 },
	 { "delete_LineEdit", _wrap_delete_LineEdit, 1 },
	 { "new_LineEdit", _wrap_new_LineEdit, 1 },
	 { "TabDialog_defaultButtonPressed", _wrap_TabDialog_defaultButtonPressed, 1 },
	 { "TabDialog_cancelButtonPressed", _wrap_TabDialog_cancelButtonPressed, 1 },
	 { "TabDialog_applyButtonPressed", _wrap_TabDialog_applyButtonPressed, 1 },
	 { "TabDialog_aboutToShow", _wrap_TabDialog_aboutToShow, 1 },
	 { "TabDialog_setOKButton", _wrap_TabDialog_setOKButton, 1 },
	 { "TabDialog_hasApplyButton", _wrap_TabDialog_hasApplyButton, 1 },
	 { "TabDialog_setApplyButton", _wrap_TabDialog_setApplyButton, 1 },
	 { "TabDialog_hasCancelButton", _wrap_TabDialog_hasCancelButton, 1 },
	 { "TabDialog_setCancelButton", _wrap_TabDialog_setCancelButton, 1 },
	 { "TabDialog_hasDefaultButton", _wrap_TabDialog_hasDefaultButton, 1 },
	 { "TabDialog_setDefaultButton", _wrap_TabDialog_setDefaultButton, 1 },
	 { "TabDialog_isTabEnabled", _wrap_TabDialog_isTabEnabled, 1 },
	 { "TabDialog_addTab", _wrap_TabDialog_addTab, 1 },
	 { "TabDialog_setFont", _wrap_TabDialog_setFont, 1 },
	 { "TabDialog_show", _wrap_TabDialog_show, 1 },
	 { "delete_TabDialog", _wrap_delete_TabDialog, 1 },
	 { "new_TabDialog", _wrap_new_TabDialog, 1 },
	 { "Dialog_setGeometryRect", _wrap_Dialog_setGeometryRect, 1 },
	 { "Dialog_setGeometry", _wrap_Dialog_setGeometry, 1 },
	 { "Dialog_resizeSize", _wrap_Dialog_resizeSize, 1 },
	 { "Dialog_resize", _wrap_Dialog_resize, 1 },
	 { "Dialog_movePoint", _wrap_Dialog_movePoint, 1 },
	 { "Dialog_move", _wrap_Dialog_move, 1 },
	 { "Dialog_show", _wrap_Dialog_show, 1 },
	 { "Dialog_result", _wrap_Dialog_result, 1 },
	 { "Dialog_execDialog", _wrap_Dialog_execDialog, 1 },
	 { "delete_Dialog", _wrap_delete_Dialog, 1 },
	 { "new_Dialog", _wrap_new_Dialog, 1 },
	 { "ComboBox_insertionPolicy", _wrap_ComboBox_insertionPolicy, 1 },
	 { "ComboBox_InsertionPolicy", _wrap_ComboBox_InsertionPolicy, 1 },
	 { "ComboBox_setInsertionPolicy", _wrap_ComboBox_setInsertionPolicy, 1 },
	 { "ComboBox_maxCount", _wrap_ComboBox_maxCount, 1 },
	 { "ComboBox_setMaxCount", _wrap_ComboBox_setMaxCount, 1 },
	 { "ComboBox_sizeLimit", _wrap_ComboBox_sizeLimit, 1 },
	 { "ComboBox_setSizeLimit", _wrap_ComboBox_setSizeLimit, 1 },
	 { "ComboBox_setEnabled", _wrap_ComboBox_setEnabled, 1 },
	 { "ComboBox_setFont", _wrap_ComboBox_setFont, 1 },
	 { "ComboBox_setPalette", _wrap_ComboBox_setPalette, 1 },
	 { "ComboBox_setBackgroundColor", _wrap_ComboBox_setBackgroundColor, 1 },
	 { "ComboBox_sizeHint", _wrap_ComboBox_sizeHint, 1 },
	 { "ComboBox_setAutoResize", _wrap_ComboBox_setAutoResize, 1 },
	 { "ComboBox_autoResize", _wrap_ComboBox_autoResize, 1 },
	 { "ComboBox_setCurrentItem", _wrap_ComboBox_setCurrentItem, 1 },
	 { "ComboBox_currentItem", _wrap_ComboBox_currentItem, 1 },
	 { "ComboBox_changePixmap", _wrap_ComboBox_changePixmap, 1 },
	 { "ComboBox_changeText", _wrap_ComboBox_changeText, 1 },
	 { "ComboBox_pixmap", _wrap_ComboBox_pixmap, 1 },
	 { "ComboBox_text", _wrap_ComboBox_text, 1 },
	 { "ComboBox_currentText", _wrap_ComboBox_currentText, 1 },
	 { "ComboBox_clear", _wrap_ComboBox_clear, 1 },
	 { "ComboBox_removeItem", _wrap_ComboBox_removeItem, 1 },
	 { "ComboBox_insertPixmap", _wrap_ComboBox_insertPixmap, 1 },
	 { "ComboBox_insertText", _wrap_ComboBox_insertText, 1 },
	 { "ComboBox_insertList", _wrap_ComboBox_insertList, 1 },
	 { "ComboBox_count", _wrap_ComboBox_count, 1 },
	 { "delete_ComboBox", _wrap_delete_ComboBox, 1 },
	 { "new_ComboBoxOld", _wrap_new_ComboBoxOld, 1 },
	 { "new_ComboBox", _wrap_new_ComboBox, 1 },
	 { "RadioButton_sizeHint", _wrap_RadioButton_sizeHint, 1 },
	 { "RadioButton_setChecked", _wrap_RadioButton_setChecked, 1 },
	 { "RadioButton_isChecked", _wrap_RadioButton_isChecked, 1 },
	 { "new_RadioButtonN", _wrap_new_RadioButtonN, 1 },
	 { "new_RadioButton", _wrap_new_RadioButton, 1 },
	 { "PushButton_toggle", _wrap_PushButton_toggle, 1 },
	 { "PushButton_setOn", _wrap_PushButton_setOn, 1 },
	 { "PushButton_setGeometryRect", _wrap_PushButton_setGeometryRect, 1 },
	 { "PushButton_setGeometry", _wrap_PushButton_setGeometry, 1 },
	 { "PushButton_resizeSize", _wrap_PushButton_resizeSize, 1 },
	 { "PushButton_resize", _wrap_PushButton_resize, 1 },
	 { "PushButton_movePoint", _wrap_PushButton_movePoint, 1 },
	 { "PushButton_move", _wrap_PushButton_move, 1 },
	 { "PushButton_sizeHint", _wrap_PushButton_sizeHint, 1 },
	 { "PushButton_setDefault", _wrap_PushButton_setDefault, 1 },
	 { "PushButton_isDefault", _wrap_PushButton_isDefault, 1 },
	 { "PushButton_setAutoDefault", _wrap_PushButton_setAutoDefault, 1 },
	 { "PushButton_autoDefault", _wrap_PushButton_autoDefault, 1 },
	 { "PushButton_setToggleButton", _wrap_PushButton_setToggleButton, 1 },
	 { "new_PushButton", _wrap_new_PushButton, 1 },
	 { "new_PushButtonN", _wrap_new_PushButtonN, 1 },
	 { "CheckBox_sizeHint", _wrap_CheckBox_sizeHint, 1 },
	 { "CheckBox_setChecked", _wrap_CheckBox_setChecked, 1 },
	 { "CheckBox_isChecked", _wrap_CheckBox_isChecked, 1 },
	 { "new_CheckBoxN", _wrap_new_CheckBoxN, 1 },
	 { "new_CheckBox", _wrap_new_CheckBox, 1 },
	 { "Button_toggled", _wrap_Button_toggled, 1 },
	 { "Button_clicked", _wrap_Button_clicked, 1 },
	 { "Button_released", _wrap_Button_released, 1 },
	 { "Button_pressed", _wrap_Button_pressed, 1 },
	 { "Button_setDown", _wrap_Button_setDown, 1 },
	 { "Button_autoRepeat", _wrap_Button_autoRepeat, 1 },
	 { "Button_setAutoRepeat", _wrap_Button_setAutoRepeat, 1 },
	 { "Button_setAutoResize", _wrap_Button_setAutoResize, 1 },
	 { "Button_autoResize", _wrap_Button_autoResize, 1 },
	 { "Button_isOn", _wrap_Button_isOn, 1 },
	 { "Button_isDown", _wrap_Button_isDown, 1 },
	 { "Button_isToggleButton", _wrap_Button_isToggleButton, 1 },
	 { "Button_setPixmap", _wrap_Button_setPixmap, 1 },
	 { "Button_pixmap", _wrap_Button_pixmap, 1 },
	 { "Button_setText", _wrap_Button_setText, 1 },
	 { "Button_text", _wrap_Button_text, 1 },
	 { "delete_Button", _wrap_delete_Button, 1 },
	 { "new_Button", _wrap_new_Button, 1 },
	 { "Widget_tooltip", _wrap_Widget_tooltip, 1 },
	 { "Widget_addSplitter", _wrap_Widget_addSplitter, 1 },
	 { "Widget_addSeparator", _wrap_Widget_addSeparator, 1 },
	 { "Widget_addPopupMenu", _wrap_Widget_addPopupMenu, 1 },
	 { "Widget_parentWidget", _wrap_Widget_parentWidget, 1 },
	 { "Widget_drawTextPoint", _wrap_Widget_drawTextPoint, 1 },
	 { "Widget_drawText", _wrap_Widget_drawText, 1 },
	 { "Widget_scroll", _wrap_Widget_scroll, 1 },
	 { "Widget_eraseRect", _wrap_Widget_eraseRect, 1 },
	 { "Widget_eraseRection", _wrap_Widget_eraseRection, 1 },
	 { "Widget_erase", _wrap_Widget_erase, 1 },
	 { "Widget_recreate", _wrap_Widget_recreate, 1 },
	 { "Widget_adjustSize", _wrap_Widget_adjustSize, 1 },
	 { "Widget_sizeHint", _wrap_Widget_sizeHint, 1 },
	 { "Widget_setGeometryRect", _wrap_Widget_setGeometryRect, 1 },
	 { "Widget_setGeometry", _wrap_Widget_setGeometry, 1 },
	 { "Widget_resizeSize", _wrap_Widget_resizeSize, 1 },
	 { "Widget_resize", _wrap_Widget_resize, 1 },
	 { "Widget_movePoint", _wrap_Widget_movePoint, 1 },
	 { "Widget_move", _wrap_Widget_move, 1 },
	 { "Widget_lowerWidget", _wrap_Widget_lowerWidget, 1 },
	 { "Widget_raiseWidget", _wrap_Widget_raiseWidget, 1 },
	 { "Widget_isVisible", _wrap_Widget_isVisible, 1 },
	 { "Widget_close", _wrap_Widget_close, 1 },
	 { "Widget_iconify", _wrap_Widget_iconify, 1 },
	 { "Widget_hide", _wrap_Widget_hide, 1 },
	 { "Widget_show", _wrap_Widget_show, 1 },
	 { "Widget_repaintRect", _wrap_Widget_repaintRect, 1 },
	 { "Widget_repaintRegion", _wrap_Widget_repaintRegion, 1 },
	 { "Widget_repaint", _wrap_Widget_repaint, 1 },
	 { "Widget_updateRegion", _wrap_Widget_updateRegion, 1 },
	 { "Widget_update", _wrap_Widget_update, 1 },
	 { "Widget_setUpdatesEnabled", _wrap_Widget_setUpdatesEnabled, 1 },
	 { "Widget_isUpdatesEnabled", _wrap_Widget_isUpdatesEnabled, 1 },
	 { "Widget_releaseKeyboard", _wrap_Widget_releaseKeyboard, 1 },
	 { "Widget_grabKeyboard", _wrap_Widget_grabKeyboard, 1 },
	 { "Widget_releaseMouse", _wrap_Widget_releaseMouse, 1 },
	 { "Widget_grabMouseCursor", _wrap_Widget_grabMouseCursor, 1 },
	 { "Widget_grabMouse", _wrap_Widget_grabMouse, 1 },
	 { "Widget_clearFocus", _wrap_Widget_clearFocus, 1 },
	 { "Widget_setFocus", _wrap_Widget_setFocus, 1 },
	 { "Widget_hasFocus", _wrap_Widget_hasFocus, 1 },
	 { "Widget_setFocusPolicy", _wrap_Widget_setFocusPolicy, 1 },
	 { "Widget_focusPolicy", _wrap_Widget_focusPolicy, 1 },
	 { "Widget_isFocusEnabled", _wrap_Widget_isFocusEnabled, 1 },
	 { "Widget_setActiveWindow", _wrap_Widget_setActiveWindow, 1 },
	 { "Widget_isActiveWindow", _wrap_Widget_isActiveWindow, 1 },
	 { "Widget_setMouseTracking", _wrap_Widget_setMouseTracking, 1 },
	 { "Widget_hasMouseTracking", _wrap_Widget_hasMouseTracking, 1 },
	 { "Widget_setIconText", _wrap_Widget_setIconText, 1 },
	 { "Widget_iconText", _wrap_Widget_iconText, 1 },
	 { "Widget_setIcon", _wrap_Widget_setIcon, 1 },
	 { "Widget_icon", _wrap_Widget_icon, 1 },
	 { "Widget_setCaption", _wrap_Widget_setCaption, 1 },
	 { "Widget_caption", _wrap_Widget_caption, 1 },
	 { "Widget_setCursor", _wrap_Widget_setCursor, 1 },
	 { "Widget_cursor", _wrap_Widget_cursor, 1 },
	 { "Widget_fontInfo", _wrap_Widget_fontInfo, 1 },
	 { "Widget_fontMetrics", _wrap_Widget_fontMetrics, 1 },
	 { "Widget_setFont", _wrap_Widget_setFont, 1 },
	 { "Widget_font", _wrap_Widget_font, 1 },
	 { "Widget_setPalette", _wrap_Widget_setPalette, 1 },
	 { "Widget_palette", _wrap_Widget_palette, 1 },
	 { "Widget_colorGroup", _wrap_Widget_colorGroup, 1 },
	 { "Widget_setBackgroundPixmap", _wrap_Widget_setBackgroundPixmap, 1 },
	 { "Widget_backgroundPixmap", _wrap_Widget_backgroundPixmap, 1 },
	 { "Widget_setBackgroundColor", _wrap_Widget_setBackgroundColor, 1 },
	 { "Widget_foregroundColor", _wrap_Widget_foregroundColor, 1 },
	 { "Widget_backgroundColor", _wrap_Widget_backgroundColor, 1 },
	 { "Widget_topLevelWidget", _wrap_Widget_topLevelWidget, 1 },
	 { "Widget_mapFromParent", _wrap_Widget_mapFromParent, 1 },
	 { "Widget_mapToParent", _wrap_Widget_mapToParent, 1 },
	 { "Widget_mapFromGlobal", _wrap_Widget_mapFromGlobal, 1 },
	 { "Widget_mapToGlobal", _wrap_Widget_mapToGlobal, 1 },
	 { "Widget_setFixedSize", _wrap_Widget_setFixedSize, 1 },
	 { "Widget_setFixedQSize", _wrap_Widget_setFixedQSize, 1 },
	 { "Widget_setSizeIncrement", _wrap_Widget_setSizeIncrement, 1 },
	 { "Widget_setQSizeIncrement", _wrap_Widget_setQSizeIncrement, 1 },
	 { "Widget_sizeIncrement", _wrap_Widget_sizeIncrement, 1 },
	 { "Widget_setMaximumSize", _wrap_Widget_setMaximumSize, 1 },
	 { "Widget_setMaximumQSize", _wrap_Widget_setMaximumQSize, 1 },
	 { "Widget_setMinimumSize", _wrap_Widget_setMinimumSize, 1 },
	 { "Widget_setMinimumQSize", _wrap_Widget_setMinimumQSize, 1 },
	 { "Widget_maximumSize", _wrap_Widget_maximumSize, 1 },
	 { "Widget_minimumSize", _wrap_Widget_minimumSize, 1 },
	 { "Widget_childrenRect", _wrap_Widget_childrenRect, 1 },
	 { "Widget_rect", _wrap_Widget_rect, 1 },
	 { "Widget_height", _wrap_Widget_height, 1 },
	 { "Widget_width", _wrap_Widget_width, 1 },
	 { "Widget_size", _wrap_Widget_size, 1 },
	 { "Widget_pos", _wrap_Widget_pos, 1 },
	 { "Widget_y", _wrap_Widget_y, 1 },
	 { "Widget_x", _wrap_Widget_x, 1 },
	 { "Widget_geometry", _wrap_Widget_geometry, 1 },
	 { "Widget_frameGeometry", _wrap_Widget_frameGeometry, 1 },
	 { "Widget_setEnabled", _wrap_Widget_setEnabled, 1 },
	 { "Widget_isEnabled", _wrap_Widget_isEnabled, 1 },
	 { "Widget_isDesktop", _wrap_Widget_isDesktop, 1 },
	 { "Widget_isPopup", _wrap_Widget_isPopup, 1 },
	 { "Widget_isModal", _wrap_Widget_isModal, 1 },
	 { "Widget_isTopLevel", _wrap_Widget_isTopLevel, 1 },
	 { "delete_Widget", _wrap_delete_Widget, 1 },
	 { "new_Widget", _wrap_new_Widget, 1 },
	 { "GridLayout_setColStretch", _wrap_GridLayout_setColStretch, 1 },
	 { "GridLayout_setRowStretch", _wrap_GridLayout_setRowStretch, 1 },
	 { "GridLayout_addLayout", _wrap_GridLayout_addLayout, 1 },
	 { "GridLayout_addMultiCellWidget", _wrap_GridLayout_addMultiCellWidget, 1 },
	 { "GridLayout_addWidget", _wrap_GridLayout_addWidget, 1 },
	 { "delete_GridLayout", _wrap_delete_GridLayout, 1 },
	 { "new_GridSubLayout", _wrap_new_GridSubLayout, 1 },
	 { "new_GridLayout", _wrap_new_GridLayout, 1 },
	 { "BoxLayout_addStrut", _wrap_BoxLayout_addStrut, 1 },
	 { "BoxLayout_direction", _wrap_BoxLayout_direction, 1 },
	 { "BoxLayout_addLayout", _wrap_BoxLayout_addLayout, 1 },
	 { "BoxLayout_addStretch", _wrap_BoxLayout_addStretch, 1 },
	 { "BoxLayout_addSpacing", _wrap_BoxLayout_addSpacing, 1 },
	 { "BoxLayout_addWidget", _wrap_BoxLayout_addWidget, 1 },
	 { "delete_BoxLayout", _wrap_delete_BoxLayout, 1 },
	 { "new_BoxSubLayout", _wrap_new_BoxSubLayout, 1 },
	 { "new_BoxLayout", _wrap_new_BoxLayout, 1 },
	 { "Layout_mainWidget", _wrap_Layout_mainWidget, 1 },
	 { "Layout_freezeThis", _wrap_Layout_freezeThis, 1 },
	 { "Layout_freeze", _wrap_Layout_freeze, 1 },
	 { "Layout_activate", _wrap_Layout_activate, 1 },
	 { "Layout_defaultBorder", _wrap_Layout_defaultBorder, 1 },
	 { "Application_restoreOverrideCursor", _wrap_Application_restoreOverrideCursor, 1 },
	 { "Application_setOverrideCursor", _wrap_Application_setOverrideCursor, 1 },
	 { "Application_lastWindowClosed", _wrap_Application_lastWindowClosed, 1 },
	 { "Application_quit", _wrap_Application_quit, 1 },
	 { "Application_exit_loop", _wrap_Application_exit_loop, 1 },
	 { "Application_enter_loop", _wrap_Application_enter_loop, 1 },
	 { "Application_processEvents", _wrap_Application_processEvents, 1 },
	 { "Application_execLoop", _wrap_Application_execLoop, 1 },
	 { "Application_focusWidget", _wrap_Application_focusWidget, 1 },
	 { "Application_setMainWidget", _wrap_Application_setMainWidget, 1 },
	 { "Application_mainWidget", _wrap_Application_mainWidget, 1 },
	 { "Application_argv", _wrap_Application_argv, 1 },
	 { "Application_argc", _wrap_Application_argc, 1 },
	 { "delete_Application", _wrap_delete_Application, 1 },
	 { "new_Application", _wrap_new_Application, 1 },
	 { "Object_killTimer", _wrap_Object_killTimer, 1 },
	 { "Object_timerConnection", _wrap_Object_timerConnection, 1 },
	 { "Object_emit", _wrap_Object_emit, 1 },
	 { "Object_disconnect", _wrap_Object_disconnect, 1 },
	 { "Object_connect", _wrap_Object_connect, 1 },
	 { "new_Object", _wrap_new_Object, 1 },
	 { "QSize_setHeight", _wrap_QSize_setHeight, 1 },
	 { "QSize_setWidth", _wrap_QSize_setWidth, 1 },
	 { "QSize_height", _wrap_QSize_height, 1 },
	 { "QSize_width", _wrap_QSize_width, 1 },
	 { "QSize_isValid", _wrap_QSize_isValid, 1 },
	 { "QSize_isEmpty", _wrap_QSize_isEmpty, 1 },
	 { "QSize_isNull", _wrap_QSize_isNull, 1 },
	 { "new_QSizeV", _wrap_new_QSizeV, 1 },
	 { "new_QSize", _wrap_new_QSize, 1 },
	 { "QRect_intersects", _wrap_QRect_intersects, 1 },
	 { "QRect_intersect", _wrap_QRect_intersect, 1 },
	 { "QRect_unite", _wrap_QRect_unite, 1 },
	 { "QRect_containsRect", _wrap_QRect_containsRect, 1 },
	 { "QRect_containsPoint", _wrap_QRect_containsPoint, 1 },
	 { "QRect_setSize", _wrap_QRect_setSize, 1 },
	 { "QRect_setHeight", _wrap_QRect_setHeight, 1 },
	 { "QRect_setWidth", _wrap_QRect_setWidth, 1 },
	 { "QRect_height", _wrap_QRect_height, 1 },
	 { "QRect_width", _wrap_QRect_width, 1 },
	 { "QRect_size", _wrap_QRect_size, 1 },
	 { "QRect_setCoords", _wrap_QRect_setCoords, 1 },
	 { "QRect_setRect", _wrap_QRect_setRect, 1 },
	 { "QRect_moveBy", _wrap_QRect_moveBy, 1 },
	 { "QRect_moveCenter", _wrap_QRect_moveCenter, 1 },
	 { "QRect_moveBottomLeft", _wrap_QRect_moveBottomLeft, 1 },
	 { "QRect_moveTopRight", _wrap_QRect_moveTopRight, 1 },
	 { "QRect_moveBottomRight", _wrap_QRect_moveBottomRight, 1 },
	 { "QRect_moveTopLeft", _wrap_QRect_moveTopLeft, 1 },
	 { "QRect_coords", _wrap_QRect_coords, 1 },
	 { "QRect_rect", _wrap_QRect_rect, 1 },
	 { "QRect_center", _wrap_QRect_center, 1 },
	 { "QRect_bottomLeft", _wrap_QRect_bottomLeft, 1 },
	 { "QRect_topRight", _wrap_QRect_topRight, 1 },
	 { "QRect_bottomRight", _wrap_QRect_bottomRight, 1 },
	 { "QRect_topLeft", _wrap_QRect_topLeft, 1 },
	 { "QRect_setY", _wrap_QRect_setY, 1 },
	 { "QRect_setX", _wrap_QRect_setX, 1 },
	 { "QRect_setBottom", _wrap_QRect_setBottom, 1 },
	 { "QRect_setRight", _wrap_QRect_setRight, 1 },
	 { "QRect_setTop", _wrap_QRect_setTop, 1 },
	 { "QRect_setLeft", _wrap_QRect_setLeft, 1 },
	 { "QRect_y", _wrap_QRect_y, 1 },
	 { "QRect_x", _wrap_QRect_x, 1 },
	 { "QRect_bottom", _wrap_QRect_bottom, 1 },
	 { "QRect_right", _wrap_QRect_right, 1 },
	 { "QRect_top", _wrap_QRect_top, 1 },
	 { "QRect_left", _wrap_QRect_left, 1 },
	 { "QRect_normalize", _wrap_QRect_normalize, 1 },
	 { "QRect_isValid", _wrap_QRect_isValid, 1 },
	 { "QRect_isEmpty", _wrap_QRect_isEmpty, 1 },
	 { "QRect_isNull", _wrap_QRect_isNull, 1 },
	 { "new_QRectLTWH", _wrap_new_QRectLTWH, 1 },
	 { "new_QRectPointSize", _wrap_new_QRectPointSize, 1 },
	 { "new_QRectPoints", _wrap_new_QRectPoints, 1 },
	 { "new_QRect", _wrap_new_QRect, 1 },
	 { "QPoint_setY", _wrap_QPoint_setY, 1 },
	 { "QPoint_setX", _wrap_QPoint_setX, 1 },
	 { "QPoint_y", _wrap_QPoint_y, 1 },
	 { "QPoint_x", _wrap_QPoint_x, 1 },
	 { "QPoint_isNull", _wrap_QPoint_isNull, 1 },
	 { "new_QPointV", _wrap_new_QPointV, 1 },
	 { "new_QPoint", _wrap_new_QPoint, 1 },
	 { "new_QBitmapLoad", _wrap_new_QBitmapLoad, 1 },
	 { "new_QBitmapCopy", _wrap_new_QBitmapCopy, 1 },
	 { "new_QBitmapSizeData", _wrap_new_QBitmapSizeData, 1 },
	 { "new_QBitmapSize", _wrap_new_QBitmapSize, 1 },
	 { "new_QBitmap", _wrap_new_QBitmap, 1 },
	 { "QPixmap_optimizeGlobally", _wrap_QPixmap_optimizeGlobally, 1 },
	 { "QPixmap_isGloballyOptimized", _wrap_QPixmap_isGloballyOptimized, 1 },
	 { "QPixmap_imageFormat", _wrap_QPixmap_imageFormat, 1 },
	 { "QPixmap_defaultDepth", _wrap_QPixmap_defaultDepth, 1 },
	 { "QPixmap_isQBitmap", _wrap_QPixmap_isQBitmap, 1 },
	 { "QPixmap_detach", _wrap_QPixmap_detach, 1 },
	 { "QPixmap_optimize", _wrap_QPixmap_optimize, 1 },
	 { "QPixmap_isOptimized", _wrap_QPixmap_isOptimized, 1 },
	 { "QPixmap_serialNumber", _wrap_QPixmap_serialNumber, 1 },
	 { "QPixmap_save", _wrap_QPixmap_save, 1 },
	 { "QPixmap_loadFromData", _wrap_QPixmap_loadFromData, 1 },
	 { "QPixmap_load", _wrap_QPixmap_load, 1 },
	 { "QPixmap_createHeuristicMask", _wrap_QPixmap_createHeuristicMask, 1 },
	 { "QPixmap_selfMask", _wrap_QPixmap_selfMask, 1 },
	 { "QPixmap_setMask", _wrap_QPixmap_setMask, 1 },
	 { "QPixmap_mask", _wrap_QPixmap_mask, 1 },
	 { "QPixmap_resize", _wrap_QPixmap_resize, 1 },
	 { "QPixmap_depth", _wrap_QPixmap_depth, 1 },
	 { "QPixmap_height", _wrap_QPixmap_height, 1 },
	 { "QPixmap_width", _wrap_QPixmap_width, 1 },
	 { "QPixmap_isNull", _wrap_QPixmap_isNull, 1 },
	 { "delete_QPixmap", _wrap_delete_QPixmap, 1 },
	 { "new_PixmapCopy", _wrap_new_PixmapCopy, 1 },
	 { "new_PixmapFile", _wrap_new_PixmapFile, 1 },
	 { "new_QPixmapSize", _wrap_new_QPixmapSize, 1 },
	 { "new_QPixmap", _wrap_new_QPixmap, 1 },
	 { "QPaintDevice_paintingActive", _wrap_QPaintDevice_paintingActive, 1 },
	 { "QPaintDevice_isExtDev", _wrap_QPaintDevice_isExtDev, 1 },
	 { "QPaintDevice_devType", _wrap_QPaintDevice_devType, 1 },
	 { "delete_QPaintDevice", _wrap_delete_QPaintDevice, 1 },
	 { "QFontMetrics_lineWidth", _wrap_QFontMetrics_lineWidth, 1 },
	 { "QFontMetrics_strikeOutPos", _wrap_QFontMetrics_strikeOutPos, 1 },
	 { "QFontMetrics_underlinePos", _wrap_QFontMetrics_underlinePos, 1 },
	 { "QFontMetrics_maxWidth", _wrap_QFontMetrics_maxWidth, 1 },
	 { "QFontMetrics_charWidth", _wrap_QFontMetrics_charWidth, 1 },
	 { "QFontMetrics_width", _wrap_QFontMetrics_width, 1 },
	 { "QFontMetrics_lineSpacing", _wrap_QFontMetrics_lineSpacing, 1 },
	 { "QFontMetrics_leading", _wrap_QFontMetrics_leading, 1 },
	 { "QFontMetrics_height", _wrap_QFontMetrics_height, 1 },
	 { "QFontMetrics_descent", _wrap_QFontMetrics_descent, 1 },
	 { "QFontMetrics_ascent", _wrap_QFontMetrics_ascent, 1 },
	 { "delete_QFontMetrics", _wrap_delete_QFontMetrics, 1 },
	 { "new_QFontMetricsCopy", _wrap_new_QFontMetricsCopy, 1 },
	 { "new_QFontMetrics", _wrap_new_QFontMetrics, 1 },
	 { "QFontInfo_exactMatch", _wrap_QFontInfo_exactMatch, 1 },
	 { "QFontInfo_rawMode", _wrap_QFontInfo_rawMode, 1 },
	 { "QFontInfo_charSet", _wrap_QFontInfo_charSet, 1 },
	 { "QFontInfo_styleHint", _wrap_QFontInfo_styleHint, 1 },
	 { "QFontInfo_fixedPitch", _wrap_QFontInfo_fixedPitch, 1 },
	 { "QFontInfo_strikeOut", _wrap_QFontInfo_strikeOut, 1 },
	 { "QFontInfo_underline", _wrap_QFontInfo_underline, 1 },
	 { "QFontInfo_bold", _wrap_QFontInfo_bold, 1 },
	 { "QFontInfo_weight", _wrap_QFontInfo_weight, 1 },
	 { "QFontInfo_italic", _wrap_QFontInfo_italic, 1 },
	 { "QFontInfo_pointSize", _wrap_QFontInfo_pointSize, 1 },
	 { "QFontInfo_family", _wrap_QFontInfo_family, 1 },
	 { "delete_QFontInfo", _wrap_delete_QFontInfo, 1 },
	 { "new_QFontInfoCopy", _wrap_new_QFontInfoCopy, 1 },
	 { "new_QFontInfo", _wrap_new_QFontInfo, 1 },
	 { "QFont_removeSubstitution", _wrap_QFont_removeSubstitution, 1 },
	 { "QFont_insertSubstitution", _wrap_QFont_insertSubstitution, 1 },
	 { "QFont_substitute", _wrap_QFont_substitute, 1 },
	 { "QFont_setDefaultFont", _wrap_QFont_setDefaultFont, 1 },
	 { "QFont_defaultFont", _wrap_QFont_defaultFont, 1 },
	 { "QFont_exactMatch", _wrap_QFont_exactMatch, 1 },
	 { "QFont_setRawMode", _wrap_QFont_setRawMode, 1 },
	 { "QFont_rawMode", _wrap_QFont_rawMode, 1 },
	 { "QFont_setCharSet", _wrap_QFont_setCharSet, 1 },
	 { "QFont_charSet", _wrap_QFont_charSet, 1 },
	 { "QFont_setStyleHint", _wrap_QFont_setStyleHint, 1 },
	 { "QFont_styleHint", _wrap_QFont_styleHint, 1 },
	 { "QFont_setFixedPitch", _wrap_QFont_setFixedPitch, 1 },
	 { "QFont_fixedPitch", _wrap_QFont_fixedPitch, 1 },
	 { "QFont_setStrikeOut", _wrap_QFont_setStrikeOut, 1 },
	 { "QFont_strikeOut", _wrap_QFont_strikeOut, 1 },
	 { "QFont_setUnderline", _wrap_QFont_setUnderline, 1 },
	 { "QFont_underline", _wrap_QFont_underline, 1 },
	 { "QFont_setItalic", _wrap_QFont_setItalic, 1 },
	 { "QFont_italic", _wrap_QFont_italic, 1 },
	 { "QFont_setBold", _wrap_QFont_setBold, 1 },
	 { "QFont_bold", _wrap_QFont_bold, 1 },
	 { "QFont_setWeight", _wrap_QFont_setWeight, 1 },
	 { "QFont_weight", _wrap_QFont_weight, 1 },
	 { "QFont_setPointSize", _wrap_QFont_setPointSize, 1 },
	 { "QFont_pointSize", _wrap_QFont_pointSize, 1 },
	 { "QFont_setFamily", _wrap_QFont_setFamily, 1 },
	 { "QFont_family", _wrap_QFont_family, 1 },
	 { "new_QFontCopy", _wrap_new_QFontCopy, 1 },
	 { "new_QFontV", _wrap_new_QFontV, 1 },
	 { "new_QFont", _wrap_new_QFont, 1 },
	 { "QCursor_setPos", _wrap_QCursor_setPos, 1 },
	 { "QCursor_setShape", _wrap_QCursor_setShape, 1 },
	 { "QCursor_shape", _wrap_QCursor_shape, 1 },
	 { "new_QCursorCopy", _wrap_new_QCursorCopy, 1 },
	 { "new_QCursorShape", _wrap_new_QCursorShape, 1 },
	 { "new_QCursor", _wrap_new_QCursor, 1 },
	 { "QPalette_serialNumber", _wrap_QPalette_serialNumber, 1 },
	 { "QPalette_setActive", _wrap_QPalette_setActive, 1 },
	 { "QPalette_setDisabled", _wrap_QPalette_setDisabled, 1 },
	 { "QPalette_setNormal", _wrap_QPalette_setNormal, 1 },
	 { "QPalette_active", _wrap_QPalette_active, 1 },
	 { "QPalette_disabled", _wrap_QPalette_disabled, 1 },
	 { "QPalette_normal", _wrap_QPalette_normal, 1 },
	 { "QPalette_copy", _wrap_QPalette_copy, 1 },
	 { "delete_QPalette", _wrap_delete_QPalette, 1 },
	 { "new_QPaletteCopy", _wrap_new_QPaletteCopy, 1 },
	 { "new_QPaletteCG", _wrap_new_QPaletteCG, 1 },
	 { "new_QPaletteColor", _wrap_new_QPaletteColor, 1 },
	 { "new_QPalette", _wrap_new_QPalette, 1 },
	 { "QColorGroup_base", _wrap_QColorGroup_base, 1 },
	 { "QColorGroup_text", _wrap_QColorGroup_text, 1 },
	 { "QColorGroup_mid", _wrap_QColorGroup_mid, 1 },
	 { "QColorGroup_dark", _wrap_QColorGroup_dark, 1 },
	 { "QColorGroup_light", _wrap_QColorGroup_light, 1 },
	 { "QColorGroup_background", _wrap_QColorGroup_background, 1 },
	 { "QColorGroup_foreground", _wrap_QColorGroup_foreground, 1 },
	 { "new_QColorGroupV", _wrap_new_QColorGroupV, 1 },
	 { "new_QColorGroup", _wrap_new_QColorGroup, 1 },
	 { "QColor_destroyAllocContext", _wrap_QColor_destroyAllocContext, 1 },
	 { "QColor_currentAllocContext", _wrap_QColor_currentAllocContext, 1 },
	 { "QColor_leaveAllocContext", _wrap_QColor_leaveAllocContext, 1 },
	 { "QColor_enterAllocContext", _wrap_QColor_enterAllocContext, 1 },
	 { "QColor_numBitPlanes", _wrap_QColor_numBitPlanes, 1 },
	 { "QColor_maxColors", _wrap_QColor_maxColors, 1 },
	 { "QColor_setLazyAlloc", _wrap_QColor_setLazyAlloc, 1 },
	 { "QColor_lazyAlloc", _wrap_QColor_lazyAlloc, 1 },
	 { "QColor_pixel", _wrap_QColor_pixel, 1 },
	 { "QColor_alloc", _wrap_QColor_alloc, 1 },
	 { "QColor_dark", _wrap_QColor_dark, 1 },
	 { "QColor_light", _wrap_QColor_light, 1 },
	 { "QColor_setHsv", _wrap_QColor_setHsv, 1 },
	 { "QColor_hsv", _wrap_QColor_hsv, 1 },
	 { "QColor_blue", _wrap_QColor_blue, 1 },
	 { "QColor_green", _wrap_QColor_green, 1 },
	 { "QColor_red", _wrap_QColor_red, 1 },
	 { "QColor_setRgb", _wrap_QColor_setRgb, 1 },
	 { "QColor_rgb", _wrap_QColor_rgb, 1 },
	 { "QColor_setNamedColor", _wrap_QColor_setNamedColor, 1 },
	 { "QColor_isDirty", _wrap_QColor_isDirty, 1 },
	 { "QColor_isValid", _wrap_QColor_isValid, 1 },
	 { "new_QColorCopy", _wrap_new_QColorCopy, 1 },
	 { "new_QColorName", _wrap_new_QColorName, 1 },
	 { "new_QColorRGB", _wrap_new_QColorRGB, 1 },
	 { "new_QColor", _wrap_new_QColor, 1 },
	 { "QListViewItem_sortChildItems", _wrap_QListViewItem_sortChildItems, 1 },
	 { "QListViewItem_key", _wrap_QListViewItem_key, 1 },
	 { "QListViewItem_pixmap", _wrap_QListViewItem_pixmap, 1 },
	 { "QListViewItem_setPixmap", _wrap_QListViewItem_setPixmap, 1 },
	 { "QListViewItem_text", _wrap_QListViewItem_text, 1 },
	 { "QListViewItem_setText", _wrap_QListViewItem_setText, 1 },
	 { "QListViewItem_depth", _wrap_QListViewItem_depth, 1 },
	 { "QListViewItem_widthChanged", _wrap_QListViewItem_widthChanged, 1 },
	 { "QListViewItem_width", _wrap_QListViewItem_width, 1 },
	 { "QListViewItem_totalHeight", _wrap_QListViewItem_totalHeight, 1 },
	 { "QListViewItem_invalidateHeight", _wrap_QListViewItem_invalidateHeight, 1 },
	 { "QListViewItem_height", _wrap_QListViewItem_height, 1 },
	 { "QListViewItem_removeItem", _wrap_QListViewItem_removeItem, 1 },
	 { "QListViewItem_insertItem", _wrap_QListViewItem_insertItem, 1 },
	 { "new_QListViewItemChildAndLabels", _wrap_new_QListViewItemChildAndLabels, 1 },
	 { "new_QListViewItemAndLabels", _wrap_new_QListViewItemAndLabels, 1 },
	 { "new_QListViewItemChild", _wrap_new_QListViewItemChild, 1 },
	 { "new_QListViewItem", _wrap_new_QListViewItem, 1 },
	 { "ToolBarOrientation", _wrap_ToolBarOrientation, 1 },
	 { "getExistingDirectory", _wrap_getExistingDirectory, 1 },
	 { "getSaveFileName", _wrap_getSaveFileName, 1 },
	 { "getOpenFileName", _wrap_getOpenFileName, 1 },
	 { "ModalFileDialog", _wrap_ModalFileDialog, 1 },
	 { "bitBlt", _wrap_bitBlt, 1 },
	 { NULL, NULL }
};
static PyObject *SWIG_globals;
#ifdef __cplusplus
extern "C" 
#endif
SWIGEXPORT(void,initpythonqtc)() {
	 PyObject *m, *d;
	 SWIG_globals = SWIG_newvarlink();
	 m = Py_InitModule("pythonqtc", pythonqtcMethods);
	 d = PyModule_GetDict(m);
	 PyDict_SetItemString(d,"ArrowCursor", PyInt_FromLong((long) ArrowCursor));
	 PyDict_SetItemString(d,"UpArrowCursor", PyInt_FromLong((long) UpArrowCursor));
	 PyDict_SetItemString(d,"CrossCursor", PyInt_FromLong((long) CrossCursor));
	 PyDict_SetItemString(d,"WaitCursor", PyInt_FromLong((long) WaitCursor));
	 PyDict_SetItemString(d,"IbeamCursor", PyInt_FromLong((long) IbeamCursor));
	 PyDict_SetItemString(d,"SizeVerCursor", PyInt_FromLong((long) SizeVerCursor));
	 PyDict_SetItemString(d,"SizeHorCursor", PyInt_FromLong((long) SizeHorCursor));
	 PyDict_SetItemString(d,"SizeBDiagCursor", PyInt_FromLong((long) SizeBDiagCursor));
	 PyDict_SetItemString(d,"SizeFDiagCursor", PyInt_FromLong((long) SizeFDiagCursor));
	 PyDict_SetItemString(d,"SizeAllCursor", PyInt_FromLong((long) SizeAllCursor));
	 PyDict_SetItemString(d,"BlankCursor", PyInt_FromLong((long) BlankCursor));
	 PyDict_SetItemString(d,"LastCursor", PyInt_FromLong((long) LastCursor));
	 PyDict_SetItemString(d,"BitmapCursor", PyInt_FromLong((long) BitmapCursor));
	 PyDict_SetItemString(d,"CopyROP", PyInt_FromLong((long) CopyROP));
	 PyDict_SetItemString(d,"OrROP", PyInt_FromLong((long) OrROP));
	 PyDict_SetItemString(d,"XorROP", PyInt_FromLong((long) XorROP));
	 PyDict_SetItemString(d,"EraseROP", PyInt_FromLong((long) EraseROP));
	 PyDict_SetItemString(d,"NotCopyROP", PyInt_FromLong((long) NotCopyROP));
	 PyDict_SetItemString(d,"NotOrROP", PyInt_FromLong((long) NotOrROP));
	 PyDict_SetItemString(d,"NotXorROP", PyInt_FromLong((long) NotXorROP));
	 PyDict_SetItemString(d,"NotEraseROP", PyInt_FromLong((long) NotEraseROP));
	 PyDict_SetItemString(d,"NotROP", PyInt_FromLong((long) NotROP));
	 PyDict_SetItemString(d,"QFont_Helvetica", PyInt_FromLong((long) QFont::Helvetica));
	 PyDict_SetItemString(d,"QFont_Times", PyInt_FromLong((long) QFont::Times));
	 PyDict_SetItemString(d,"QFont_Courier", PyInt_FromLong((long) QFont::Courier));
	 PyDict_SetItemString(d,"QFont_OldEnglish", PyInt_FromLong((long) QFont::OldEnglish));
	 PyDict_SetItemString(d,"QFont_System", PyInt_FromLong((long) QFont::System));
	 PyDict_SetItemString(d,"QFont_AnyStyle", PyInt_FromLong((long) QFont::AnyStyle));
	 PyDict_SetItemString(d,"QFont_SansSerif", PyInt_FromLong((long) QFont::SansSerif));
	 PyDict_SetItemString(d,"QFont_Serif", PyInt_FromLong((long) QFont::Serif));
	 PyDict_SetItemString(d,"QFont_TypeWriter", PyInt_FromLong((long) QFont::TypeWriter));
	 PyDict_SetItemString(d,"QFont_Decorative", PyInt_FromLong((long) QFont::Decorative));
	 PyDict_SetItemString(d,"QFont_Light", PyInt_FromLong((long) QFont::Light));
	 PyDict_SetItemString(d,"QFont_Normal", PyInt_FromLong((long) QFont::Normal));
	 PyDict_SetItemString(d,"QFont_DemiBold", PyInt_FromLong((long) QFont::DemiBold));
	 PyDict_SetItemString(d,"QFont_Bold", PyInt_FromLong((long) QFont::Bold));
	 PyDict_SetItemString(d,"QFont_Black", PyInt_FromLong((long) QFont::Black));
	 PyDict_SetItemString(d,"QFont_Latin1", PyInt_FromLong((long) QFont::Latin1));
	 PyDict_SetItemString(d,"QFont_ISO_8859_1", PyInt_FromLong((long) QFont::ISO_8859_1));
	 PyDict_SetItemString(d,"QFont_AnyCharSet", PyInt_FromLong((long) QFont::AnyCharSet));
	 PyDict_SetItemString(d,"QPixmap_Auto", PyInt_FromLong((long) QPixmap::Auto));
	 PyDict_SetItemString(d,"QPixmap_Color", PyInt_FromLong((long) QPixmap::Color));
	 PyDict_SetItemString(d,"QPixmap_Mono", PyInt_FromLong((long) QPixmap::Mono));
	 PyDict_SetItemString(d,"BoxLayout_LeftToRight", PyInt_FromLong((long) BoxLayout::LeftToRight));
	 PyDict_SetItemString(d,"BoxLayout_RightToLeft", PyInt_FromLong((long) BoxLayout::RightToLeft));
	 PyDict_SetItemString(d,"BoxLayout_TopToBottom", PyInt_FromLong((long) BoxLayout::TopToBottom));
	 PyDict_SetItemString(d,"BoxLayout_BottomToTop", PyInt_FromLong((long) BoxLayout::BottomToTop));
	 PyDict_SetItemString(d,"BoxLayout_Down", PyInt_FromLong((long) BoxLayout::Down));
	 PyDict_SetItemString(d,"BoxLayout_Up", PyInt_FromLong((long) BoxLayout::Up));
	 PyDict_SetItemString(d,"Widget_NoFocus", PyInt_FromLong((long) Widget::NoFocus));
	 PyDict_SetItemString(d,"Widget_TabFocus", PyInt_FromLong((long) Widget::TabFocus));
	 PyDict_SetItemString(d,"Widget_ClickFocus", PyInt_FromLong((long) Widget::ClickFocus));
	 PyDict_SetItemString(d,"Widget_StrongFocus", PyInt_FromLong((long) Widget::StrongFocus));
	 PyDict_SetItemString(d,"ComboBox_NoInsertion", PyInt_FromLong((long) ComboBox::NoInsertion));
	 PyDict_SetItemString(d,"ComboBox_AtTop", PyInt_FromLong((long) ComboBox::AtTop));
	 PyDict_SetItemString(d,"ComboBox_AtCurrent", PyInt_FromLong((long) ComboBox::AtCurrent));
	 PyDict_SetItemString(d,"ComboBox_AtBottom", PyInt_FromLong((long) ComboBox::AtBottom));
	 PyDict_SetItemString(d,"ComboBox_AfterCurrent", PyInt_FromLong((long) ComboBox::AfterCurrent));
	 PyDict_SetItemString(d,"ComboBox_BeforeCurrent", PyInt_FromLong((long) ComboBox::BeforeCurrent));
	 PyDict_SetItemString(d,"LineEdit_Normal", PyInt_FromLong((long) LineEdit::Normal));
	 PyDict_SetItemString(d,"LineEdit_NoEcho", PyInt_FromLong((long) LineEdit::NoEcho));
	 PyDict_SetItemString(d,"LineEdit_Password", PyInt_FromLong((long) LineEdit::Password));
	 PyDict_SetItemString(d,"Frame_NoFrame", PyInt_FromLong((long) Frame::NoFrame));
	 PyDict_SetItemString(d,"Frame_Box", PyInt_FromLong((long) Frame::Box));
	 PyDict_SetItemString(d,"Frame_Panel", PyInt_FromLong((long) Frame::Panel));
	 PyDict_SetItemString(d,"Frame_WinPanel", PyInt_FromLong((long) Frame::WinPanel));
	 PyDict_SetItemString(d,"Frame_HLine", PyInt_FromLong((long) Frame::HLine));
	 PyDict_SetItemString(d,"Frame_VLine", PyInt_FromLong((long) Frame::VLine));
	 PyDict_SetItemString(d,"Frame_MShape", PyInt_FromLong((long) Frame::MShape));
	 PyDict_SetItemString(d,"Frame_Plain", PyInt_FromLong((long) Frame::Plain));
	 PyDict_SetItemString(d,"Frame_Raised", PyInt_FromLong((long) Frame::Raised));
	 PyDict_SetItemString(d,"Frame_Sunken", PyInt_FromLong((long) Frame::Sunken));
	 PyDict_SetItemString(d,"Frame_MShadow", PyInt_FromLong((long) Frame::MShadow));
	 PyDict_SetItemString(d,"ScrollBar_Horizontal", PyInt_FromLong((long) ScrollBar::Horizontal));
	 PyDict_SetItemString(d,"ScrollBar_Vertical", PyInt_FromLong((long) ScrollBar::Vertical));
	 PyDict_SetItemString(d,"QMenuBar_Never", PyInt_FromLong((long) QMenuBar::Never));
	 PyDict_SetItemString(d,"QMenuBar_InWindowsStyle", PyInt_FromLong((long) QMenuBar::InWindowsStyle));
/*
 * These are the pointer type-equivalency mappings. 
 * (Used by the SWIG pointer type-checker).
 */
	 SWIG_RegisterMapping("_signed_long","_long",0);
	 SWIG_RegisterMapping("_Dialog","_class_TabDialog",SwigTabDialogToDialog);
	 SWIG_RegisterMapping("_Dialog","_TabDialog",SwigTabDialogToDialog);
	 SWIG_RegisterMapping("_Dialog","_class_Dialog",0);
	 SWIG_RegisterMapping("_class_CheckBox","_CheckBox",0);
	 SWIG_RegisterMapping("_class_ListBox","_ListBox",0);
	 SWIG_RegisterMapping("_splitter","_class_splitter",0);
	 SWIG_RegisterMapping("_QFontInfo","_class_QFontInfo",0);
	 SWIG_RegisterMapping("_class_QFont","_QFont",0);
	 SWIG_RegisterMapping("_class_RadioButton","_RadioButton",0);
	 SWIG_RegisterMapping("_class_QBitmap","_QBitmap",0);
	 SWIG_RegisterMapping("_class_Object","_class_ToolButton",SwigToolButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_ToolButton",SwigToolButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_class_ToolBar",SwigToolBarToObject);
	 SWIG_RegisterMapping("_class_Object","_ToolBar",SwigToolBarToObject);
	 SWIG_RegisterMapping("_class_Object","_class_mainwindow",SwigmainwindowToObject);
	 SWIG_RegisterMapping("_class_Object","_mainwindow",SwigmainwindowToObject);
	 SWIG_RegisterMapping("_class_Object","_class_splitter",SwigsplitterToObject);
	 SWIG_RegisterMapping("_class_Object","_splitter",SwigsplitterToObject);
	 SWIG_RegisterMapping("_class_Object","_class_treeview",SwigtreeviewToObject);
	 SWIG_RegisterMapping("_class_Object","_treeview",SwigtreeviewToObject);
	 SWIG_RegisterMapping("_class_Object","_class_qdbt_tabular",Swigqdbt_tabularToObject);
	 SWIG_RegisterMapping("_class_Object","_qdbt_tabular",Swigqdbt_tabularToObject);
	 SWIG_RegisterMapping("_class_Object","_class_ScrollBar",SwigScrollBarToObject);
	 SWIG_RegisterMapping("_class_Object","_ScrollBar",SwigScrollBarToObject);
	 SWIG_RegisterMapping("_class_Object","_class_MultiLineEdit",SwigMultiLineEditToObject);
	 SWIG_RegisterMapping("_class_Object","_MultiLineEdit",SwigMultiLineEditToObject);
	 SWIG_RegisterMapping("_class_Object","_class_ListBox",SwigListBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_ListBox",SwigListBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_class_TableView",SwigTableViewToObject);
	 SWIG_RegisterMapping("_class_Object","_TableView",SwigTableViewToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Label",SwigLabelToObject);
	 SWIG_RegisterMapping("_class_Object","_Label",SwigLabelToObject);
	 SWIG_RegisterMapping("_class_Object","_class_ButtonGroup",SwigButtonGroupToObject);
	 SWIG_RegisterMapping("_class_Object","_ButtonGroup",SwigButtonGroupToObject);
	 SWIG_RegisterMapping("_class_Object","_class_GroupBox",SwigGroupBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_GroupBox",SwigGroupBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Frame",SwigFrameToObject);
	 SWIG_RegisterMapping("_class_Object","_Frame",SwigFrameToObject);
	 SWIG_RegisterMapping("_class_Object","_class_LineEdit",SwigLineEditToObject);
	 SWIG_RegisterMapping("_class_Object","_LineEdit",SwigLineEditToObject);
	 SWIG_RegisterMapping("_class_Object","_class_TabDialog",SwigTabDialogToObject);
	 SWIG_RegisterMapping("_class_Object","_TabDialog",SwigTabDialogToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Dialog",SwigDialogToObject);
	 SWIG_RegisterMapping("_class_Object","_Dialog",SwigDialogToObject);
	 SWIG_RegisterMapping("_class_Object","_class_ComboBox",SwigComboBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_ComboBox",SwigComboBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_class_RadioButton",SwigRadioButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_RadioButton",SwigRadioButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_class_PushButton",SwigPushButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_PushButton",SwigPushButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_class_CheckBox",SwigCheckBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_CheckBox",SwigCheckBoxToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Button",SwigButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_Button",SwigButtonToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Widget",SwigWidgetToObject);
	 SWIG_RegisterMapping("_class_Object","_Widget",SwigWidgetToObject);
	 SWIG_RegisterMapping("_class_Object","_class_GridLayout",SwigGridLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_GridLayout",SwigGridLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_class_BoxLayout",SwigBoxLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_BoxLayout",SwigBoxLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Layout",SwigLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_Layout",SwigLayoutToObject);
	 SWIG_RegisterMapping("_class_Object","_class_Application",SwigApplicationToObject);
	 SWIG_RegisterMapping("_class_Object","_Application",SwigApplicationToObject);
	 SWIG_RegisterMapping("_class_Object","_Object",0);
	 SWIG_RegisterMapping("_Button","_class_RadioButton",SwigRadioButtonToButton);
	 SWIG_RegisterMapping("_Button","_RadioButton",SwigRadioButtonToButton);
	 SWIG_RegisterMapping("_Button","_class_PushButton",SwigPushButtonToButton);
	 SWIG_RegisterMapping("_Button","_PushButton",SwigPushButtonToButton);
	 SWIG_RegisterMapping("_Button","_class_CheckBox",SwigCheckBoxToButton);
	 SWIG_RegisterMapping("_Button","_CheckBox",SwigCheckBoxToButton);
	 SWIG_RegisterMapping("_Button","_class_Button",0);
	 SWIG_RegisterMapping("_class_LineEdit","_LineEdit",0);
	 SWIG_RegisterMapping("_long","_unsigned_long",0);
	 SWIG_RegisterMapping("_long","_signed_long",0);
	 SWIG_RegisterMapping("_QPoint","_class_QPoint",0);
	 SWIG_RegisterMapping("_class_Dialog","_class_TabDialog",SwigTabDialogToDialog);
	 SWIG_RegisterMapping("_class_Dialog","_TabDialog",SwigTabDialogToDialog);
	 SWIG_RegisterMapping("_class_Dialog","_Dialog",0);
	 SWIG_RegisterMapping("_class_GroupBox","_class_ButtonGroup",SwigButtonGroupToGroupBox);
	 SWIG_RegisterMapping("_class_GroupBox","_ButtonGroup",SwigButtonGroupToGroupBox);
	 SWIG_RegisterMapping("_class_GroupBox","_GroupBox",0);
	 SWIG_RegisterMapping("_TableView","_class_MultiLineEdit",SwigMultiLineEditToTableView);
	 SWIG_RegisterMapping("_TableView","_MultiLineEdit",SwigMultiLineEditToTableView);
	 SWIG_RegisterMapping("_TableView","_class_ListBox",SwigListBoxToTableView);
	 SWIG_RegisterMapping("_TableView","_ListBox",SwigListBoxToTableView);
	 SWIG_RegisterMapping("_TableView","_class_TableView",0);
	 SWIG_RegisterMapping("_QListViewItem","_class_QListViewItem",0);
	 SWIG_RegisterMapping("_QPalette","_class_QPalette",0);
	 SWIG_RegisterMapping("_class_QFontInfo","_QFontInfo",0);
	 SWIG_RegisterMapping("_ButtonGroup","_class_ButtonGroup",0);
	 SWIG_RegisterMapping("_mainwindow","_class_mainwindow",0);
	 SWIG_RegisterMapping("_class_treeview","_treeview",0);
	 SWIG_RegisterMapping("_class_Label","_Label",0);
	 SWIG_RegisterMapping("_class_MenuData","_MenuData",0);
	 SWIG_RegisterMapping("_Layout","_class_GridLayout",SwigGridLayoutToLayout);
	 SWIG_RegisterMapping("_Layout","_GridLayout",SwigGridLayoutToLayout);
	 SWIG_RegisterMapping("_Layout","_class_BoxLayout",SwigBoxLayoutToLayout);
	 SWIG_RegisterMapping("_Layout","_BoxLayout",SwigBoxLayoutToLayout);
	 SWIG_RegisterMapping("_Layout","_class_Layout",0);
	 SWIG_RegisterMapping("_class_Button","_class_RadioButton",SwigRadioButtonToButton);
	 SWIG_RegisterMapping("_class_Button","_RadioButton",SwigRadioButtonToButton);
	 SWIG_RegisterMapping("_class_Button","_class_PushButton",SwigPushButtonToButton);
	 SWIG_RegisterMapping("_class_Button","_PushButton",SwigPushButtonToButton);
	 SWIG_RegisterMapping("_class_Button","_class_CheckBox",SwigCheckBoxToButton);
	 SWIG_RegisterMapping("_class_Button","_CheckBox",SwigCheckBoxToButton);
	 SWIG_RegisterMapping("_class_Button","_Button",0);
	 SWIG_RegisterMapping("_MultiLineEdit","_class_MultiLineEdit",0);
	 SWIG_RegisterMapping("_QPixmap","_class_QBitmap",SwigQBitmapToQPixmap);
	 SWIG_RegisterMapping("_QPixmap","_QBitmap",SwigQBitmapToQPixmap);
	 SWIG_RegisterMapping("_QPixmap","_class_QPixmap",0);
	 SWIG_RegisterMapping("_class_QPoint","_QPoint",0);
	 SWIG_RegisterMapping("_QMenuBar","_class_QMenuBar",0);
	 SWIG_RegisterMapping("_class_QMessageBox","_QMessageBox",0);
	 SWIG_RegisterMapping("_FileDialog","_class_FileDialog",0);
	 SWIG_RegisterMapping("_class_TableView","_class_MultiLineEdit",SwigMultiLineEditToTableView);
	 SWIG_RegisterMapping("_class_TableView","_MultiLineEdit",SwigMultiLineEditToTableView);
	 SWIG_RegisterMapping("_class_TableView","_class_ListBox",SwigListBoxToTableView);
	 SWIG_RegisterMapping("_class_TableView","_ListBox",SwigListBoxToTableView);
	 SWIG_RegisterMapping("_class_TableView","_TableView",0);
	 SWIG_RegisterMapping("_GridLayout","_class_GridLayout",0);
	 SWIG_RegisterMapping("_class_ComboBox","_ComboBox",0);
	 SWIG_RegisterMapping("_Widget","_class_ToolButton",SwigToolButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_ToolButton",SwigToolButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_class_ToolBar",SwigToolBarToWidget);
	 SWIG_RegisterMapping("_Widget","_ToolBar",SwigToolBarToWidget);
	 SWIG_RegisterMapping("_Widget","_class_mainwindow",SwigmainwindowToWidget);
	 SWIG_RegisterMapping("_Widget","_mainwindow",SwigmainwindowToWidget);
	 SWIG_RegisterMapping("_Widget","_class_splitter",SwigsplitterToWidget);
	 SWIG_RegisterMapping("_Widget","_splitter",SwigsplitterToWidget);
	 SWIG_RegisterMapping("_Widget","_class_treeview",SwigtreeviewToWidget);
	 SWIG_RegisterMapping("_Widget","_treeview",SwigtreeviewToWidget);
	 SWIG_RegisterMapping("_Widget","_class_qdbt_tabular",Swigqdbt_tabularToWidget);
	 SWIG_RegisterMapping("_Widget","_qdbt_tabular",Swigqdbt_tabularToWidget);
	 SWIG_RegisterMapping("_Widget","_class_ScrollBar",SwigScrollBarToWidget);
	 SWIG_RegisterMapping("_Widget","_ScrollBar",SwigScrollBarToWidget);
	 SWIG_RegisterMapping("_Widget","_class_MultiLineEdit",SwigMultiLineEditToWidget);
	 SWIG_RegisterMapping("_Widget","_MultiLineEdit",SwigMultiLineEditToWidget);
	 SWIG_RegisterMapping("_Widget","_class_ListBox",SwigListBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_ListBox",SwigListBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_class_TableView",SwigTableViewToWidget);
	 SWIG_RegisterMapping("_Widget","_TableView",SwigTableViewToWidget);
	 SWIG_RegisterMapping("_Widget","_class_Label",SwigLabelToWidget);
	 SWIG_RegisterMapping("_Widget","_Label",SwigLabelToWidget);
	 SWIG_RegisterMapping("_Widget","_class_ButtonGroup",SwigButtonGroupToWidget);
	 SWIG_RegisterMapping("_Widget","_ButtonGroup",SwigButtonGroupToWidget);
	 SWIG_RegisterMapping("_Widget","_class_GroupBox",SwigGroupBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_GroupBox",SwigGroupBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_class_Frame",SwigFrameToWidget);
	 SWIG_RegisterMapping("_Widget","_Frame",SwigFrameToWidget);
	 SWIG_RegisterMapping("_Widget","_class_LineEdit",SwigLineEditToWidget);
	 SWIG_RegisterMapping("_Widget","_LineEdit",SwigLineEditToWidget);
	 SWIG_RegisterMapping("_Widget","_class_TabDialog",SwigTabDialogToWidget);
	 SWIG_RegisterMapping("_Widget","_TabDialog",SwigTabDialogToWidget);
	 SWIG_RegisterMapping("_Widget","_class_Dialog",SwigDialogToWidget);
	 SWIG_RegisterMapping("_Widget","_Dialog",SwigDialogToWidget);
	 SWIG_RegisterMapping("_Widget","_class_ComboBox",SwigComboBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_ComboBox",SwigComboBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_class_RadioButton",SwigRadioButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_RadioButton",SwigRadioButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_class_PushButton",SwigPushButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_PushButton",SwigPushButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_class_CheckBox",SwigCheckBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_CheckBox",SwigCheckBoxToWidget);
	 SWIG_RegisterMapping("_Widget","_class_Button",SwigButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_Button",SwigButtonToWidget);
	 SWIG_RegisterMapping("_Widget","_class_Widget",0);
	 SWIG_RegisterMapping("_TabDialog","_class_TabDialog",0);
	 SWIG_RegisterMapping("_QRect","_class_QRect",0);
	 SWIG_RegisterMapping("_class_Layout","_class_GridLayout",SwigGridLayoutToLayout);
	 SWIG_RegisterMapping("_class_Layout","_GridLayout",SwigGridLayoutToLayout);
	 SWIG_RegisterMapping("_class_Layout","_class_BoxLayout",SwigBoxLayoutToLayout);
	 SWIG_RegisterMapping("_class_Layout","_BoxLayout",SwigBoxLayoutToLayout);
	 SWIG_RegisterMapping("_class_Layout","_Layout",0);
	 SWIG_RegisterMapping("_class_QSize","_QSize",0);
	 SWIG_RegisterMapping("_class_Frame","_class_MultiLineEdit",SwigMultiLineEditToFrame);
	 SWIG_RegisterMapping("_class_Frame","_MultiLineEdit",SwigMultiLineEditToFrame);
	 SWIG_RegisterMapping("_class_Frame","_class_ListBox",SwigListBoxToFrame);
	 SWIG_RegisterMapping("_class_Frame","_ListBox",SwigListBoxToFrame);
	 SWIG_RegisterMapping("_class_Frame","_class_TableView",SwigTableViewToFrame);
	 SWIG_RegisterMapping("_class_Frame","_TableView",SwigTableViewToFrame);
	 SWIG_RegisterMapping("_class_Frame","_class_Label",SwigLabelToFrame);
	 SWIG_RegisterMapping("_class_Frame","_Label",SwigLabelToFrame);
	 SWIG_RegisterMapping("_class_Frame","_class_ButtonGroup",SwigButtonGroupToFrame);
	 SWIG_RegisterMapping("_class_Frame","_ButtonGroup",SwigButtonGroupToFrame);
	 SWIG_RegisterMapping("_class_Frame","_class_GroupBox",SwigGroupBoxToFrame);
	 SWIG_RegisterMapping("_class_Frame","_GroupBox",SwigGroupBoxToFrame);
	 SWIG_RegisterMapping("_class_Frame","_Frame",0);
	 SWIG_RegisterMapping("_class_QColorGroup","_QColorGroup",0);
	 SWIG_RegisterMapping("_unsigned_long","_long",0);
	 SWIG_RegisterMapping("_PopupMenu","_class_PopupMenu",0);
	 SWIG_RegisterMapping("_class_QListViewItem","_QListViewItem",0);
	 SWIG_RegisterMapping("_CheckBox","_class_CheckBox",0);
	 SWIG_RegisterMapping("_class_Widget","_class_ToolButton",SwigToolButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_ToolButton",SwigToolButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_ToolBar",SwigToolBarToWidget);
	 SWIG_RegisterMapping("_class_Widget","_ToolBar",SwigToolBarToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_mainwindow",SwigmainwindowToWidget);
	 SWIG_RegisterMapping("_class_Widget","_mainwindow",SwigmainwindowToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_splitter",SwigsplitterToWidget);
	 SWIG_RegisterMapping("_class_Widget","_splitter",SwigsplitterToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_treeview",SwigtreeviewToWidget);
	 SWIG_RegisterMapping("_class_Widget","_treeview",SwigtreeviewToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_qdbt_tabular",Swigqdbt_tabularToWidget);
	 SWIG_RegisterMapping("_class_Widget","_qdbt_tabular",Swigqdbt_tabularToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_ScrollBar",SwigScrollBarToWidget);
	 SWIG_RegisterMapping("_class_Widget","_ScrollBar",SwigScrollBarToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_MultiLineEdit",SwigMultiLineEditToWidget);
	 SWIG_RegisterMapping("_class_Widget","_MultiLineEdit",SwigMultiLineEditToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_ListBox",SwigListBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_ListBox",SwigListBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_TableView",SwigTableViewToWidget);
	 SWIG_RegisterMapping("_class_Widget","_TableView",SwigTableViewToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_Label",SwigLabelToWidget);
	 SWIG_RegisterMapping("_class_Widget","_Label",SwigLabelToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_ButtonGroup",SwigButtonGroupToWidget);
	 SWIG_RegisterMapping("_class_Widget","_ButtonGroup",SwigButtonGroupToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_GroupBox",SwigGroupBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_GroupBox",SwigGroupBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_Frame",SwigFrameToWidget);
	 SWIG_RegisterMapping("_class_Widget","_Frame",SwigFrameToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_LineEdit",SwigLineEditToWidget);
	 SWIG_RegisterMapping("_class_Widget","_LineEdit",SwigLineEditToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_TabDialog",SwigTabDialogToWidget);
	 SWIG_RegisterMapping("_class_Widget","_TabDialog",SwigTabDialogToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_Dialog",SwigDialogToWidget);
	 SWIG_RegisterMapping("_class_Widget","_Dialog",SwigDialogToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_ComboBox",SwigComboBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_ComboBox",SwigComboBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_RadioButton",SwigRadioButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_RadioButton",SwigRadioButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_PushButton",SwigPushButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_PushButton",SwigPushButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_CheckBox",SwigCheckBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_CheckBox",SwigCheckBoxToWidget);
	 SWIG_RegisterMapping("_class_Widget","_class_Button",SwigButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_Button",SwigButtonToWidget);
	 SWIG_RegisterMapping("_class_Widget","_Widget",0);
	 SWIG_RegisterMapping("_class_mainwindow","_mainwindow",0);
	 SWIG_RegisterMapping("_ToolBar","_class_ToolBar",0);
	 SWIG_RegisterMapping("_signed_int","_int",0);
	 SWIG_RegisterMapping("_QColor","_class_QColor",0);
	 SWIG_RegisterMapping("_class_TabDialog","_TabDialog",0);
	 SWIG_RegisterMapping("_qdbt_tabular","_class_qdbt_tabular",0);
	 SWIG_RegisterMapping("_class_Application","_Application",0);
	 SWIG_RegisterMapping("_QFont","_class_QFont",0);
	 SWIG_RegisterMapping("_QPaintDevice","_class_QBitmap",SwigQBitmapToQPaintDevice);
	 SWIG_RegisterMapping("_QPaintDevice","_QBitmap",SwigQBitmapToQPaintDevice);
	 SWIG_RegisterMapping("_QPaintDevice","_class_QPixmap",SwigQPixmapToQPaintDevice);
	 SWIG_RegisterMapping("_QPaintDevice","_QPixmap",SwigQPixmapToQPaintDevice);
	 SWIG_RegisterMapping("_QPaintDevice","_class_QPaintDevice",0);
	 SWIG_RegisterMapping("_RadioButton","_class_RadioButton",0);
	 SWIG_RegisterMapping("_LineEdit","_class_LineEdit",0);
	 SWIG_RegisterMapping("_class_MultiLineEdit","_MultiLineEdit",0);
	 SWIG_RegisterMapping("_unsigned_short","_short",0);
	 SWIG_RegisterMapping("_QCursor","_class_QCursor",0);
	 SWIG_RegisterMapping("_class_QPixmap","_class_QBitmap",SwigQBitmapToQPixmap);
	 SWIG_RegisterMapping("_class_QPixmap","_QBitmap",SwigQBitmapToQPixmap);
	 SWIG_RegisterMapping("_class_QPixmap","_QPixmap",0);
	 SWIG_RegisterMapping("_class_FileDialog","_FileDialog",0);
	 SWIG_RegisterMapping("_class_PopupMenu","_PopupMenu",0);
	 SWIG_RegisterMapping("_GroupBox","_class_ButtonGroup",SwigButtonGroupToGroupBox);
	 SWIG_RegisterMapping("_GroupBox","_ButtonGroup",SwigButtonGroupToGroupBox);
	 SWIG_RegisterMapping("_GroupBox","_class_GroupBox",0);
	 SWIG_RegisterMapping("_class_GridLayout","_GridLayout",0);
	 SWIG_RegisterMapping("_signed_short","_short",0);
	 SWIG_RegisterMapping("_PushButton","_class_PushButton",0);
	 SWIG_RegisterMapping("_class_splitter","_splitter",0);
	 SWIG_RegisterMapping("_class_QColor","_QColor",0);
	 SWIG_RegisterMapping("_class_qdbt_tabular","_qdbt_tabular",0);
	 SWIG_RegisterMapping("_treeview","_class_treeview",0);
	 SWIG_RegisterMapping("_Label","_class_Label",0);
	 SWIG_RegisterMapping("_MenuData","_class_MenuData",0);
	 SWIG_RegisterMapping("_ToolButton","_class_ToolButton",0);
	 SWIG_RegisterMapping("_unsigned_int","_int",0);
	 SWIG_RegisterMapping("_class_QPaintDevice","_class_QBitmap",SwigQBitmapToQPaintDevice);
	 SWIG_RegisterMapping("_class_QPaintDevice","_QBitmap",SwigQBitmapToQPaintDevice);
	 SWIG_RegisterMapping("_class_QPaintDevice","_class_QPixmap",SwigQPixmapToQPaintDevice);
	 SWIG_RegisterMapping("_class_QPaintDevice","_QPixmap",SwigQPixmapToQPaintDevice);
	 SWIG_RegisterMapping("_class_QPaintDevice","_QPaintDevice",0);
	 SWIG_RegisterMapping("_short","_unsigned_short",0);
	 SWIG_RegisterMapping("_short","_signed_short",0);
	 SWIG_RegisterMapping("_BoxLayout","_class_BoxLayout",0);
	 SWIG_RegisterMapping("_QMessageBox","_class_QMessageBox",0);
	 SWIG_RegisterMapping("_int","_unsigned_int",0);
	 SWIG_RegisterMapping("_int","_signed_int",0);
	 SWIG_RegisterMapping("_QFontMetrics","_class_QFontMetrics",0);
	 SWIG_RegisterMapping("_WhatsThis","_class_WhatsThis",0);
	 SWIG_RegisterMapping("_ComboBox","_class_ComboBox",0);
	 SWIG_RegisterMapping("_ListBox","_class_ListBox",0);
	 SWIG_RegisterMapping("_ScrollBar","_class_ScrollBar",0);
	 SWIG_RegisterMapping("_class_QPalette","_QPalette",0);
	 SWIG_RegisterMapping("_class_ButtonGroup","_ButtonGroup",0);
	 SWIG_RegisterMapping("_class_ToolBar","_ToolBar",0);
	 SWIG_RegisterMapping("_QBitmap","_class_QBitmap",0);
	 SWIG_RegisterMapping("_class_QCursor","_QCursor",0);
	 SWIG_RegisterMapping("_class_BoxLayout","_BoxLayout",0);
	 SWIG_RegisterMapping("_QSize","_class_QSize",0);
	 SWIG_RegisterMapping("_Frame","_class_MultiLineEdit",SwigMultiLineEditToFrame);
	 SWIG_RegisterMapping("_Frame","_MultiLineEdit",SwigMultiLineEditToFrame);
	 SWIG_RegisterMapping("_Frame","_class_ListBox",SwigListBoxToFrame);
	 SWIG_RegisterMapping("_Frame","_ListBox",SwigListBoxToFrame);
	 SWIG_RegisterMapping("_Frame","_class_TableView",SwigTableViewToFrame);
	 SWIG_RegisterMapping("_Frame","_TableView",SwigTableViewToFrame);
	 SWIG_RegisterMapping("_Frame","_class_Label",SwigLabelToFrame);
	 SWIG_RegisterMapping("_Frame","_Label",SwigLabelToFrame);
	 SWIG_RegisterMapping("_Frame","_class_ButtonGroup",SwigButtonGroupToFrame);
	 SWIG_RegisterMapping("_Frame","_ButtonGroup",SwigButtonGroupToFrame);
	 SWIG_RegisterMapping("_Frame","_class_GroupBox",SwigGroupBoxToFrame);
	 SWIG_RegisterMapping("_Frame","_GroupBox",SwigGroupBoxToFrame);
	 SWIG_RegisterMapping("_Frame","_class_Frame",0);
	 SWIG_RegisterMapping("_QColorGroup","_class_QColorGroup",0);
	 SWIG_RegisterMapping("_class_QMenuBar","_QMenuBar",0);
	 SWIG_RegisterMapping("_class_QFontMetrics","_QFontMetrics",0);
	 SWIG_RegisterMapping("_class_WhatsThis","_WhatsThis",0);
	 SWIG_RegisterMapping("_class_PushButton","_PushButton",0);
	 SWIG_RegisterMapping("_class_ScrollBar","_ScrollBar",0);
	 SWIG_RegisterMapping("_Application","_class_Application",0);
	 SWIG_RegisterMapping("_class_ToolButton","_ToolButton",0);
	 SWIG_RegisterMapping("_class_QRect","_QRect",0);
	 SWIG_RegisterMapping("_Object","_class_ToolButton",SwigToolButtonToObject);
	 SWIG_RegisterMapping("_Object","_ToolButton",SwigToolButtonToObject);
	 SWIG_RegisterMapping("_Object","_class_ToolBar",SwigToolBarToObject);
	 SWIG_RegisterMapping("_Object","_ToolBar",SwigToolBarToObject);
	 SWIG_RegisterMapping("_Object","_class_mainwindow",SwigmainwindowToObject);
	 SWIG_RegisterMapping("_Object","_mainwindow",SwigmainwindowToObject);
	 SWIG_RegisterMapping("_Object","_class_splitter",SwigsplitterToObject);
	 SWIG_RegisterMapping("_Object","_splitter",SwigsplitterToObject);
	 SWIG_RegisterMapping("_Object","_class_treeview",SwigtreeviewToObject);
	 SWIG_RegisterMapping("_Object","_treeview",SwigtreeviewToObject);
	 SWIG_RegisterMapping("_Object","_class_qdbt_tabular",Swigqdbt_tabularToObject);
	 SWIG_RegisterMapping("_Object","_qdbt_tabular",Swigqdbt_tabularToObject);
	 SWIG_RegisterMapping("_Object","_class_ScrollBar",SwigScrollBarToObject);
	 SWIG_RegisterMapping("_Object","_ScrollBar",SwigScrollBarToObject);
	 SWIG_RegisterMapping("_Object","_class_MultiLineEdit",SwigMultiLineEditToObject);
	 SWIG_RegisterMapping("_Object","_MultiLineEdit",SwigMultiLineEditToObject);
	 SWIG_RegisterMapping("_Object","_class_ListBox",SwigListBoxToObject);
	 SWIG_RegisterMapping("_Object","_ListBox",SwigListBoxToObject);
	 SWIG_RegisterMapping("_Object","_class_TableView",SwigTableViewToObject);
	 SWIG_RegisterMapping("_Object","_TableView",SwigTableViewToObject);
	 SWIG_RegisterMapping("_Object","_class_Label",SwigLabelToObject);
	 SWIG_RegisterMapping("_Object","_Label",SwigLabelToObject);
	 SWIG_RegisterMapping("_Object","_class_ButtonGroup",SwigButtonGroupToObject);
	 SWIG_RegisterMapping("_Object","_ButtonGroup",SwigButtonGroupToObject);
	 SWIG_RegisterMapping("_Object","_class_GroupBox",SwigGroupBoxToObject);
	 SWIG_RegisterMapping("_Object","_GroupBox",SwigGroupBoxToObject);
	 SWIG_RegisterMapping("_Object","_class_Frame",SwigFrameToObject);
	 SWIG_RegisterMapping("_Object","_Frame",SwigFrameToObject);
	 SWIG_RegisterMapping("_Object","_class_LineEdit",SwigLineEditToObject);
	 SWIG_RegisterMapping("_Object","_LineEdit",SwigLineEditToObject);
	 SWIG_RegisterMapping("_Object","_class_TabDialog",SwigTabDialogToObject);
	 SWIG_RegisterMapping("_Object","_TabDialog",SwigTabDialogToObject);
	 SWIG_RegisterMapping("_Object","_class_Dialog",SwigDialogToObject);
	 SWIG_RegisterMapping("_Object","_Dialog",SwigDialogToObject);
	 SWIG_RegisterMapping("_Object","_class_ComboBox",SwigComboBoxToObject);
	 SWIG_RegisterMapping("_Object","_ComboBox",SwigComboBoxToObject);
	 SWIG_RegisterMapping("_Object","_class_RadioButton",SwigRadioButtonToObject);
	 SWIG_RegisterMapping("_Object","_RadioButton",SwigRadioButtonToObject);
	 SWIG_RegisterMapping("_Object","_class_PushButton",SwigPushButtonToObject);
	 SWIG_RegisterMapping("_Object","_PushButton",SwigPushButtonToObject);
	 SWIG_RegisterMapping("_Object","_class_CheckBox",SwigCheckBoxToObject);
	 SWIG_RegisterMapping("_Object","_CheckBox",SwigCheckBoxToObject);
	 SWIG_RegisterMapping("_Object","_class_Button",SwigButtonToObject);
	 SWIG_RegisterMapping("_Object","_Button",SwigButtonToObject);
	 SWIG_RegisterMapping("_Object","_class_Widget",SwigWidgetToObject);
	 SWIG_RegisterMapping("_Object","_Widget",SwigWidgetToObject);
	 SWIG_RegisterMapping("_Object","_class_GridLayout",SwigGridLayoutToObject);
	 SWIG_RegisterMapping("_Object","_GridLayout",SwigGridLayoutToObject);
	 SWIG_RegisterMapping("_Object","_class_BoxLayout",SwigBoxLayoutToObject);
	 SWIG_RegisterMapping("_Object","_BoxLayout",SwigBoxLayoutToObject);
	 SWIG_RegisterMapping("_Object","_class_Layout",SwigLayoutToObject);
	 SWIG_RegisterMapping("_Object","_Layout",SwigLayoutToObject);
	 SWIG_RegisterMapping("_Object","_class_Application",SwigApplicationToObject);
	 SWIG_RegisterMapping("_Object","_Application",SwigApplicationToObject);
	 SWIG_RegisterMapping("_Object","_class_Object",0);
}
